############################################################################
#                                                                          #
#  Copyright (c) 2001, 2024 NoMachine, http://www.nomachine.com.           #
#                                                                          #
#  NXSERVER, NX protocol compression and NX extensions to this software    #
#  are copyright of NoMachine. Redistribution and use of the present       #
#  software is allowed according to terms specified in the file LICENSE    #
#  which comes in the source distribution.                                 #
#                                                                          #
#  Check http://www.nomachine.com/licensing.html for applicability.        #
#                                                                          #
#  NX and NoMachine are trademarks of NoMachine S.a.r.l.                   #
#                                                                          #
#  All rights reserved.                                                    #
#                                                                          #
############################################################################
sub NXClusterTools::generateClusterGUID{package NXClusterTools;no warnings;(my (
@command)=());push (@command,$GLOBAL::COMMAND_NXKEYGEN);push (@command,
"\x2d\x75");(my (@options)=());push (@options,"\x73\x65\x74\x20\x65\x6e\x76",(((
"\x4c\x44\x5f\x4c\x49\x42\x52\x41\x52\x59\x5f\x50\x41\x54\x48\x3d".
$GLOBAL::NODE_ROOT).$GLOBAL::DIRECTORY_SLASH)."\x6c\x69\x62"));push (@options,
"\x73\x65\x74\x20\x65\x6e\x76",("\x4e\x58\x5f\x53\x59\x53\x54\x45\x4d\x3d".
$GLOBAL::NODE_ROOT));push (@options,"\x73\x65\x74\x20\x65\x6e\x76",(
"\x48\x4f\x4d\x45\x3d".NXPaths::getUserNXHomeDir ()));(my ($cmdErr,$cmdOut,
$exitValue)=main::nxRunCommand ((\@command),(\@options)));if (($exitValue!=
(0x15d8+ 4234-0x2662))){Logger::warning (
"\x4e\x58\x43\x6c\x75\x73\x74\x65\x72\x54\x6f\x6f\x6c\x73\x3a\x20\x43\x61\x6e\x6e\x6f\x74\x20\x67\x65\x6e\x65\x72\x61\x74\x65\x20\x47\x55\x49\x44\x2e"
);return ((""));}chomp ($cmdOut);return ($cmdOut);}sub 
NXClusterTools::generateClusterKeys{package NXClusterTools;no warnings;(my (
@command)=());push (@command,$GLOBAL::COMMAND_NXKEYGEN);(my $priv=
NXPaths::getClusterRSAPrivateKey ());(my $pub=NXPaths::getClusterRSAPublicKey ()
);push (@command,"\x2d\x6b",$priv);push (@command,"\x2d\x70",$pub);push (
@command,"\x2d\x74","\x72\x73\x61");(my (@options)=());push (@options,
"\x73\x65\x74\x20\x65\x6e\x76",(((
"\x4c\x44\x5f\x4c\x49\x42\x52\x41\x52\x59\x5f\x50\x41\x54\x48\x3d".
$GLOBAL::NODE_ROOT).$GLOBAL::DIRECTORY_SLASH)."\x6c\x69\x62"));push (@options,
"\x73\x65\x74\x20\x65\x6e\x76",("\x4e\x58\x5f\x53\x59\x53\x54\x45\x4d\x3d".
$GLOBAL::NODE_ROOT));push (@options,"\x73\x65\x74\x20\x65\x6e\x76",(
"\x48\x4f\x4d\x45\x3d".NXPaths::getUserNXHomeDir ()));(my ($cmd_err,$cmd_out,
$exit_value)=main::nxRunCommand ((\@command),(\@options)));
changeFileOwnershipToNxIfRoot ($priv);changeFileOwnershipToNxIfRoot ($pub);if ((
Common::NXFile::setPermissionsReadWriteForNX ($priv)==(-(0x10d9+ 627-0x134b)))){
Logger::warning (((
"\x4e\x58\x43\x6c\x75\x73\x74\x65\x72\x54\x6f\x6f\x6c\x73\x3a\x20\x43\x61\x6e\x6e\x6f\x74\x20\x73\x65\x74\x20\x70\x65\x72\x6d\x69\x73\x73\x69\x6f\x6e\x73\x20\x74\x6f\x20\x27"
.$priv)."\x27\x2e"));}if ((
Common::NXFile::setPermissionReadWriteForOwnerReadOnlyForAll ($pub)==(-
(0x1ffb+   7-0x2001)))){Logger::warning (((
"\x4e\x58\x43\x6c\x75\x73\x74\x65\x72\x54\x6f\x6f\x6c\x73\x3a\x20\x43\x61\x6e\x6e\x6f\x74\x20\x73\x65\x74\x20\x70\x65\x72\x6d\x69\x73\x73\x69\x6f\x6e\x73\x20\x74\x6f\x20"
.$pub)."\x2e"));}}sub NXClusterTools::generateClusterHostCerts{package 
NXClusterTools;no warnings;(my (@command)=());push (@command,
$GLOBAL::COMMAND_NXKEYGEN);(my $priv=NXPaths::getClusterHostPrivateCert ());(my $pub
=NXPaths::getClusterHostPublicCert ());push (@command,"\x2d\x6b",$priv);push (
@command,"\x2d\x63",$pub);(my (@options)=());push (@options,
"\x73\x65\x74\x20\x65\x6e\x76",(((
"\x4c\x44\x5f\x4c\x49\x42\x52\x41\x52\x59\x5f\x50\x41\x54\x48\x3d".
$GLOBAL::NODE_ROOT).$GLOBAL::DIRECTORY_SLASH)."\x6c\x69\x62"));push (@options,
"\x73\x65\x74\x20\x65\x6e\x76",("\x4e\x58\x5f\x53\x59\x53\x54\x45\x4d\x3d".
$GLOBAL::NODE_ROOT));(my $homeDir=NXPaths::getUserNXHomeDir ());push (@options,
"\x73\x65\x74\x20\x65\x6e\x76",("\x48\x4f\x4d\x45\x3d".$homeDir));(my ($cmd_err,
$cmd_out,$exit_value)=main::nxRunCommand ((\@command),(\@options)));
changeFileOwnershipToNxIfRoot ($priv);changeFileOwnershipToNxIfRoot ($pub);if ((
Common::NXFile::setPermissionsReadWriteForNX ($priv)==(-(0x22da+  12-0x22e5)))){
Logger::error (((
"\x43\x61\x6e\x6e\x6f\x74\x20\x73\x65\x74\x20\x70\x65\x72\x6d\x69\x73\x73\x69\x6f\x6e\x73\x20\x74\x6f\x20"
.$priv)."\x2e"));}if ((
Common::NXFile::setPermissionReadWriteForOwnerReadOnlyForAll ($pub)==(-
(0x0f08+ 4032-0x1ec7)))){Logger::error (((
"\x43\x61\x6e\x6e\x6f\x74\x20\x73\x65\x74\x20\x70\x65\x72\x6d\x69\x73\x73\x69\x6f\x6e\x73\x20\x74\x6f\x20"
.$pub)."\x2e"));}}sub NXClusterTools::cleanInterface{package NXClusterTools;no 
warnings;(my $interface=$GLOBAL::ClusterInterface);(my $clusterHost=
$GLOBAL::ClusterHost);(my $mask=$GLOBAL::ClusterNetmask);if ((
$GLOBAL::ScriptClusterClearSharedIP ne (""))){main::nxrequire (
"\x4e\x58\x53\x63\x72\x69\x70\x74\x73");return (NXScripts::runScript (
"\x73\x63\x72\x69\x70\x74\x5f\x63\x6c\x75\x73\x74\x65\x72\x5f\x63\x6c\x65\x61\x72\x5f\x73\x68\x61\x72\x65\x64\x5f\x69\x70"
,$interface,$clusterHost,$mask));}(my (%interfaces)=getInterfaces ());if ((
$interfaces{$interface}eq (""))){Logger::debug (((
"\x4e\x58\x43\x6c\x75\x73\x74\x65\x72\x3a\x20\x49\x6e\x74\x65\x72\x66\x61\x63\x65\x20\x27"
.$interface).
"\x27\x20\x61\x6c\x72\x65\x61\x64\x79\x20\x63\x6c\x65\x61\x6e\x20\x75\x70\x2e"))
;(($interface,$clusterHost)=__readInterfaceFromFile ());if (($interfaces{
$interface}eq (""))){Logger::debug (((
"\x4e\x58\x43\x6c\x75\x73\x74\x65\x72\x3a\x20\x49\x6e\x74\x65\x72\x66\x61\x63\x65\x20\x27"
.$interface).
"\x27\x20\x66\x72\x6f\x6d\x20\x66\x69\x6c\x65\x20\x61\x6c\x72\x65\x61\x64\x79\x20\x63\x6c\x65\x61\x6e\x20\x75\x70\x2e"
));return ((0x0d79+ 4661-0x1fae));}}Logger::debug (((((
"\x4e\x58\x43\x6c\x75\x73\x74\x65\x72\x3a\x20\x43\x6c\x65\x61\x6e\x20\x75\x70\x20\x69\x6e\x74\x65\x72\x66\x61\x63\x65\x20\x27"
.$interface)."\x27\x20\x68\x6f\x73\x74\x20\x27").$clusterHost)."\x27\x2e"));(my (
@command)=());sub BEGIN{require NXTools;do{"\x4e\x58\x54\x6f\x6f\x6c\x73"->
import};}if ((not (($interface=~ /(.*):(\d+)/ )))){if ((not (
NXMsg::isMessageRegistered (
"\x65\x43\x4d\x44\x43\x6c\x75\x73\x74\x65\x72\x49\x6e\x76\x61\x6c\x69\x64\x49\x6e\x74\x65\x72\x66\x61\x63\x65"
)))){NXMsg::register_error (
"\x4e\x58\x43\x6c\x75\x73\x74\x65\x72\x54\x6f\x6f\x6c\x73",
"\x65\x43\x4d\x44\x43\x6c\x75\x73\x74\x65\x72\x49\x6e\x76\x61\x6c\x69\x64\x49\x6e\x74\x65\x72\x66\x61\x63\x65"
,$GLOBAL::MSG_ERROR);}Common::NXMsg::error (
"\x65\x43\x4d\x44\x43\x6c\x75\x73\x74\x65\x72\x49\x6e\x76\x61\x6c\x69\x64\x49\x6e\x74\x65\x72\x66\x61\x63\x65"
,$interface);return ((0x1638+ 3349-0x234c));}(my $device=$1);if ((
$GLOBAL::ForceClusterIfconfig eq "\x31")){push (@command,
NXTools::getUnixCommandPath ("\x69\x66\x63\x6f\x6e\x66\x69\x67"));push (@command
,$interface);push (@command,"\x64\x6f\x77\x6e");}else{push (@command,
NXTools::getUnixCommandPath ("\x69\x70"));push (@command,
"\x61\x64\x64\x72\x65\x73\x73","\x64\x65\x6c\x65\x74\x65");push (@command,((
$clusterHost."\x2f").$mask));push (@command,"\x64\x65\x76",$device);push (
@command,"\x6c\x61\x62\x65\x6c",$interface);}(my (@options)=());(my ($cmdOut,
$cmdErr,$exitValue)=main::nxRunCommand ((\@command),(\@options)));Logger::debug 
((((((("\x43\x6f\x6d\x6d\x61\x6e\x64\x20\x6f\x75\x74\x70\x75\x74\x20\x27".
$cmdOut)."\x27\x20\x27").$cmdErr).
"\x27\x20\x65\x78\x69\x74\x20\x63\x6f\x64\x65\x20\x27").$exitValue)."\x27\x2e"))
;if (($exitValue!=(0x162a+ 1699-0x1ccd))){Logger::error (((((((((
"\x46\x61\x69\x6c\x65\x64\x20\x74\x6f\x20\x64\x65\x6c\x65\x74\x65\x20\x63\x6c\x75\x73\x74\x65\x72\x20\x69\x6e\x74\x65\x72\x66\x61\x63\x65\x20\x27"
.$interface)."\x27\x2e\x20\x45\x72\x72\x6f\x72\x20\x69\x73\x20\x27").$exitValue)
."\x27\x2e\x20\x27").$cmdOut)."\x27\x20\x27").$cmdErr)."\x27\x2e"));}
removeInterfaceFile ();return ($exitValue);}sub 
NXClusterTools::saveInterfaceToFile{package NXClusterTools;no warnings;(my $interface
=shift (@_));(my $clusterHost=shift (@_));(my $filename=
NXPaths::getClusterInterfaceFile ());(my $fileExisted=(0x18cf+ 1175-0x1d66));if 
(Common::NXFile::fileExists ($filename)){($fileExisted=(0x08bd+ 5480-0x1e24));}(my $FH
=main::nxopen ($filename,($NXBits::O_RDWR+$NXBits::O_CREAT),((
$NXBits::OthersRead+$NXBits::UserReadWrite)+$NXBits::GroupRead)));if ((not (
defined ($FH)))){(my $errorNumber=libnxh::NXGetError ());(my $errorstring=
libnxh::NXGetErrorString ());Logger::error (((
"\x43\x61\x6e\x6e\x6f\x74\x20\x6f\x70\x65\x6e\x20\x66\x69\x6c\x65\x20".$filename
)."\x20\x66\x6f\x72\x20\x77\x72\x69\x74\x69\x6e\x67\x2e"));Logger::error (((((
"\x45\x72\x72\x6f\x72\x20\x69\x73\x20".$errorNumber)."\x2c\x20").$errorstring).
"\x2e"));return ((0x10b7+ 1448-0x165e));}if ((main::nxwrite ($FH,((($interface.
"\x0a").$clusterHost)."\x0a"))==(-(0x0e41+ 4222-0x1ebe)))){Logger::error (((
"\x43\x61\x6e\x6e\x6f\x74\x20\x77\x72\x69\x74\x65\x20\x74\x6f\x20\x66\x69\x6c\x65\x20\x27"
.$filename)."\x27\x2e"));main::nxclose ($FH);if ((not ($fileExisted))){
changeFileOwnershipToNxIfRoot ($filename);}return ((0x1c08+ 960-0x1fc7));}
main::nxclose ($FH);if ((not ($fileExisted))){changeFileOwnershipToNxIfRoot (
$filename);}return ((0x019d+ 1667-0x0820));}sub 
NXClusterTools::removeInterfaceFile{package NXClusterTools;no warnings;(my $filename
=NXPaths::getClusterInterfaceFile ());if (Common::NXFile::isExists ($filename)){
Common::NXFile::removeFile ($filename);}}sub 
NXClusterTools::doesInterfaceFileExist{package NXClusterTools;no warnings;(my $filename
=NXPaths::getClusterInterfaceFile ());if (Common::NXFile::fileExists ($filename)
){Logger::debug (((
"\x4e\x58\x43\x6c\x75\x73\x74\x65\x72\x54\x6f\x6f\x6c\x73\x3a\x20\x46\x69\x6c\x65\x20\x27"
.$filename)."\x27\x20\x65\x78\x69\x73\x74\x73\x2e"));return (
(0x1a28+ 2459-0x23c2));}Logger::debug (((
"\x4e\x58\x43\x6c\x75\x73\x74\x65\x72\x54\x6f\x6f\x6c\x73\x3a\x20\x46\x69\x6c\x65\x20\x27"
.$filename).
"\x27\x20\x64\x6f\x65\x73\x20\x6e\x6f\x74\x20\x65\x78\x69\x73\x74\x2e"));return 
((0x073d+ 4961-0x1a9e));}sub NXClusterTools::__readInterfaceFromFile{package 
NXClusterTools;no warnings;if ((not (doesInterfaceFileExist ()))){return ((""),
(""));}(my $filename=NXPaths::getClusterInterfaceFile ());(my $FH=main::nxopen (
$filename,$NXBits::O_RDONLY,(0x0e52+ 5391-0x2361)));if ((not (defined ($FH)))){(my $errorNumber
=libnxh::NXGetError ());(my $errorstring=libnxh::NXGetErrorString ());
Logger::error (((
"\x43\x61\x6e\x6e\x6f\x74\x20\x6f\x70\x65\x6e\x20\x66\x69\x6c\x65\x20\x27".
$filename)."\x27\x20\x66\x6f\x72\x20\x72\x65\x61\x64\x69\x6e\x67\x2e"));
Logger::error ((((("\x45\x72\x72\x6f\x72\x20\x69\x73\x3a\x20".$errorNumber).
"\x2c\x20").$errorstring)."\x2e"));return ((""),(""));}my ($interface);my (
$clusterHost);main::nxreadLine ($FH,(\$interface));main::nxreadLine ($FH,(
\$clusterHost));main::nxclose ($FH);chomp ($interface);chomp ($clusterHost);
return ($interface,$clusterHost);}sub NXClusterTools::getInterfaces{package 
NXClusterTools;no warnings;(my (%interfaces)=());Logger::debug (
"\x6c\x69\x62\x6e\x78\x68\x3a\x3a\x4e\x58\x47\x65\x74\x4e\x65\x74\x77\x6f\x72\x6b\x49\x6e\x74\x65\x72\x66\x61\x63\x65\x73"
);(my $return=libnxh::NXGetNetworkInterfaces ());Logger::debug (((
"\x6c\x69\x62\x6e\x78\x68\x3a\x3a\x4e\x58\x47\x65\x74\x4e\x65\x74\x77\x6f\x72\x6b\x49\x6e\x74\x65\x72\x66\x61\x63\x65\x73\x20\x72\x65\x74\x75\x72\x6e\x73\x20\x27"
.$return)."\x27\x2e"));(my (@lines)=split ( /\n/ ,$return,(0x15a3+ 3924-0x24f7))
);foreach my $line (@lines){if (($line=~ /(^[\w:\d]+)\s+AF_INET\s+([0-9A-Fa-f]{2}[:-]){5}([0-9A-Fa-f]{2})+\s+(\d+\.\d+\.\d+\.\d+)\s+(\d+\.\d+\.\d+\.\d+)/ )
){Logger::debug ((((((("\x49\x6e\x74\x65\x72\x66\x61\x63\x65\x20\x27".$1).
"\x27\x2c\x20\x49\x50\x20\x27").$4)."\x27\x20\x6d\x61\x73\x6b\x20\x27").$5).
"\x27\x2e"));($interfaces{$1}={"\x69\x70",$4,"\x6d\x61\x73\x6b",$5});}}return (
%interfaces);}sub NXClusterTools::getIPs{package NXClusterTools;no warnings;
Logger::debug (
"\x6c\x69\x62\x6e\x78\x68\x3a\x3a\x4e\x58\x47\x65\x74\x4e\x65\x74\x77\x6f\x72\x6b\x49\x6e\x74\x65\x72\x66\x61\x63\x65\x73"
);(my $return=libnxh::NXGetNetworkInterfaces ());Logger::debug (((
"\x6c\x69\x62\x6e\x78\x68\x3a\x3a\x4e\x58\x47\x65\x74\x4e\x65\x74\x77\x6f\x72\x6b\x49\x6e\x74\x65\x72\x66\x61\x63\x65\x73\x20\x72\x65\x74\x75\x72\x6e\x73\x20\x27"
.$return)."\x27\x2e"));(my (%IPs)=());(my (@lines)=split ( /\n/ ,$return,
(0x00dc+ 285-0x01f9)));foreach my $line (@lines){if (($line=~ /(^[\w:\d]+)\s+AF_INET\s+([0-9A-Fa-f]{2}[:-]){5}([0-9A-Fa-f]{2})+\s+(\d+\.\d+\.\d+\.\d+)\s+(\d+\.\d+\.\d+\.\d+)/ )
){(my $iface=$1);(my $ip=$4);(my $mask=$5);Logger::debug (((((((
"\x4e\x58\x43\x6c\x75\x73\x74\x65\x72\x54\x6f\x6f\x6c\x73\x3a\x20\x69\x6e\x74\x65\x72\x66\x61\x63\x65\x20\x27"
.$iface)."\x27\x20\x49\x50\x20\x27").$ip)."\x27\x20\x6d\x61\x73\x6b\x20\x27").
$mask)."\x27\x2e"));($IPs{$ip}={"\x69\x6e\x74\x65\x72\x66\x61\x63\x65",$iface,
"\x6d\x61\x73\x6b",$mask});}}return (%IPs);}sub NXClusterTools::isIPExists{
package NXClusterTools;no warnings;(my $IP=shift (@_));Logger::debug (((
"\x4e\x58\x43\x6c\x75\x73\x74\x65\x72\x54\x6f\x6f\x6c\x73\x3a\x20\x53\x65\x61\x72\x63\x68\x20\x49\x50\x20\x27"
.$IP).
"\x27\x20\x6f\x6e\x20\x69\x6e\x74\x65\x72\x66\x61\x63\x65\x20\x6c\x69\x73\x74\x2e"
));(my (%interfaces)=getInterfaces ());foreach my $name (keys (%interfaces)){if 
(($interfaces{$name}{"\x69\x70"}eq $ip)){Logger::debug (((((
"\x4e\x58\x43\x6c\x75\x73\x74\x65\x72\x54\x6f\x6f\x6c\x73\x3a\x20\x46\x6f\x75\x6e\x64\x20\x49\x50\x20\x27"
.$IP)."\x27\x20\x6f\x6e\x20\x69\x6e\x74\x65\x72\x66\x61\x63\x65\x20\x27").$name)
."\x27\x2e"));return ((0x07ac+ 1306-0x0cc5));}}Logger::debug (((
"\x4e\x58\x43\x6c\x75\x73\x74\x65\x72\x54\x6f\x6f\x6c\x73\x3a\x20\x43\x61\x6e\x6e\x6f\x74\x20\x66\x6f\x75\x6e\x64\x20\x49\x50\x20\x27"
.$IP)."\x27\x2e"));return ((0x1217+ 4868-0x251b));}sub 
NXClusterTools::getClusterPublicKey{package NXClusterTools;no warnings;(my $file
=NXPaths::getClusterRSAPublicKey ());if ((not (Common::NXFile::fileExists ($file
)))){generateClusterKeys ();}(my $content=Common::NXFile::getFileContent ($file)
);if (($content eq (""))){(my $message=((
"\x43\x61\x6e\x6e\x6f\x74\x20\x72\x65\x74\x72\x69\x65\x76\x65\x20\x63\x6c\x75\x73\x74\x65\x72\x20\x70\x75\x6c\x69\x63\x20\x6b\x65\x79\x20\x66\x72\x6f\x6d\x20\x70\x61\x74\x68\x20\x27"
.$file)."\x27"));Logger::error ($message);die ($message);}return ($content);}sub
 NXClusterTools::__setDatabaseBackup{package NXClusterTools;no warnings;(my $database
=shift (@_));(my $content=shift (@_));if (__isDatabaseBackupExist ($database)){
Logger::debug (((
"\x4e\x58\x43\x6c\x75\x73\x74\x65\x72\x54\x6f\x6f\x6c\x73\x3a\x20\x44\x61\x74\x61\x62\x61\x73\x65\x20\x62\x61\x63\x6b\x75\x70\x20\x27"
.$database).
"\x27\x20\x61\x6c\x72\x65\x61\x64\x79\x20\x65\x78\x69\x73\x74\x73\x2e"));return 
((0x01e1+ 1816-0x08f9));}if (($content eq (""))){Logger::debug (((
"\x4e\x58\x43\x6c\x75\x73\x74\x65\x72\x54\x6f\x6f\x6c\x73\x3a\x20\x44\x61\x74\x61\x62\x61\x73\x65\x20\x62\x61\x63\x6b\x75\x70\x20\x27"
.$database)."\x27\x20\x69\x73\x20\x65\x6d\x70\x74\x79\x2e"));return (
(0x0953+ 4771-0x1bf6));}($content=main::urlencode ($content));NXRedis::sendToDb 
(((((
"\x63\x6f\x6d\x6d\x61\x6e\x64\x3d\x73\x65\x74\x6e\x78\x2c\x73\x65\x72\x76\x69\x63\x65\x3d\x64\x62\x2c\x6b\x65\x79\x3d\x62\x61\x63\x6b\x75\x70\x2e"
.$database)."\x2c\x76\x61\x6c\x75\x65\x3d").$content)."\x0a"));}sub 
NXClusterTools::getNodesDB{package NXClusterTools;no warnings;main::nxrequire (
"\x4e\x58\x4e\x6f\x64\x65\x73");return (NXNodes::getDatabaseInString ());}sub 
NXClusterTools::getClusterDB{package NXClusterTools;no warnings;return (
getDatabaseInString ());}sub NXClusterTools::getProfilesDB{package 
NXClusterTools;no warnings;main::nxrequire (
"\x4e\x58\x50\x72\x6f\x66\x69\x6c\x65\x73\x44\x42");return (
NXProfilesDB::getDatabaseInString ());}sub NXClusterTools::getUsersDB{package 
NXClusterTools;no warnings;main::nxrequire (
"\x4e\x58\x55\x73\x65\x72\x73\x4d\x61\x6e\x61\x67\x65\x72");return (
NXUsersManager::getDatabaseInString ());}sub NXClusterTools::getAdministratorsDB
{package NXClusterTools;no warnings;main::nxrequire (
"\x4e\x58\x41\x64\x6d\x69\x6e\x69\x73\x74\x72\x61\x74\x6f\x72\x73\x4d\x61\x6e\x61\x67\x65\x72"
);return (NXAdministratorsManager::getDatabaseInString ());}sub 
NXClusterTools::getGroupsDB{package NXClusterTools;no warnings;main::nxrequire (
"\x4e\x58\x47\x72\x6f\x75\x70\x73");return (NXGroups::getDatabaseInString ());}
sub NXClusterTools::getNodeGroupsDB{package NXClusterTools;no warnings;
main::nxrequire ("\x4e\x58\x4e\x6f\x64\x65\x47\x72\x6f\x75\x70\x73",
"\x69\x6e\x69\x74");return (NXNodeGroups::getDatabaseInString ());}sub 
NXClusterTools::getServerGroupsDB{package NXClusterTools;no warnings;
main::nxrequire ("\x4e\x58\x53\x65\x72\x76\x65\x72\x47\x72\x6f\x75\x70\x73",
"\x69\x6e\x69\x74");return (NXServerGroups::getDatabaseInString ());}sub 
NXClusterTools::getNXCerts{package NXClusterTools;no warnings;main::nxrequire (
"\x4e\x58\x53\x65\x72\x76\x65\x72\x73");return (NXServers::getNXCertsString ());
}sub NXClusterTools::getSSHCerts{package NXClusterTools;no warnings;
main::nxrequire ("\x4e\x58\x53\x65\x72\x76\x65\x72\x73");return (
NXServers::getSSHCertsString ());}sub NXClusterTools::getNetworkDB{package 
NXClusterTools;no warnings;return (Common::NXFile::getFileContent (
NXPaths::getNetworkDB ()));}sub NXClusterTools::getNetworkFile{package 
NXClusterTools;no warnings;return (Common::NXFile::getFileContent (
NXPaths::getNetworkFile ()));}sub NXClusterTools::getServerDSAPublicKey{package 
NXClusterTools;no warnings;(my $file=NXPaths::getServerDSAPublicKey ());if ((not
 (Common::NXFile::fileExists ($file)))){return ((""));}return (
Common::NXFile::getFileContent ($file));}sub 
NXClusterTools::getServerDSAPrivateKey{package NXClusterTools;no warnings;(my $file
=NXPaths::getServerDSAPrivateKey ());if ((not (Common::NXFile::fileExists ($file
)))){return ((""));}return (Common::NXFile::getFileContent ($file));}sub 
NXClusterTools::getServerRSAPublicKey{package NXClusterTools;no warnings;(my $file
=NXPaths::getServerRSAPublicKey ());if ((not (Common::NXFile::fileExists ($file)
))){return ((""));}return (Common::NXFile::getFileContent ($file));}sub 
NXClusterTools::getServerRSAPrivateKey{package NXClusterTools;no warnings;(my $file
=NXPaths::getServerRSAPrivateKey ());if ((not (Common::NXFile::fileExists ($file
)))){return ((""));}return (Common::NXFile::getFileContent ($file));}sub 
NXClusterTools::getPlayerCerts{package NXClusterTools;no warnings;(my $file=
NXPaths::getUserNXKnownCerts ());(my $content=Common::NXFile::getFileContent (
$file));return ($content);}sub NXClusterTools::getClusterMasterCertPub{package 
NXClusterTools;no warnings;(my $file=NXPaths::getClusterHostPublicCert ());if ((
not (Common::NXFile::fileExists ($file)))){generateClusterHostCerts ();}(my $content
=Common::NXFile::getFileContent ($file));if (($content eq (""))){(my $message=(
"\x43\x61\x6e\x6e\x6f\x74\x20\x72\x65\x74\x72\x69\x65\x76\x65\x20\x66\x69\x6c\x65\x3a\x20"
.$file));Logger::error ($message);die ($message);}return ($content);}sub 
NXClusterTools::getClusterMasterCertPriv{package NXClusterTools;no warnings;(my $file
=NXPaths::getClusterHostPrivateCert ());if ((not (Common::NXFile::fileExists (
$file)))){generateClusterHostCerts ();}(my $content=
Common::NXFile::getFileContent ($file));if (($content eq (""))){(my $message=(
"\x43\x61\x6e\x6e\x6f\x74\x20\x72\x65\x74\x72\x69\x65\x76\x65\x20\x66\x69\x6c\x65\x3a\x20"
.$file));Logger::error ($message);die ($message);}return ($content);}sub 
NXClusterTools::getHttpHostPrivateCert{package NXClusterTools;no warnings;(my $file
=NXPaths::getHttpHostPrivateCert ());(my $content=Common::NXFile::getFileContent
 ($file));if (($content eq (""))){(my $message=(
"\x43\x61\x6e\x6e\x6f\x74\x20\x72\x65\x74\x72\x69\x65\x76\x65\x20\x66\x69\x6c\x65\x3a\x20"
.$file));Logger::error ($message);die ($message);}return ($content);}sub 
NXClusterTools::getHttpHostPublicCert{package NXClusterTools;no warnings;(my $file
=NXPaths::getHttpHostPublicCert ());(my $content=Common::NXFile::getFileContent 
($file));if (($content eq (""))){(my $message=(
"\x43\x61\x6e\x6e\x6f\x74\x20\x72\x65\x74\x72\x69\x65\x76\x65\x20\x66\x69\x6c\x65\x3a\x20"
.$file));Logger::error ($message);die ($message);}return ($content);}sub 
NXClusterTools::getClusterHttpMasterCertPub{package NXClusterTools;no warnings;(my $file
=NXPaths::getClusterHttpHostPublicCert ());(my $content=
Common::NXFile::getFileContent ($file));if (($content eq (""))){(my $message=(
"\x43\x61\x6e\x6e\x6f\x74\x20\x72\x65\x74\x72\x69\x65\x76\x65\x20\x66\x69\x6c\x65\x3a\x20"
.$file));Logger::error ($message);die ($message);}return ($content);}sub 
NXClusterTools::getSSHHostKeyDSAPrivate{package NXClusterTools;no warnings;(my $file
=NXPaths::getSSHHostKeyDSAPrivate ());(my $content=
Common::NXFile::getFileContent ($file));return ($content);}sub 
NXClusterTools::getSSHHostKeyDSAPublic{package NXClusterTools;no warnings;(my $file
=NXPaths::getSSHHostKeyDSAPublic ());(my $content=Common::NXFile::getFileContent
 ($file));return ($content);}sub NXClusterTools::getSSHHostKeyRSAPrivate{package
 NXClusterTools;no warnings;(my $file=NXPaths::getSSHHostKeyRSAPrivate ());(my $content
=Common::NXFile::getFileContent ($file));return ($content);}sub 
NXClusterTools::getSSHHostKeyRSAPublic{package NXClusterTools;no warnings;(my $file
=NXPaths::getSSHHostKeyRSAPublic ());(my $content=Common::NXFile::getFileContent
 ($file));return ($content);}sub NXClusterTools::getSSHHostKeyECDSAPrivate{
package NXClusterTools;no warnings;(my $file=NXPaths::getSSHHostKeyECDSAPrivate 
());(my $content=Common::NXFile::getFileContent ($file));return ($content);}sub 
NXClusterTools::getSSHHostKeyECDSAPublic{package NXClusterTools;no warnings;(my $file
=NXPaths::getSSHHostKeyECDSAPublic ());(my $content=
Common::NXFile::getFileContent ($file));return ($content);}sub 
NXClusterTools::getSSHHostKeyED25519Private{package NXClusterTools;no warnings;(my $file
=NXPaths::getSSHHostKeyED25519Private ());(my $content=
Common::NXFile::getFileContent ($file));return ($content);}sub 
NXClusterTools::getSSHHostKeyED25519Public{package NXClusterTools;no warnings;(my $file
=NXPaths::getSSHHostKeyED25519Public ());(my $content=
Common::NXFile::getFileContent ($file));return ($content);}sub 
NXClusterTools::getUserKnownHostsSSH{package NXClusterTools;no warnings;return (
Common::NXFile::getFileContent (NXPaths::getUserKnownHostsSSH ()));}sub 
NXClusterTools::__unsync{package NXClusterTools;no warnings;(my $file=shift (@_)
);(my $owner=shift (@_));(my $emptyFile=($file."\x2e\x65\x6d\x70\x74\x79"));if (
Common::NXFile::fileExists ($emptyFile)){__remove ($emptyFile);__remove ($file);
return ((0x0556+ 5247-0x19d5));}(my $fileBackup=($file.
"\x2e\x62\x61\x63\x6b\x75\x70"));if (Common::NXFile::fileExists ($fileBackup)){
Logger::debug ((((("\x52\x65\x6e\x61\x6d\x65\x20\x27".$fileBackup).
"\x27\x20\x74\x6f\x20\x27").$file)."\x27\x2e"));unless (rename ($fileBackup,
$file)){Logger::error ((((((
"\x43\x61\x6e\x6e\x6f\x74\x20\x72\x65\x6e\x61\x6d\x65\x20\x66\x69\x6c\x65\x20\x27"
.$fileBackup)."\x27\x20\x74\x6f\x20\x27").$file)."\x27\x2e\x20").$!));return (
(0x0e49+ 2116-0x168c));}if (($owner ne "\x72\x6f\x6f\x74")){
changeFileOwnershipToNxIfRoot ($file);}}return ((0x0fc8+ 5381-0x24cd));}sub 
NXClusterTools::__unsyncDatabases{package NXClusterTools;no warnings;
Logger::debug (
"\x4e\x58\x43\x6c\x75\x73\x74\x65\x72\x54\x6f\x6f\x6c\x73\x3a\x20\x64\x65\x73\x79\x6e\x63\x68\x72\x6f\x6e\x69\x7a\x65\x20\x64\x61\x74\x61\x62\x61\x73\x65\x73\x2e"
);if (__isDatabaseBackupExist ("\x6e\x6f\x64\x65\x73")){main::nxrequire (
"\x4e\x58\x4e\x6f\x64\x65\x73");NXNodes::cleanDb ();NXNodes::setDatabaseByString
 (__getDatabaseBackup ("\x6e\x6f\x64\x65\x73"));}if (__isDatabaseBackupExist (
"\x70\x72\x6f\x66\x69\x6c\x65\x73")){main::nxrequire (
"\x4e\x58\x50\x72\x6f\x66\x69\x6c\x65\x73\x44\x42");NXProfilesDB::cleanDb ();
NXProfilesDB::setDatabaseByString (__getDatabaseBackup (
"\x70\x72\x6f\x66\x69\x6c\x65\x73"));}main::nxrequire (
"\x4e\x58\x4e\x6f\x64\x65\x47\x72\x6f\x75\x70\x73");NXNodeGroups::cleanDb ();
NXRemoteMachinesGroups::cleanLoadedGroups ();if (__isDatabaseBackupExist (
"\x6e\x6f\x64\x65\x67\x72\x6f\x75\x70\x73")){NXNodeGroups::setDatabaseByString (
__getDatabaseBackup ("\x6e\x6f\x64\x65\x67\x72\x6f\x75\x70\x73"));}
main::nxrequire ("\x4e\x58\x53\x65\x72\x76\x65\x72\x47\x72\x6f\x75\x70\x73");
NXServerGroups::cleanDb ();NXRemoteMachinesGroups::cleanLoadedGroups ();if (
__isDatabaseBackupExist ("\x73\x65\x72\x76\x65\x72\x67\x72\x6f\x75\x70\x73")){
NXServerGroups::setDatabaseByString (__getDatabaseBackup (
"\x73\x65\x72\x76\x65\x72\x67\x72\x6f\x75\x70\x73"));}if (
__isDatabaseBackupExist ("\x75\x73\x65\x72\x73")){main::nxrequire (
"\x4e\x58\x55\x73\x65\x72\x73\x4d\x61\x6e\x61\x67\x65\x72");
NXUsersManager::cleanDb ();NXUsersManager::setDatabaseByString (
__getDatabaseBackup ("\x75\x73\x65\x72\x73"));}if (__isDatabaseBackupExist (
"\x61\x64\x6d\x69\x6e\x69\x73\x74\x72\x61\x74\x6f\x72\x73")){main::nxrequire (
"\x4e\x58\x41\x64\x6d\x69\x6e\x69\x73\x74\x72\x61\x74\x6f\x72\x73\x4d\x61\x6e\x61\x67\x65\x72"
);NXAdministratorsManager::cleanDb ();
NXAdministratorsManager::setDatabaseByString (__getDatabaseBackup (
"\x61\x64\x6d\x69\x6e\x69\x73\x74\x72\x61\x74\x6f\x72\x73"));}if (
__isDatabaseBackupExist ("\x63\x65\x72\x74\x73\x4e\x58")){main::nxrequire (
"\x4e\x58\x53\x65\x72\x76\x65\x72\x73");NXServers::setNXCertsByString (undef,
__getDatabaseBackup ("\x63\x65\x72\x74\x73\x4e\x58"));}if (
__isDatabaseBackupExist ("\x63\x65\x72\x74\x73\x53\x53\x48")){main::nxrequire (
"\x4e\x58\x53\x65\x72\x76\x65\x72\x73");NXServers::setSSHCertsByString (undef,
__getDatabaseBackup ("\x63\x65\x72\x74\x73\x53\x53\x48"));}if (
__isDatabaseBackupExist ("\x67\x72\x6f\x75\x70\x73")){main::nxrequire (
"\x4e\x58\x47\x72\x6f\x75\x70\x73");NXGroups::cleanDb ();
NXGroups::setDatabaseByString (__getDatabaseBackup ("\x67\x72\x6f\x75\x70\x73"))
;}}sub NXClusterTools::__isDatabaseBackupExist{package NXClusterTools;no 
warnings;(my $database=shift (@_));NXRedis::sendToDb (((
"\x63\x6f\x6d\x6d\x61\x6e\x64\x3d\x65\x78\x69\x73\x74\x73\x2c\x73\x65\x72\x76\x69\x63\x65\x3d\x64\x62\x2c\x6b\x65\x79\x3d\x62\x61\x63\x6b\x75\x70\x2e"
.$database)."\x0a"));return (NXRedis::get ());}sub 
NXClusterTools::__getDatabaseBackup{package NXClusterTools;no warnings;(my $database
=shift (@_));NXRedis::sendToDb (((
"\x63\x6f\x6d\x6d\x61\x6e\x64\x3d\x67\x65\x74\x2c\x73\x65\x72\x76\x69\x63\x65\x3d\x64\x62\x2c\x6b\x65\x79\x3d\x62\x61\x63\x6b\x75\x70\x2e"
.$database)."\x0a"));return (main::urldecode (NXRedis::get ()));}sub 
NXClusterTools::__remove{package NXClusterTools;no warnings;(my $file=shift (@_)
);if (Common::NXFile::fileExists ($file)){Logger::debug (((
"\x52\x65\x6d\x6f\x76\x69\x6e\x67\x20\x5b".$file)."\x5d"));if ((not (unlink (
$file)))){Logger::error ((((
"\x43\x61\x6e\x6e\x6f\x74\x20\x72\x65\x6d\x6f\x76\x65\x20\x66\x69\x6c\x65\x20".
$file)."\x20").$!));}}}sub NXClusterTools::unsynchronize{package NXClusterTools;
no warnings;(my $host=shift (@_));__unsync (NXPaths::getUserNXKnownCerts ());
__unsync (NXPaths::getNXAuthorizedKeysPath ("\x6e\x78"));__unsync (
NXPaths::getNodePublicKeys ());if ((
Common::NXFile::setOwnerShipAndPermissionsReadOnlyForNX (
NXPaths::getNodePublicKeys ())==(-(0x0cba+ 202-0x0d83)))){Logger::error ((
"\x43\x61\x6e\x6e\x6f\x74\x20\x73\x65\x74\x20\x66\x69\x6c\x65\x20\x70\x65\x72\x6d\x69\x73\x73\x69\x6f\x6e\x73\x20\x66\x6f\x72\x3a\x20"
.NXPaths::getNodePublicKeys ()));}__unsync (NXPaths::getUserKnownHostsSSH ());
__unsyncDatabases ();__remove (NXPaths::getClusterHostPublicCert ());__remove (
NXPaths::getClusterHostPrivateCert ());if (($host ne "\x6c\x6f\x63\x61\x6c")){
cleanDb ();}__unsync (NXPaths::getNetworkFile ());__unsync (
NXPaths::getNetworkDB ());}sub NXClusterTools::cleanSSHKeys{package 
NXClusterTools;no warnings;__unsync (NXPaths::getSSHHostKeyDSAPrivate (),
"\x72\x6f\x6f\x74");__unsync (NXPaths::getSSHHostKeyDSAPublic (),
"\x72\x6f\x6f\x74");__unsync (NXPaths::getSSHHostKeyRSAPrivate (),
"\x72\x6f\x6f\x74");__unsync (NXPaths::getSSHHostKeyRSAPublic (),
"\x72\x6f\x6f\x74");__unsync (NXPaths::getSSHHostKeyECDSAPrivate (),
"\x72\x6f\x6f\x74");__unsync (NXPaths::getSSHHostKeyECDSAPublic (),
"\x72\x6f\x6f\x74");__unsync (NXPaths::getSSHHostKeyED25519Private (),
"\x72\x6f\x6f\x74");__unsync (NXPaths::getSSHHostKeyED25519Public (),
"\x72\x6f\x6f\x74");}sub NXClusterTools::addClusterKey{package NXClusterTools;no
 warnings;(my $fileContent=shift (@_));(my $file=
NXPaths::getNXAuthorizedKeysPath ("\x6e\x78"));(my $rights=
$NXBits::UserReadWrite);return (__appendFile ($file,$rights,$fileContent,
(0x0b87+ 757-0x0cfc)));}sub NXClusterTools::setNodesDB{package NXClusterTools;no
 warnings;(my $fileContent=shift (@_));main::nxrequire (
"\x4e\x58\x4e\x6f\x64\x65\x73");__setDatabaseBackup ("\x6e\x6f\x64\x65\x73",
NXNodes::getDatabaseInString ());NXNodes::cleanDb ();return (
NXNodes::setDatabaseByString ($fileContent));}sub 
NXClusterTools::setNodeGroupsDB{package NXClusterTools;no warnings;(my $fileContent
=shift (@_));main::nxrequire ("\x4e\x58\x4e\x6f\x64\x65\x47\x72\x6f\x75\x70\x73"
,"\x69\x6e\x69\x74");__setDatabaseBackup (
"\x6e\x6f\x64\x65\x67\x72\x6f\x75\x70\x73",NXNodeGroups::getDatabaseInString ())
;NXNodeGroups::cleanDb ();return (NXNodeGroups::setDatabaseByString (
$fileContent));}sub NXClusterTools::setServerGroupsDB{package NXClusterTools;no 
warnings;(my $fileContent=shift (@_));main::nxrequire (
"\x4e\x58\x53\x65\x72\x76\x65\x72\x47\x72\x6f\x75\x70\x73","\x69\x6e\x69\x74");
__setDatabaseBackup ("\x73\x65\x72\x76\x65\x72\x67\x72\x6f\x75\x70\x73",
NXServerGroups::getDatabaseInString ());NXServerGroups::cleanDb ();
NXServerGroups::cleanLoadedGroups ();return (NXServerGroups::setDatabaseByString
 ($fileContent));}sub NXClusterTools::setClusterDB{package NXClusterTools;no 
warnings;(my $fileContent=shift (@_));cleanDb ();return (setDatabaseByString (
$fileContent));}sub NXClusterTools::setProfilesDB{package NXClusterTools;no 
warnings;(my $fileContent=shift (@_));main::nxrequire (
"\x4e\x58\x50\x72\x6f\x66\x69\x6c\x65\x73\x44\x42");__setDatabaseBackup (
"\x70\x72\x6f\x66\x69\x6c\x65\x73",NXProfilesDB::getDatabaseInString ());
NXProfilesDB::cleanDb ();return (NXProfilesDB::setDatabaseByString ($fileContent
));}sub NXClusterTools::setUsersDB{package NXClusterTools;no warnings;(my $fileContent
=shift (@_));main::nxrequire (
"\x4e\x58\x55\x73\x65\x72\x73\x4d\x61\x6e\x61\x67\x65\x72");__setDatabaseBackup 
("\x75\x73\x65\x72\x73",NXUsersManager::getDatabaseInString ());
NXUsersManager::cleanDb ();return (NXUsersManager::setDatabaseByString (
$fileContent));}sub NXClusterTools::setAdministratorsDB{package NXClusterTools;
no warnings;(my $fileContent=shift (@_));main::nxrequire (
"\x4e\x58\x41\x64\x6d\x69\x6e\x69\x73\x74\x72\x61\x74\x6f\x72\x73\x4d\x61\x6e\x61\x67\x65\x72"
);__setDatabaseBackup (
"\x61\x64\x6d\x69\x6e\x69\x73\x74\x72\x61\x74\x6f\x72\x73",
NXAdministratorsManager::getDatabaseInString ());
NXAdministratorsManager::cleanDb ();return (
NXAdministratorsManager::setDatabaseByString ($fileContent));}sub 
NXClusterTools::setGroupsDB{package NXClusterTools;no warnings;(my $fileContent=
shift (@_));main::nxrequire ("\x4e\x58\x47\x72\x6f\x75\x70\x73");
__setDatabaseBackup ("\x67\x72\x6f\x75\x70\x73",NXGroups::getDatabaseInString ()
);NXGroups::cleanDb ();return (NXGroups::setDatabaseByString ($fileContent));}
sub NXClusterTools::setNXCertsDB{package NXClusterTools;no warnings;(my $fileContent
=shift (@_));Logger::debug (
"\x4e\x58\x43\x6c\x75\x73\x74\x65\x72\x54\x6f\x6f\x6c\x73\x3a\x20\x53\x65\x74\x74\x69\x6e\x67\x20\x4e\x58\x20\x63\x65\x72\x74\x73\x2e"
);main::nxrequire ("\x4e\x58\x53\x65\x72\x76\x65\x72\x73");(my $ref_certs=
NXServers::getNXCertsHash ());(my $backup=NXShell::hashParameters2Url (
%$ref_certs));__setDatabaseBackup ("\x63\x65\x72\x74\x73\x4e\x58",$backup);
return (NXServers::setNXCertsByString ($ref_certs,$fileContent));}sub 
NXClusterTools::setSSHCertsDB{package NXClusterTools;no warnings;(my $fileContent
=shift (@_));Logger::debug (
"\x4e\x58\x43\x6c\x75\x73\x74\x65\x72\x54\x6f\x6f\x6c\x73\x3a\x20\x53\x65\x74\x74\x69\x6e\x67\x20\x53\x53\x48\x20\x63\x65\x72\x74\x73\x2e"
);main::nxrequire ("\x4e\x58\x53\x65\x72\x76\x65\x72\x73");(my $ref_certs=
NXServers::getSSHCertsHash ());(my $backup=NXShell::hashParameters2Url (
%$ref_certs));__setDatabaseBackup ("\x63\x65\x72\x74\x73\x53\x53\x48",$backup);
return (NXServers::setSSHCertsByString ($ref_certs,$fileContent));}sub 
NXClusterTools::setNetworkDB{package NXClusterTools;no warnings;(my $fileContent
=shift (@_));(my $file=NXPaths::getNetworkDB ());(my $rights=
$NXBits::UserReadWrite);return (__setFile ($file,$rights,$fileContent,
(0x19c9+ 3701-0x26be)));}sub NXClusterTools::setNetworkFile{package 
NXClusterTools;no warnings;(my $fileContent=shift (@_));(my $file=
NXPaths::getNetworkFile ());(my $rights=(($NXBits::UserReadWrite+
$NXBits::GroupRead)+$NXBits::OthersRead));return (__setFile ($file,$rights,
$fileContent,(0x1239+ 4696-0x22ed)));}sub NXClusterTools::setServerDSAPublicKey{
package NXClusterTools;no warnings;(my $fileContent=shift (@_));(my $file=
NXPaths::getServerDSAPublicKey ());(my $rights=(($NXBits::UserReadWrite+
$NXBits::GroupRead)+$NXBits::OthersRead));return (__setFile ($file,$rights,
$fileContent,(0x15b5+ 4004-0x23b5)));}sub NXClusterTools::setServerDSAPrivateKey
{package NXClusterTools;no warnings;(my $fileContent=shift (@_));(my $file=
NXPaths::getServerDSAPrivateKey ());(my $rights=$NXBits::UserReadWrite);return (
__setFile ($file,$rights,$fileContent,(0x18a2+ 3060-0x2316)));}sub 
NXClusterTools::setServerRSAPublicKey{package NXClusterTools;no warnings;(my $fileContent
=shift (@_));(my $file=NXPaths::getServerRSAPublicKey ());(my $rights=((
$NXBits::UserReadWrite+$NXBits::GroupRead)+$NXBits::OthersRead));return (
__setFile ($file,$rights,$fileContent,(0x1bdf+ 346-0x1b95)));}sub 
NXClusterTools::setServerRSAPrivateKey{package NXClusterTools;no warnings;(my $fileContent
=shift (@_));(my $file=NXPaths::getServerRSAPrivateKey ());(my $rights=
$NXBits::UserReadWrite);return (__setFile ($file,$rights,$fileContent,
(0x1f06+ 1160-0x220e)));}sub NXClusterTools::setClientCerts{package 
NXClusterTools;no warnings;(my $fileContent=shift (@_));(my $file=
NXPaths::getUserNXKnownCerts ());(my $rights=$NXBits::UserReadWrite);return (
__setFile ($file,$rights,$fileContent,(0x0836+ 7148-0x22a2)));}sub 
NXClusterTools::setAuthorizedCerts{package NXClusterTools;no warnings;(my $fileContent
=shift (@_));(my $file=NXPaths::getNXAuthorizedKeysPath ("\x6e\x78"));(my $rights
=$NXBits::UserReadWrite);return (__setFile ($file,$rights,$fileContent,
(0x10bd+ 3556-0x1d21)));}sub NXClusterTools::addSSHAuthorizedCerts{package 
NXClusterTools;no warnings;(my $fileContent=shift (@_));(my $file=
NXPaths::getNodePublicKeys ());if (Common::NXFile::fileExists ($file)){my (
$error);if ((Common::NXFile::setPermissionsReadWriteForNX ($file,(\$error))==(-
(0x0a07+ 5109-0x1dfb)))){Logger::error (((((
"\x43\x61\x6e\x6e\x6f\x74\x20\x63\x68\x61\x6e\x67\x65\x20\x72\x69\x67\x68\x74\x73\x20\x74\x6f\x20\x27"
.$file)."\x27\x2e\x20\x45\x72\x72\x6f\x72\x20\x69\x73\x20\x27").$error).
"\x27\x2e"));return ((0x1030+ 5484-0x259b));}}(my $rights=$NXBits::UserReadWrite
);return (__appendFile ($file,$rights,$fileContent,(0x1155+ 1249-0x14b6)));}sub 
NXClusterTools::setSSHAuthorizedCerts{package NXClusterTools;no warnings;(my $fileContent
=shift (@_));(my $file=NXPaths::getNodePublicKeys ());(my $rights=
$NXBits::UserReadWrite);return (__setFile ($file,$rights,$fileContent,
(0x0e02+ 4674-0x1ec4)));}sub NXClusterTools::__setHostPrivateCert{package 
NXClusterTools;no warnings;(my $fileContent=shift (@_));(my $file=
NXPaths::getHostPrivateCert ());(my $rights=$NXBits::UserReadWrite);return (
__setFile ($file,$rights,$fileContent,(0x0a8b+ 285-0x0a28)));}sub 
NXClusterTools::__setHostPublicCert{package NXClusterTools;no warnings;(my $fileContent
=shift (@_));(my $file=NXPaths::getHostPublicCert ());(my $rights=
$NXBits::UserReadWrite);return (__setFile ($file,$rights,$fileContent,
(0x0efb+ 3454-0x1af9)));}sub NXClusterTools::setClusterMasterCertPub{package 
NXClusterTools;no warnings;(my $fileContent=shift (@_));(my $file=
NXPaths::getClusterHostPublicCert ());(my $rights=$NXBits::UserReadWrite);return
 (__setFile ($file,$rights,$fileContent,(0x1043+ 5189-0x2308)));}sub 
NXClusterTools::setClusterMasterCertPriv{package NXClusterTools;no warnings;(my $fileContent
=shift (@_));(my $file=NXPaths::getClusterHostPrivateCert ());(my $rights=
$NXBits::UserReadWrite);return (__setFile ($file,$rights,$fileContent,
(0x1c74+ 2460-0x2490)));}sub NXClusterTools::setKnownHostsSSH{package 
NXClusterTools;no warnings;(my $fileContent=shift (@_));(my $file=
NXPaths::getUserKnownHostsSSH ());(my $rights=$NXBits::UserReadWrite);return (
__setFile ($file,$rights,$fileContent,(0x057d+ 8814-0x266b)));}sub 
NXClusterTools::setSSHHostKeyDSAPrivate{package NXClusterTools;no warnings;(my $fileContent
=shift (@_));(my $file=NXPaths::getSSHHostKeyDSAPrivate ());(my $rights=
$NXBits::UserReadWrite);__setFile ($file,$rights,$fileContent,
(0x174c+ 2258-0x1e9e),"\x72\x6f\x6f\x74");return ((0x00eb+ 9432-0x25c3));}sub 
NXClusterTools::setSSHHostKeyDSAPublic{package NXClusterTools;no warnings;(my $fileContent
=shift (@_));(my $file=NXPaths::getSSHHostKeyDSAPublic ());(my $rights=((
$NXBits::UserReadWrite+$NXBits::GroupRead)+$NXBits::OthersRead));__setFile (
$file,$rights,$fileContent,(0x0d4d+ 6078-0x2367),"\x72\x6f\x6f\x74");return (
(0x0048+ 2051-0x084b));}sub NXClusterTools::setSSHHostKeyRSAPrivate{package 
NXClusterTools;no warnings;(my $fileContent=shift (@_));(my $file=
NXPaths::getSSHHostKeyRSAPrivate ());(my $rights=$NXBits::UserReadWrite);
__setFile ($file,$rights,$fileContent,(0x1d99+ 2606-0x2647),"\x72\x6f\x6f\x74");
return ((0x16a7+ 4196-0x270b));}sub NXClusterTools::setSSHHostKeyRSAPublic{
package NXClusterTools;no warnings;(my $fileContent=shift (@_));(my $file=
NXPaths::getSSHHostKeyRSAPublic ());(my $rights=(($NXBits::UserReadWrite+
$NXBits::GroupRead)+$NXBits::OthersRead));__setFile ($file,$rights,$fileContent,
(0x03ab+ 5507-0x178a),"\x72\x6f\x6f\x74");return ((0x02a1+ 251-0x039c));}sub 
NXClusterTools::setSSHHostKeyECDSAPrivate{package NXClusterTools;no warnings;(my $fileContent
=shift (@_));(my $file=NXPaths::getSSHHostKeyECDSAPrivate ());(my $rights=
$NXBits::UserReadWrite);__setFile ($file,$rights,$fileContent,
(0x0648+ 1469-0x0a85),"\x72\x6f\x6f\x74");return ((0x02f6+ 5647-0x1905));}sub 
NXClusterTools::setSSHHostKeyECDSAPublic{package NXClusterTools;no warnings;(my $fileContent
=shift (@_));(my $file=NXPaths::getSSHHostKeyECDSAPublic ());(my $rights=((
$NXBits::UserReadWrite+$NXBits::GroupRead)+$NXBits::OthersRead));__setFile (
$file,$rights,$fileContent,(0x0686+ 1750-0x0bb8),"\x72\x6f\x6f\x74");return (
(0x0f90+ 3876-0x1eb4));}sub NXClusterTools::setSSHHostKeyED25519Private{package 
NXClusterTools;no warnings;(my $fileContent=shift (@_));(my $file=
NXPaths::getSSHHostKeyED25519Private ());(my $rights=$NXBits::UserReadWrite);
__setFile ($file,$rights,$fileContent,(0x05ed+ 4843-0x1758),"\x72\x6f\x6f\x74");
return ((0x0029+ 1723-0x06e4));}sub NXClusterTools::setSSHHostKeyED25519Public{
package NXClusterTools;no warnings;(my $fileContent=shift (@_));(my $file=
NXPaths::getSSHHostKeyED25519Public ());(my $rights=(($NXBits::UserReadWrite+
$NXBits::GroupRead)+$NXBits::OthersRead));__setFile ($file,$rights,$fileContent,
(0x02f7+ 6831-0x1c02),"\x72\x6f\x6f\x74");return ((0x1c4c+ 2356-0x2580));}sub 
NXClusterTools::__backupPrevious{package NXClusterTools;no warnings;(my $path=
shift (@_));(my $rights=shift (@_));(my $owner=shift (@_));(my $body=shift (@_))
;if ((not (Common::NXFile::fileExists ($path)))){(my $emptyFile=($path.
"\x2e\x65\x6d\x70\x74\x79"));(my $FH=main::nxopen ($emptyFile,($NXBits::O_RDWR+
$NXBits::O_CREAT),(($NXBits::OthersRead+$NXBits::UserReadWrite)+
$NXBits::GroupRead)));if ((not (defined ($FH)))){(my $errorNumber=
libnxh::NXGetError ());(my $errorString=libnxh::NXGetErrorString ());
Logger::error (((
"\x43\x61\x6e\x6e\x6f\x74\x20\x63\x72\x65\x61\x74\x65\x20\x66\x69\x6c\x65\x20\x27"
.$emptyFile)."\x27\x2e"));Logger::error (((((
"\x45\x72\x72\x6f\x72\x20\x69\x73\x20".$errorNumber)."\x2c\x20").$errorString).
"\x2e"));return ((0x066f+ 2381-0x0fbb));}main::nxclose ($FH);if (($owner ne 
"\x72\x6f\x6f\x74")){changeFileOwnershipToNxIfRoot ($emptyFile);}return (
(0x0e22+ 5774-0x24b0));}(my $backup=($path."\x2e\x62\x61\x63\x6b\x75\x70"));if (
Common::NXFile::fileExists ($backup)){($backup.=("\x2d".NXTools::getTimeMs ()));
}if (($body ne (""))){(my $FH=main::nxopen ($backup,($NXBits::O_RDWR+
$NXBits::O_CREAT),$NXBits::UserReadWrite));if ((not (defined ($FH)))){(my $errorNumber
=libnxh::NXGetError ());(my $errorString=libnxh::NXGetErrorString ());
Logger::error (((
"\x43\x61\x6e\x6e\x6f\x74\x20\x63\x72\x65\x61\x74\x65\x20\x66\x69\x6c\x65\x20\x27"
.$emptyFile)."\x27\x2e"));Logger::error (((((
"\x45\x72\x72\x6f\x72\x20\x69\x73\x20".$errorNumber)."\x2c\x20").$errorString).
"\x2e"));return ((0x0e05+ 2020-0x15e8));}if ((main::nxwrite ($FH,$body)==(-
(0x01ca+ 4456-0x1331)))){(my $errorNumber=libnxh::NXGetError ());(my $errorstring
=libnxh::NXGetErrorString ());Logger::error (((
"\x43\x61\x6e\x6e\x6f\x74\x20\x77\x72\x69\x74\x65\x20\x74\x6f\x20\x66\x69\x6c\x65\x20\x27"
.$backup)."\x27\x2e"));Logger::error (((((
"\x45\x72\x72\x6f\x72\x20\x69\x73\x3a\x20".$errorNumber)."\x2c\x20").
$errorstring)."\x2e"));main::nxclose ($FH);if (($backupOwner ne 
"\x72\x6f\x6f\x74")){changeFileOwnershipToNxIfRoot ($backup);}return (
(0x12b5+ 1580-0x18e0));}main::nxclose ($FH);if (($owner ne "\x72\x6f\x6f\x74")){
changeFileOwnershipToNxIfRoot ($backup);}return ((0x033f+ 1425-0x08d0));}else{(my (
$retValue,$outMsg)=Common::NXCore::copyFile ($path,$backup));if (($outMsg ne 
(""))){Logger::error (((((((
"\x43\x61\x6e\x6e\x6f\x74\x20\x63\x6f\x70\x79\x20\x27".$path).
"\x27\x20\x74\x6f\x20\x27").$backup).
"\x27\x2e\x20\x45\x72\x72\x6f\x72\x20\x69\x73\x20\x27").$outMsg)."\x27\x2e"));
return ((0x0ba7+ 6484-0x24fa));}}my ($error);if ((Common::NXFile::setPermission 
($backup,$rights,(\$error))==(-(0x14c8+ 654-0x1755)))){Logger::warning (((((
"\x43\x61\x6e\x6e\x6f\x74\x20\x63\x68\x61\x6e\x67\x65\x20\x72\x69\x67\x68\x74\x73\x20\x74\x6f\x20"
.$backup)."\x2e\x20\x45\x72\x72\x6f\x72\x20\x69\x73\x20\x27").$error)."\x27\x2e"
));return ((0x0e29+ 2234-0x16e2));}unless (Common::NXFile::fileExists ($backup))
{Logger::error (((((
"\x46\x61\x69\x6c\x65\x64\x20\x74\x6f\x20\x63\x72\x65\x61\x74\x65\x20\x66\x69\x6c\x65\x20\x62\x61\x63\x6b\x75\x70\x20\x27"
.$backup)."\x27\x20\x66\x6f\x72\x20\x27").$path)."\x27\x2e"));return (
(0x022c+ 4546-0x13ed));}if ((($owner ne "\x72\x6f\x6f\x74")and ($owner ne 
"\x6e\x78\x68\x74\x64"))){changeFileOwnershipToNxIfRoot ($backup);}return (
(0x0ba3+ 2334-0x14c1));}sub NXClusterTools::__setFile{package NXClusterTools;no 
warnings;(my $file=shift (@_));(my $rights=shift (@_));(my $fileBody=shift (@_))
;(my $backupRights=shift (@_));(my $backupOwner=shift (@_));(my $backupBody=
shift (@_));if (__backupPrevious ($file,$backupRights,$backupOwner,$backupBody))
{return ((0x1550+ 1904-0x1cbf));}(my $fileBackup=($file."\x2e\x74\x6d\x70"));(my $fileDesc
=main::nxopen ($fileBackup,($NXBits::O_WRONLY+$NXBits::O_CREAT),$rights));unless
 (defined ($fileDesc)){Logger::error (((
"\x45\x72\x72\x6f\x72\x20\x6f\x70\x65\x6e\x69\x6e\x67\x20\x66\x69\x6c\x65\x20\x74\x6f\x20\x77\x72\x69\x74\x65\x20\x27"
.$fileBackup)."\x27\x2e"));return ((0x10ba+ 2088-0x18e1));}if ((main::nxwrite (
$fileDesc,$fileBody)==(-(0x0a6c+ 7096-0x2623)))){(my $errorNumber=
libnxh::NXGetError ());(my $errorstring=libnxh::NXGetErrorString ());
Logger::error (((
"\x43\x61\x6e\x6e\x6f\x74\x20\x77\x72\x69\x74\x65\x20\x74\x6f\x20\x66\x69\x6c\x65\x20\x27"
.$fileBackup)."\x27\x2e"));Logger::error (((((
"\x45\x72\x72\x6f\x72\x20\x69\x73\x3a\x20".$errorNumber)."\x2c\x20").
$errorstring)."\x2e"));main::nxclose ($fileDesc);if ((($backupOwner ne 
"\x72\x6f\x6f\x74")and ($backupOwner ne "\x6e\x78\x68\x74\x64"))){
changeFileOwnershipToNxIfRoot ($fileBackup);}return ((0x1098+ 1917-0x1814));}
main::nxclose ($fileDesc);if ((($backupOwner ne "\x72\x6f\x6f\x74")and (
$backupOwner ne "\x6e\x78\x68\x74\x64"))){changeFileOwnershipToNxIfRoot (
$fileBackup);}unless (rename ($fileBackup,$file)){Logger::error (((((((
"\x43\x61\x6e\x6e\x6f\x74\x20\x72\x65\x6e\x61\x6d\x65\x20\x66\x69\x6c\x65\x20\x27"
.$fileBackup)."\x27\x20\x74\x6f\x20\x27").$file).
"\x27\x2e\x20\x45\x72\x72\x6f\x72\x20\x69\x73\x20\x27").$!)."\x27\x2e"));return 
((0x106b+ 4821-0x233f));}return ((0x112b+ 4875-0x2436));}sub 
NXClusterTools::__appendFile{package NXClusterTools;no warnings;(my $file=shift 
(@_));(my $rights=shift (@_));(my $fileBody=shift (@_));(my $rightBackup=shift (
@_));(my $ownerBackup=shift (@_));if (__backupPrevious ($file,$rightBackup,
$ownerBackup)){return ((0x16e3+ 3808-0x25c2));}(my $fileExisted=
(0x0058+ 2559-0x0a57));if (Common::NXFile::fileExists ($file)){($fileExisted=
(0x09db+ 7475-0x270d));}(my $fileDesc=main::nxopen ($file,(($NXBits::O_WRONLY+
$NXBits::O_CREAT)+$NXBits::O_APPEND),$rights));unless (defined ($fileDesc)){
Logger::error (((
"\x45\x72\x72\x6f\x72\x20\x77\x68\x69\x6c\x65\x20\x6f\x70\x65\x6e\x69\x6e\x67\x20\x66\x69\x6c\x65\x20\x27"
.$file)."\x27\x20\x74\x6f\x20\x61\x70\x70\x65\x6e\x64\x2e"));return (
(0x0155+ 8657-0x2325));}if ((main::nxwrite ($fileDesc,$fileBody)==(-
(0x05e6+ 616-0x084d)))){(my $errorNumber=libnxh::NXGetError ());(my $errorstring
=libnxh::NXGetErrorString ());Logger::error (((
"\x43\x61\x6e\x6e\x6f\x74\x20\x77\x72\x69\x74\x65\x20\x74\x6f\x20\x66\x69\x6c\x65\x20"
.$file)."\x2e"));Logger::error ((((("\x45\x72\x72\x6f\x72\x20\x69\x73\x3a\x20".
$errorNumber)."\x2c\x20").$errorstring)."\x2e"));main::nxclose ($fileDesc);if ((
not ($fileExisted))){if (($ownerBackup ne "\x72\x6f\x6f\x74")){
changeFileOwnershipToNxIfRoot ($file);}}return ((0x18a6+ 3589-0x26aa));}
main::nxclose ($fileDesc);if ((not ($fileExisted))){
changeFileOwnershipToNxIfRoot ($file);}return ((0x0833+ 2922-0x139d));}sub 
NXClusterTools::__addClusterNodeKey{package NXClusterTools;no warnings;(my $message
=shift (@_));($message=main::urldecode ($message));return (addClusterKey (
$message));}sub NXClusterTools::checkUserNXConfigDir{package NXClusterTools;no 
warnings;(my $path=NXPaths::getConfigDir ());unless (
Common::NXFile::directoryExists ($path)){my ($error);unless (
Common::NXPaths::createAccessibleForNXDirectory ((\$error),$path)){return (
(0x1359+ 1392-0x18c9));}}return ((0x14d5+ 1055-0x18f3));}sub 
NXClusterTools::prepareNXKnownCerts{package NXClusterTools;no warnings;(my $refClusterHash
=shift (@_));my ($file);foreach my $key (keys (%$refClusterHash)){(my $value=
$$refClusterHash{$key});chomp ($value);if (
Common::NXShellCreate::isHostInCertFile ($key,NXPaths::getCurrentUserKnownCerts 
())){Common::NXShellCreate::removeCertificate ($key,$value,
NXPaths::getUserNXKnownCerts ());}($file.=(((("\x48\x6f\x73\x74\x3a".$key).
"\x0a").$value)."\x0a"));}(my $myIp=$GLOBAL::ClusterOldLocal);(my $myCert=
getHostPublicCert ());chomp ($myCert);if (
Common::NXShellCreate::isHostInCertFile ($myIp,NXPaths::getCurrentUserKnownCerts
 ())){Common::NXShellCreate::removeCertificate ($myIp,$myCert,
NXPaths::getUserNXKnownCerts ());}($file.=(((("\x48\x6f\x73\x74\x3a".$myIp).
"\x0a").$myCert)."\x0a"));(my $hostCert=getClusterMasterCertPub ());if (
NXCluster::isSingleCert ()){($hostCert=getHostPublicCert ());}chomp ($hostCert);
if (Common::NXShellCreate::isHostInCertFile ($GLOBAL::ClusterHost,
NXPaths::getCurrentUserKnownCerts ())){Common::NXShellCreate::removeCertificate 
($GLOBAL::ClusterHost,$hostCert,NXPaths::getUserNXKnownCerts ());}($file.=((((
"\x48\x6f\x73\x74\x3a".$GLOBAL::ClusterHost)."\x0a").$hostCert)."\x0a"));($file
.=getPlayerCerts ());setClientCerts ($file);(my $path=
NXPaths::getUserNXKnownCerts ());changeFileOwnershipToNxIfRoot ($path);return (
$file);}sub NXClusterTools::__preparePublicKeys{package NXClusterTools;no 
warnings;(my $ref_publicKeys=shift (@_));(my $protocol=shift (@_));Logger::debug
 (
"\x4e\x58\x43\x6c\x75\x73\x74\x65\x72\x54\x6f\x6f\x6c\x73\x3a\x20\x50\x72\x65\x70\x61\x72\x65\x20\x70\x75\x62\x6c\x69\x63\x20\x6b\x65\x79\x73\x2e"
);(my $file=(""));my ($filePath);if (($protocol eq "\x53\x53\x48")){($filePath=
NXPaths::getNodePublicKeys ());}else{($filePath=NXPaths::getNXAuthorizedKeysPath
 ("\x6e\x78"));}(my $fileContent=Common::NXFile::getFileContent ($filePath));(my (
@oldContent)=split ( /\n/ ,$fileContent,(0x03a2+ 5338-0x187c)));(my $prefix=
"\x6e\x6f\x2d\x70\x6f\x72\x74\x2d\x66\x6f\x72\x77\x61\x72\x64\x69\x6e\x67\x2c\x6e\x6f\x2d\x61\x67\x65\x6e\x74\x2d\x66\x6f\x72\x77\x61\x72\x64\x69\x6e\x67\x2c"
);($prefix.=(("\x63\x6f\x6d\x6d\x61\x6e\x64\x3d\x22".$GLOBAL::ETC_DIR).
$GLOBAL::DIRECTORY_SLASH));($prefix.=
"\x6e\x78\x73\x65\x72\x76\x65\x72\x20\x2d\x2d\x72\x65\x6d\x6f\x74\x65\x6c\x6f\x67\x69\x6e\x22\x20"
);foreach my $key (keys (%$ref_publicKeys)){(my $potentialKey=$$ref_publicKeys{
$key});(my $add=(0x18dd+ 446-0x1a9a));chomp ($potentialKey);($potentialKey=~ s/\r//g )
;if (($protocol eq "\x53\x53\x48")){($potentialKey=($prefix.$potentialKey));}
else{($potentialKey.=
"\x20\x4e\x6f\x4d\x61\x63\x68\x69\x6e\x65\x43\x6c\x75\x73\x74\x65\x72");}foreach my $line
 (@oldContent){chomp ($line);($line=~ s/\r//g );if (($potentialKey eq $line)){(
$add=(0x192d+ 191-0x19ec));last;}}if (($add==(0x0b5a+ 3413-0x18ae))){($file.=(
$potentialKey."\x0a"));}}(my $potentialKey=getClusterPublicKey ());chomp (
$potentialKey);($potentialKey=~ s/\r//g );if (($protocol eq "\x53\x53\x48")){(
$potentialKey=($prefix.$potentialKey));}else{($potentialKey.=
"\x20\x4e\x6f\x4d\x61\x63\x68\x69\x6e\x65\x43\x6c\x75\x73\x74\x65\x72");}(my $add
=(0x0951+ 1206-0x0e06));foreach my $line (@oldContent){chomp ($line);($line=~ s/\r//g )
;if (($potentialKey eq $line)){($add=(0x0b20+ 2916-0x1684));last;}}if (($add==
(0x13db+ 1484-0x19a6))){($file.=($potentialKey."\x0a"));}($file.=$fileContent);
if (($protocol eq "\x53\x53\x48")){setSSHAuthorizedCerts ($file);}else{
setAuthorizedCerts ($file);}return ($file);}sub 
NXClusterTools::prepareNXDPublicKeys{package NXClusterTools;no warnings;(my $ref_publicKeys
=shift (@_));return (__preparePublicKeys ($ref_publicKeys,"\x4e\x58"));}sub 
NXClusterTools::prepareSSHPublicKeys{package NXClusterTools;no warnings;(my $ref_publicKeys
=shift (@_));return (__preparePublicKeys ($ref_publicKeys,"\x53\x53\x48"));}sub 
NXClusterTools::prepareSSHClusterKey{package NXClusterTools;no warnings;(my $prefix
=
"\x6e\x6f\x2d\x70\x6f\x72\x74\x2d\x66\x6f\x72\x77\x61\x72\x64\x69\x6e\x67\x2c\x6e\x6f\x2d\x61\x67\x65\x6e\x74\x2d\x66\x6f\x72\x77\x61\x72\x64\x69\x6e\x67\x2c"
);($prefix.=((("\x63\x6f\x6d\x6d\x61\x6e\x64\x3d\x22".$GLOBAL::ETC_DIR).
$GLOBAL::DIRECTORY_SLASH).
"\x6e\x78\x73\x65\x72\x76\x65\x72\x20\x2d\x2d\x72\x65\x6d\x6f\x74\x65\x6c\x6f\x67\x69\x6e\x22\x20"
));(my $key=($prefix.getClusterPublicKey ()));return ($key);}sub 
NXClusterTools::prepareKnownHostsSSH{package NXClusterTools;no warnings;(my $host
=shift (@_));(my $sshCrt=shift (@_));($sshCrt=~ s/\015//gs );my ($file);if ((
$sshCrt ne (""))){($file=(((($GLOBAL::ClusterPool."\x2c").$GLOBAL::ClusterHost).
"\x20").$sshCrt));}Common::NXShellCreate::removeCertificateSSH (
$GLOBAL::ClusterHost,(""),NXPaths::getUserKnownHostsSSH ());(my (@hosts)=split ( /,/ ,
$GLOBAL::ClusterPool,(0x05a1+ 3099-0x11bc)));foreach my $host (@hosts){
Common::NXShellCreate::removeCertificateSSH ($host,(""),
NXPaths::getUserKnownHostsSSH ());}($file.=getUserKnownHostsSSH ());
setKnownHostsSSH ($file);return ($file);}sub NXClusterTools::checkKeys{package 
NXClusterTools;no warnings;Logger::debug (
"\x4e\x58\x43\x6c\x75\x73\x74\x65\x72\x54\x6f\x6f\x6c\x73\x3a\x20\x43\x68\x65\x63\x6b\x69\x6e\x67\x20\x63\x6c\x75\x73\x74\x65\x72\x20\x66\x69\x6c\x65\x73\x2e"
);if ((not (Common::NXFile::fileExists (NXPaths::getClusterRSAPrivateKey ())))){
generateClusterKeys ();}if ((not (Common::NXFile::fileExists (
NXPaths::getClusterRSAPublicKey ())))){generateClusterKeys ();}if ((not (
Common::NXFile::fileExists (NXPaths::getClusterHostPublicCert ())))){
generateClusterHostCerts ();}if ((not (Common::NXFile::fileExists (
NXPaths::getClusterHostPrivateCert ())))){generateClusterHostCerts ();}}sub 
NXClusterTools::changeFileOwnershipToNxIfRoot{package NXClusterTools;no warnings
;(my $file=shift (@_));(my $user=Common::NXCore::getEffectiveUsername ());if ((
$user eq "\x72\x6f\x6f\x74")){Logger::debug2 (((
"\x53\x65\x74\x74\x69\x6e\x67\x20\x6f\x77\x6e\x65\x72\x73\x68\x69\x70\x20\x66\x6f\x72\x20\x75\x73\x65\x72\x20\x6e\x78\x20\x27"
.$file)."\x27\x2e"));my ($errorName);my ($errorCode);if ((
Common::NXFile::setOwnershipForUserSilent ($file,"\x6e\x78",(\$errorName),(
\$errorCode))==(-(0x0ee7+ 925-0x1283)))){Logger::error ((((((
"\x43\x61\x6e\x6e\x6f\x74\x20\x73\x65\x74\x20\x6f\x77\x6e\x65\x72\x73\x68\x69\x70\x20\x66\x69\x6c\x65\x20"
.$file)."\x2e\x20").$errorCode)."\x20").$errorName));NXMsg::error (
"\x65\x43\x61\x6e\x6e\x6f\x74\x53\x65\x74\x4f\x77\x6e\x65\x72\x73\x68\x69\x70",
"\x4e\x58\x53\x68\x65\x6c\x6c",(($file."\x2e\x20").$errorName));unlink ($file);
main::nxexit ((0x0bb6+ 3414-0x190c));}}return ((0x0607+ 4033-0x15c8));}sub 
NXClusterTools::__getPathToPublicKey{package NXClusterTools;no warnings;if (
__isRSAKeyAvailable ()){return (NXPaths::getClusterRSAPrivateKey ());}return (
NXPaths::getClusterDSAPrivateKey ());}sub NXClusterTools::getDatabaseInString{
package NXClusterTools;no warnings;(my $request=
"\x63\x6f\x6d\x6d\x61\x6e\x64\x3d\x68\x6d\x67\x65\x74\x2c\x73\x65\x72\x76\x69\x63\x65\x3d\x64\x62\x2c\x6b\x65\x79\x3d\x63\x6c\x75\x73\x74\x65\x72\x2e\x63\x6f\x6e\x66\x69\x67\x2c\x66\x69\x65\x6c\x64\x3d\x6d\x61\x73\x74\x65\x72\x2c\x66\x69\x65\x6c\x64\x3d\x73\x68\x61\x72\x65\x64\x2c\x66\x69\x65\x6c\x64\x3d\x70\x72\x6f\x74\x6f\x2c\x66\x69\x65\x6c\x64\x3d\x67\x72\x61\x63\x65"
);($request.=
"\x2c\x66\x69\x65\x6c\x64\x3d\x72\x65\x74\x72\x79\x2c\x66\x69\x65\x6c\x64\x3d\x70\x72\x6f\x62\x65\x2c\x66\x69\x65\x6c\x64\x3d\x69\x6e\x74\x65\x72\x76\x61\x6c\x2c\x66\x69\x65\x6c\x64\x3d\x74\x69\x6d\x65\x6f\x75\x74\x2c\x66\x69\x65\x6c\x64\x3d\x6d\x61\x69\x6e\x43\x6c\x75\x73\x74\x65\x72\x55\x55\x49\x44\x2c\x66\x69\x65\x6c\x64\x3d\x63\x6c\x75\x73\x74\x65\x72\x47\x55\x49\x44\x0a"
);(my $databaseString=(""));NXRedis::sendToDb ($request);(my $config=
NXRedis::get ());($config=~ s/ /,/g );($databaseString.=($config."\x0a"));
NXRedis::sendToDb (
"\x63\x6f\x6d\x6d\x61\x6e\x64\x3d\x73\x6d\x65\x6d\x62\x65\x72\x73\x2c\x73\x65\x72\x76\x69\x63\x65\x3d\x64\x62\x2c\x6b\x65\x79\x3d\x63\x6c\x75\x73\x74\x65\x72\x0a"
);(my $clusterList=NXRedis::get ());(my (@list)=split ( / / ,$clusterList,
(0x0511+ 543-0x0730)));foreach $host (@list){NXRedis::sendToDb (((
"\x63\x6f\x6d\x6d\x61\x6e\x64\x3d\x68\x6d\x67\x65\x74\x2c\x73\x65\x72\x76\x69\x63\x65\x3d\x64\x62\x2c\x6b\x65\x79\x3d\x63\x6c\x75\x73\x74\x65\x72\x2e"
.$host).
"\x2c\x66\x69\x65\x6c\x64\x3d\x68\x6f\x73\x74\x2c\x66\x69\x65\x6c\x64\x3d\x69\x6e\x74\x65\x72\x66\x61\x63\x65\x2c\x66\x69\x65\x6c\x64\x3d\x6e\x65\x74\x6d\x61\x73\x6b\x0a"
));(my $line=NXRedis::get ());($line=~ s/ /,/g );($databaseString.=($line."\x0a"
));}return ($databaseString);}sub NXClusterTools::setDatabaseByString{package 
NXClusterTools;no warnings;(my $string=shift (@_));(my (@clusterList)=split ( /\n/ ,
$string,(0x0f84+ 5749-0x25f9)));(my $redisString=__setConfigLine ($clusterList[
(0x1356+ 590-0x15a4)]));NXRedis::sendToDb ($redisString);(my ($host1data,
$host1set)=__setHostLineS ($clusterList[(0x204a+ 135-0x20d0)]));
NXRedis::sendToDb ($host1data);NXRedis::sendToDb ($host1set);(my ($host2data,
$host2set)=__setHostLineS ($clusterList[(0x162a+ 4215-0x269f)]));
NXRedis::sendToDb ($host2data);NXRedis::sendToDb ($host2set);return (
(0x10fb+ 2192-0x198b));}sub NXClusterTools::__setConfigLine{package 
NXClusterTools;no warnings;(my $configLine=shift (@_));(my $record=
"\x63\x6f\x6d\x6d\x61\x6e\x64\x3d\x68\x6d\x73\x65\x74\x2c\x73\x65\x72\x76\x69\x63\x65\x3d\x64\x62\x2c\x6b\x65\x79\x3d\x63\x6c\x75\x73\x74\x65\x72\x2e\x63\x6f\x6e\x66\x69\x67"
);(my (@options)=split ( /,/ ,$configLine,(0x00a6+ 4044-0x1072)));($record.=(
"\x2c\x66\x69\x65\x6c\x64\x3d\x6d\x61\x73\x74\x65\x72\x2c\x76\x61\x6c\x75\x65\x3d"
.$options[(0x0347+ 3877-0x126c)]));($record.=(
"\x2c\x66\x69\x65\x6c\x64\x3d\x73\x68\x61\x72\x65\x64\x2c\x76\x61\x6c\x75\x65\x3d"
.$options[(0x0640+ 277-0x0754)]));($record.=(
"\x2c\x66\x69\x65\x6c\x64\x3d\x70\x72\x6f\x74\x6f\x2c\x76\x61\x6c\x75\x65\x3d".
$options[(0x04f0+ 3688-0x1356)]));($record.=(
"\x2c\x66\x69\x65\x6c\x64\x3d\x67\x72\x61\x63\x65\x2c\x76\x61\x6c\x75\x65\x3d".
$options[(0x1cb2+ 624-0x1f1f)]));($record.=(
"\x2c\x66\x69\x65\x6c\x64\x3d\x72\x65\x74\x72\x79\x2c\x76\x61\x6c\x75\x65\x3d".
$options[(0x1083+ 1846-0x17b5)]));($record.=(
"\x2c\x66\x69\x65\x6c\x64\x3d\x70\x72\x6f\x62\x65\x2c\x76\x61\x6c\x75\x65\x3d".
$options[(0x0091+ 3728-0x0f1c)]));($record.=(
"\x2c\x66\x69\x65\x6c\x64\x3d\x69\x6e\x74\x65\x72\x76\x61\x6c\x2c\x76\x61\x6c\x75\x65\x3d"
.$options[(0x144c+ 404-0x15da)]));($record.=(
"\x2c\x66\x69\x65\x6c\x64\x3d\x74\x69\x6d\x65\x6f\x75\x74\x2c\x76\x61\x6c\x75\x65\x3d"
.$options[(0x20eb+ 772-0x23e8)]));($record.=(
"\x2c\x66\x69\x65\x6c\x64\x3d\x6d\x61\x69\x6e\x43\x6c\x75\x73\x74\x65\x72\x55\x55\x49\x44\x2c\x76\x61\x6c\x75\x65\x3d"
.$options[(0x0702+ 4689-0x194b)]));($record.=(
"\x2c\x66\x69\x65\x6c\x64\x3d\x63\x6c\x75\x73\x74\x65\x72\x47\x55\x49\x44\x2c\x76\x61\x6c\x75\x65\x3d"
.$options[(0x1011+ 3083-0x1c13)]));($record.="\x0a");return ($record);}sub 
NXClusterTools::__setHostLineS{package NXClusterTools;no warnings;(my $hostLine=
shift (@_));(my (@host)=split ( /,/ ,$hostLine,(0x0865+ 4475-0x19e0)));(my $record
=(
"\x63\x6f\x6d\x6d\x61\x6e\x64\x3d\x68\x6d\x73\x65\x74\x2c\x73\x65\x72\x76\x69\x63\x65\x3d\x64\x62\x2c\x6b\x65\x79\x3d\x63\x6c\x75\x73\x74\x65\x72\x2e"
.$host[(0x0199+ 7929-0x2092)]));($record.=(
"\x2c\x66\x69\x65\x6c\x64\x3d\x68\x6f\x73\x74\x2c\x76\x61\x6c\x75\x65\x3d".$host
[(0x1e62+ 774-0x2168)]));($record.=(
"\x2c\x66\x69\x65\x6c\x64\x3d\x69\x6e\x74\x65\x72\x66\x61\x63\x65\x2c\x76\x61\x6c\x75\x65\x3d"
.$host[(0x18fd+ 890-0x1c76)]));($record.=(
"\x2c\x66\x69\x65\x6c\x64\x3d\x6e\x65\x74\x6d\x61\x73\x6b\x2c\x76\x61\x6c\x75\x65\x3d"
.$host[(0x1cb1+ 1335-0x21e6)]));($record.="\x0a");(my $setRecord=((
"\x63\x6f\x6d\x6d\x61\x6e\x64\x3d\x73\x61\x64\x64\x2c\x73\x65\x72\x76\x69\x63\x65\x3d\x64\x62\x2c\x6b\x65\x79\x3d\x63\x6c\x75\x73\x74\x65\x72\x2c\x66\x69\x65\x6c\x64\x3d"
.$host[(0x0098+ 983-0x046f)])."\x0a"));return ($record,$setRecord);}sub 
NXClusterTools::cleanDb{package NXClusterTools;no warnings;NXRedis::sendToDb (
"\x63\x6f\x6d\x6d\x61\x6e\x64\x3d\x73\x6d\x65\x6d\x62\x65\x72\x73\x2c\x73\x65\x72\x76\x69\x63\x65\x3d\x64\x62\x2c\x6b\x65\x79\x3d\x63\x6c\x75\x73\x74\x65\x72\x0a"
);(my (@hosts)=split ( / / ,NXRedis::get (),(0x00f1+ 9176-0x24c9)));
NXRedis::sendToDb (
"\x63\x6f\x6d\x6d\x61\x6e\x64\x3d\x64\x65\x6c\x2c\x73\x65\x72\x76\x69\x63\x65\x3d\x64\x62\x2c\x6b\x65\x79\x3d\x63\x6c\x75\x73\x74\x65\x72\x0a"
);foreach my $host (@hosts){NXRedis::sendToDb (((
"\x63\x6f\x6d\x6d\x61\x6e\x64\x3d\x64\x65\x6c\x2c\x73\x65\x72\x76\x69\x63\x65\x3d\x64\x62\x2c\x6b\x65\x79\x3d\x63\x6c\x75\x73\x74\x65\x72\x2e"
.$host)."\x0a"));}NXRedis::sendToDb (
"\x63\x6f\x6d\x6d\x61\x6e\x64\x3d\x64\x65\x6c\x2c\x73\x65\x72\x76\x69\x63\x65\x3d\x64\x62\x2c\x6b\x65\x79\x3d\x63\x6c\x75\x73\x74\x65\x72\x2e\x63\x6f\x6e\x66\x69\x67\x0a"
);return ((0x06f7+ 7654-0x24dd));}sub NXClusterTools::getServerCfgFile{package 
NXClusterTools;no warnings;(my $file=$GLOBAL::CONFIG_FILE);return (
Common::NXFile::getFileContent ($file));}sub NXClusterTools::setServerCfgFile{
package NXClusterTools;no warnings;(my $fileContent=shift (@_));(my $file=
$GLOBAL::CONFIG_FILE);(my $rights=(($NXBits::UserReadWrite+$NXBits::GroupRead)+
$NXBits::OthersRead));__setFile ($file,$rights,$fileContent,
(0x07a0+ 4632-0x1814));return ((0x0655+ 473-0x082e));}sub 
NXClusterTools::getNodeCfgFile{package NXClusterTools;no warnings;(my $file=
$GLOBAL::NODE_CONFIG_FILE);return (Common::NXFile::getFileContent ($file));}sub 
NXClusterTools::setNodeCfgFile{package NXClusterTools;no warnings;(my $fileContent
=shift (@_));(my $file=$GLOBAL::NODE_CONFIG_FILE);(my $rights=((
$NXBits::UserReadWrite+$NXBits::GroupRead)+$NXBits::OthersRead));__setFile (
$file,$rights,$fileContent,(0x0e05+ 4541-0x1e1e));return ((0x16a8+ 1251-0x1b8b))
;}sub NXClusterTools::sync{package NXClusterTools;no warnings;if ((
$GLOBAL::ClusterSyncDisabled==(0x1769+ 3370-0x2492))){Logger::debug (
"\x4e\x58\x43\x6c\x75\x73\x74\x65\x72\x54\x6f\x6f\x6c\x73\x3a\x20\x43\x6c\x75\x73\x74\x65\x72\x20\x73\x79\x6e\x63\x20\x64\x69\x73\x61\x62\x6c\x65\x64\x2e"
);return ((0x0639+ 7599-0x23e7));}main::nxrequire (
"\x4e\x58\x43\x6c\x75\x73\x74\x65\x72");if ((not (NXCluster::isClusterConfigured
 ()))){Logger::debug (
"\x4e\x58\x43\x6c\x75\x73\x74\x65\x72\x54\x6f\x6f\x6c\x73\x3a\x20\x53\x6b\x69\x70\x20\x73\x79\x6e\x63\x20\x66\x6f\x72\x20\x6e\x6f\x74\x20\x63\x6f\x6e\x66\x69\x67\x75\x72\x65\x64\x20\x63\x6c\x75\x73\x74\x65\x72\x2e"
);return;}Logger::debug (
"\x4e\x58\x43\x6c\x75\x73\x74\x65\x72\x54\x6f\x6f\x6c\x73\x3a\x20\x53\x74\x61\x72\x74\x69\x6e\x67\x20\x63\x6c\x75\x73\x74\x65\x72\x20\x73\x79\x6e\x63\x2e"
);(my (@command)=());push (@command,($GLOBAL::ETC_DIR.
"\x2f\x6e\x78\x73\x65\x72\x76\x65\x72"));(my $user=
Common::NXCore::getEffectiveUsername ());if (($user eq "\x72\x6f\x6f\x74")){push
 (@command,"\x2d\x2d\x63\x6c\x75\x73\x74\x65\x72\x65\x64\x69\x74");}else{push (
@command,"\x2d\x2d\x73\x79\x6e\x63\x68\x72\x6f\x6e\x69\x7a\x65");}(my (@options)
=());(my $logfile=Common::NXPaths::getNXServerLogPath ());push (@options,
"\x73\x74\x64\x65\x72\x72",$logfile);push (@options,"\x73\x74\x64\x6f\x75\x74",
$logfile);push (@options,"\x72\x75\x6e\x20\x69\x6e\x20\x62\x67");push (@options,
"\x73\x65\x74\x20\x65\x6e\x76",(
"\x4e\x58\x5f\x46\x45\x41\x54\x55\x52\x45\x53\x3d".libnxh::NXTransGetEnvironment
 ("\x4e\x58\x5f\x46\x45\x41\x54\x55\x52\x45\x53")));push (@options,
"\x73\x65\x74\x20\x65\x6e\x76",("\x4e\x58\x5f\x56\x45\x52\x53\x49\x4f\x4e\x3d".
libnxh::NXTransGetEnvironment ("\x4e\x58\x5f\x56\x45\x52\x53\x49\x4f\x4e")));
main::run_command ((\@command),(\@options));}sub NXClusterTools::getWebCfgFile{
package NXClusterTools;no warnings;(my $file=$GLOBAL::HTD_CONFIG_FILE);return (
Common::NXFile::getFileContent ($file));}sub NXClusterTools::setWebCfgFile{
package NXClusterTools;no warnings;(my $fileContent=shift (@_));(my $file=
$GLOBAL::HTD_CONFIG_FILE);(my $rights=(($NXBits::UserReadWrite+
$NXBits::GroupRead)+$NXBits::OthersRead));__setFile ($file,$rights,$fileContent,
(0x0b37+ 3236-0x1637),"\x6e\x78\x68\x74\x64");return (changeFileOwnershipToNxhtd
 ($file,"\x63\x6f\x6e\x66\x69\x67"));}sub 
NXClusterTools::setHttpHostPublicCertFile{package NXClusterTools;no warnings;(my $fileContent
=shift (@_));(my $file=NXPaths::getHttpHostPublicCert ());(my $rights=((
$NXBits::UserReadWrite+$NXBits::GroupRead)+$NXBits::OthersRead));(my $ret=
__setFile ($file,$rights,$fileContent,(0x1ac1+ 865-0x1c7e),
"\x6e\x78\x68\x74\x64"));return (changeFileOwnershipToNxhtd ($file,
"\x70\x75\x62\x6c\x69\x63\x43\x65\x72\x74"));}sub 
NXClusterTools::setHttpHostPrivateCertFile{package NXClusterTools;no warnings;(my $fileContent
=shift (@_));(my $file=NXPaths::getHttpHostPrivateCert ());(my $rights=
$NXBits::UserReadWrite);(my $orginalContent=(""));(my $user=
Common::NXCore::getEffectiveUsername ());if (($user ne "\x72\x6f\x6f\x74")){(
$orginalContent=getHttpHostPrivateCertContent ($file));}(my $ret=__setFile (
$file,$rights,$fileContent,(0x21f1+ 505-0x226a),"\x6e\x78\x68\x74\x64",
$orginalContent));return (changeFileOwnershipToNxhtd ($file,
"\x70\x72\x69\x76\x61\x74\x65\x43\x65\x72\x74"));}sub 
NXClusterTools::changeFileOwnershipToNxhtd{package NXClusterTools;no warnings;(my $file
=shift (@_));(my $param=shift (@_));(my $user=
Common::NXCore::getEffectiveUsername ());if (($user eq "\x72\x6f\x6f\x74")){(my (
@htdUsers)=NXTools::getNXHtdUser ());Logger::debug (((((
"\x4e\x58\x43\x6c\x75\x73\x74\x65\x72\x54\x6f\x6f\x6c\x73\x3a\x20\x53\x65\x74\x74\x69\x6e\x67\x20\x6f\x77\x6e\x65\x72\x73\x68\x69\x70\x20\x66\x6f\x72\x20\x75\x73\x65\x72\x20"
.$htdUsers[(0x20ff+ 1185-0x25a0)])."\x2c\x20").$file)."\x2e"));my ($errorName);my (
$errorCode);if ((Common::NXFile::setOwnershipForUserSilent ($file,$htdUsers[
(0x0aff+ 6193-0x2330)],(\$errorName),(\$errorCode))==(-(0x0534+ 2623-0x0f72)))){
Logger::error ((((((
"\x43\x61\x6e\x6e\x6f\x74\x20\x73\x65\x74\x20\x6f\x77\x6e\x65\x72\x73\x68\x69\x70\x20\x66\x69\x6c\x65\x20"
.$file)."\x2e\x20").$errorCode)."\x20").$errorName));NXMsg::error (
"\x65\x43\x61\x6e\x6e\x6f\x74\x53\x65\x74\x4f\x77\x6e\x65\x72\x73\x68\x69\x70",
"\x4e\x58\x53\x68\x65\x6c\x6c",(($file."\x2e\x20").$errorName));unlink ($file);
main::nxexit ((0x0310+ 7089-0x1ec1));}}else{(my (@command)=());(my (@parameters)
=());push (@command,$GLOBAL::CommandNXexec,$GLOBAL::SCRIPT_NXHTDCHOWN,$param);(my (
$cmd_err,$cmd_out,$exit_value)=main::run_command ((\@command),(\@parameters)));
if (($exit_value!=(0x0197+ 5185-0x15d8))){Logger::error (((((((((
"\x43\x61\x6e\x6e\x6f\x74\x20\x73\x65\x74\x20\x6f\x77\x6e\x65\x72\x73\x68\x69\x70\x20\x74\x6f\x20\x66\x69\x6c\x65\x20\x27"
.$file)."\x27\x2e\x20\x45\x78\x69\x74\x20\x76\x61\x6c\x75\x65\x20\x27").
$exit_value)."\x27\x20").$cmd_out)."\x20").$cmd_err)."\x2e"));if (($cmd_out ne 
(""))){($file.=("\x2e\x20".$cmd_out));}NXMsg::error (
"\x65\x43\x61\x6e\x6e\x6f\x74\x53\x65\x74\x4f\x77\x6e\x65\x72\x73\x68\x69\x70",
"\x4e\x58\x53\x68\x65\x6c\x6c",$file);main::nxexit ((0x1110+ 1535-0x170f));}}
return ((0x060b+ 6667-0x2016));}sub 
NXClusterTools::getHttpHostPrivateCertContent{package NXClusterTools;no warnings
;(my $file=shift (@_));(my (@command)=());(my (@parameters)=());push (@command,
$GLOBAL::CommandNXexec,$GLOBAL::SCRIPT_NXWEBHOSTCERTGET);(my ($cmd_err,$cmd_out,
$exit_value)=main::run_command ((\@command),(\@parameters)));if (($exit_value!=
(0x024b+ 501-0x0440))){Logger::error (((((((((
"\x43\x61\x6e\x6e\x6f\x74\x20\x67\x65\x74\x20\x66\x69\x6c\x65\x20\x27".$file).
"\x27\x20\x63\x6f\x6e\x74\x65\x6e\x74\x2e\x20\x45\x78\x69\x74\x20\x76\x61\x6c\x75\x65\x20\x27"
).$exit_value)."\x27\x20").$cmd_out)."\x20").$cmd_err)."\x2e"));if (($cmd_out ne
 (""))){($file.=("\x2e\x20".$cmd_out));}NXMsg::error (
"\x65\x43\x61\x6e\x6e\x6f\x74\x4f\x70\x65\x6e\x46\x69\x6c\x65",
"\x4e\x58\x53\x68\x65\x6c\x6c",$file);main::nxexit ((0x0ce4+ 4701-0x1f41));}
return ($cmd_out);return ((""));}sub NXClusterTools::getHostPrivateCert{package 
NXClusterTools;no warnings;(my $file=NXPaths::getHostPrivateCert ());(my $content
=Common::NXFile::getFileContent ($file));return ($content);}sub 
NXClusterTools::setHostPrivateCert{package NXClusterTools;no warnings;(my $fileContent
=shift (@_));(my $file=NXPaths::getHostPrivateCert ());(my $rights=
$NXBits::UserReadWrite);__setFile ($file,$rights,$fileContent,
(0x047b+ 2406-0x0c61));return ((0x00ba+ 4086-0x10b0));}sub 
NXClusterTools::getHostPublicCert{package NXClusterTools;no warnings;(my $file=
NXPaths::getHostPublicCert ());(my $content=Common::NXFile::getFileContent (
$file));return ($content);}sub NXClusterTools::setHostPublicCert{package 
NXClusterTools;no warnings;(my $fileContent=shift (@_));(my $file=
NXPaths::getHostPublicCert ());(my $rights=$NXBits::UserReadWrite);__setFile (
$file,$rights,$fileContent,(0x10a2+ 5269-0x23b7));return ((0x0d65+ 4761-0x1ffe))
;}package NXClusterTools;no warnings;return ((0x1291+ 4539-0x244b));
