############################################################################
#                                                                          #
#  Copyright (c) 2001, 2024 NoMachine, http://www.nomachine.com.           #
#                                                                          #
#  NXSERVER, NX protocol compression and NX extensions to this software    #
#  are copyright of NoMachine. Redistribution and use of the present       #
#  software is allowed according to terms specified in the file LICENSE    #
#  which comes in the source distribution.                                 #
#                                                                          #
#  Check http://www.nomachine.com/licensing.html for applicability.        #
#                                                                          #
#  NX and NoMachine are trademarks of NoMachine S.a.r.l.                   #
#                                                                          #
#  All rights reserved.                                                    #
#                                                                          #
############################################################################
package NXFrameBuffer;no warnings;require NXVirtualSession;require 
NXClientSystemDaemons;(my $__startingXserver=(0x09db+ 3076-0x15df));(my $__nxFrameBufferRunning
=(""));(my $__error=(""));(my $__username=(""));(my $__geometry=(""));(my $__clientNotAsked
=(0x0845+ 1424-0x0dd4));($message_started=
"\x6e\x78\x46\x72\x61\x6d\x65\x42\x75\x66\x66\x65\x72\x20\x73\x74\x61\x72\x74\x65\x64"
);($message_abortedXserverFound=
"\x6e\x78\x46\x72\x61\x6d\x65\x42\x75\x66\x66\x65\x72\x20\x61\x62\x6f\x72\x74\x65\x64\x2e\x20\x52\x65\x61\x73\x6f\x6e\x3a\x20\x77\x6f\x72\x6b\x69\x6e\x67\x20\x58\x73\x65\x72\x76\x65\x72\x20\x66\x6f\x75\x6e\x64"
);($message_abortedFrameBufferRunning=
"\x6e\x78\x46\x72\x61\x6d\x65\x42\x75\x66\x66\x65\x72\x20\x61\x62\x6f\x72\x74\x65\x64\x2e\x20\x52\x65\x61\x73\x6f\x6e\x3a\x20\x66\x72\x61\x6d\x65\x20\x62\x75\x66\x66\x65\x72\x20\x61\x6c\x72\x65\x61\x64\x79\x20\x72\x75\x6e\x6e\x69\x6e\x67"
);($message_abortedFrameBufferDisabled=
"\x6e\x78\x46\x72\x61\x6d\x65\x42\x75\x66\x66\x65\x72\x20\x61\x62\x6f\x72\x74\x65\x64\x2e\x20\x52\x65\x61\x73\x6f\x6e\x3a\x20\x66\x72\x61\x6d\x65\x20\x62\x75\x66\x66\x65\x72\x20\x64\x69\x73\x61\x62\x6c\x65\x64"
);($message_abortedWrongRequest=
"\x6e\x78\x46\x72\x61\x6d\x65\x42\x75\x66\x66\x65\x72\x20\x61\x62\x6f\x72\x74\x65\x64\x2e\x20\x52\x65\x61\x73\x6f\x6e\x3a\x20\x77\x72\x6f\x6e\x67\x20\x72\x65\x71\x75\x65\x73\x74"
);($message_errorStarting=
"\x6e\x78\x46\x72\x61\x6d\x65\x42\x75\x66\x66\x65\x72\x20\x65\x72\x72\x6f\x72\x20\x77\x68\x69\x6c\x65\x20\x73\x74\x61\x72\x74\x69\x6e\x67"
);($__stateMachineInitialized=(0x1202+ 1687-0x1899));($defaultConnection=
"\x31\x32\x37\x2e\x30\x2e\x30\x2e\x31\x20\x30\x20\x31\x32\x37\x2e\x30\x2e\x30\x2e\x31\x20\x30"
);sub handleNxFrameBuffer{initializeStateMachine ();
NXShell::registerStateMachine (
"\x4e\x58\x46\x72\x61\x6d\x65\x42\x75\x66\x66\x65\x72",
"\x4e\x58\x46\x72\x61\x6d\x65\x42\x75\x66\x66\x65\x72\x3a\x3a\x72\x75\x6e",
"\x4e\x58\x46\x72\x61\x6d\x65\x42\x75\x66\x66\x65\x72\x3a\x3a\x67\x65\x74\x54\x69\x6d\x65\x6f\x75\x74"
,
"\x4e\x58\x46\x72\x61\x6d\x65\x42\x75\x66\x66\x65\x72\x3a\x3a\x69\x73\x52\x65\x61\x64\x79"
);NXShell::stopGetCommandStateMachine ();run ();return ((0x18e6+ 1168-0x1d76));}
sub initializeStateMachine{if (stateMachineInitialized ()){setCurrentState (
"\x68\x61\x6e\x64\x6c\x65\x4e\x78\x46\x72\x61\x6d\x65\x42\x75\x66\x66\x65\x72");
return ((0x0bb9+ 1942-0x134f));}initializeMessages ();addState (
"\x68\x61\x6e\x64\x6c\x65\x4e\x78\x46\x72\x61\x6d\x65\x42\x75\x66\x66\x65\x72",
"\x5f\x5f\x68\x61\x6e\x64\x6c\x65\x53\x74\x61\x74\x65\x48\x61\x6e\x64\x6c\x65\x4e\x78\x46\x72\x61\x6d\x65\x42\x75\x66\x66\x65\x72"
);addTransition (
"\x68\x61\x6e\x64\x6c\x65\x4e\x78\x46\x72\x61\x6d\x65\x42\x75\x66\x66\x65\x72",
"\x61\x73\x6b\x55\x73\x65\x72\x54\x6f\x53\x74\x61\x72\x74\x4e\x78\x46\x72\x61\x6d\x65\x42\x75\x66\x66\x65\x72"
,"\x73\x74\x61\x72\x74\x4e\x78\x46\x72\x61\x6d\x65\x42\x75\x66\x66\x65\x72");
addTransition (
"\x68\x61\x6e\x64\x6c\x65\x4e\x78\x46\x72\x61\x6d\x65\x42\x75\x66\x66\x65\x72",
"\x73\x74\x61\x72\x74\x4e\x78\x46\x72\x61\x6d\x65\x42\x75\x66\x66\x65\x72",
"\x73\x74\x61\x72\x74\x41\x75\x74\x6f\x6d\x61\x74\x69\x63\x6c\x79");
addTransition (
"\x68\x61\x6e\x64\x6c\x65\x4e\x78\x46\x72\x61\x6d\x65\x42\x75\x66\x66\x65\x72",
"\x63\x6f\x6e\x74\x69\x6e\x75\x65\x4c\x69\x73\x74\x53\x65\x73\x73\x69\x6f\x6e\x73"
,"\x73\x65\x73\x73\x69\x6f\x6e\x4c\x69\x73\x74");addState (
"\x61\x73\x6b\x55\x73\x65\x72\x54\x6f\x53\x74\x61\x72\x74\x4e\x78\x46\x72\x61\x6d\x65\x42\x75\x66\x66\x65\x72"
,
"\x5f\x5f\x68\x61\x6e\x64\x6c\x65\x53\x74\x61\x74\x65\x41\x73\x6b\x55\x73\x65\x72\x54\x6f\x53\x74\x61\x72\x74\x4e\x78\x46\x72\x61\x6d\x65\x42\x75\x66\x66\x65\x72"
);addTransition (
"\x61\x73\x6b\x55\x73\x65\x72\x54\x6f\x53\x74\x61\x72\x74\x4e\x78\x46\x72\x61\x6d\x65\x42\x75\x66\x66\x65\x72"
,"\x77\x61\x69\x74\x46\x6f\x72\x55\x73\x65\x72\x52\x65\x73\x70\x6f\x6e\x73\x65",
"\x75\x73\x65\x72\x41\x73\x6b\x65\x64");addState (
"\x77\x61\x69\x74\x46\x6f\x72\x55\x73\x65\x72\x52\x65\x73\x70\x6f\x6e\x73\x65",
"\x5f\x5f\x68\x61\x6e\x64\x6c\x65\x57\x61\x69\x74\x46\x6f\x72\x55\x73\x65\x72\x52\x65\x73\x70\x6f\x6e\x73\x65"
);addTransition (
"\x77\x61\x69\x74\x46\x6f\x72\x55\x73\x65\x72\x52\x65\x73\x70\x6f\x6e\x73\x65",
"\x73\x74\x61\x72\x74\x4e\x78\x46\x72\x61\x6d\x65\x42\x75\x66\x66\x65\x72",
"\x73\x74\x61\x72\x74\x4e\x78\x46\x72\x61\x6d\x65\x42\x75\x66\x66\x65\x72\x52\x65\x63\x65\x69\x76\x65\x64"
);addTransition (
"\x77\x61\x69\x74\x46\x6f\x72\x55\x73\x65\x72\x52\x65\x73\x70\x6f\x6e\x73\x65",
"\x73\x61\x76\x65\x4e\x78\x46\x72\x61\x6d\x65\x42\x75\x66\x66\x65\x72\x50\x61\x72\x61\x6d\x65\x74\x65\x72\x73\x49\x6e\x43\x6f\x6e\x66\x69\x67"
,
"\x73\x61\x76\x65\x4e\x78\x46\x72\x61\x6d\x65\x42\x75\x66\x66\x65\x72\x50\x61\x72\x61\x6d\x65\x74\x65\x72\x73\x49\x6e\x43\x6f\x6e\x66\x69\x67"
);addTransition (
"\x77\x61\x69\x74\x46\x6f\x72\x55\x73\x65\x72\x52\x65\x73\x70\x6f\x6e\x73\x65",
"\x63\x6f\x6e\x74\x69\x6e\x75\x65\x4c\x69\x73\x74\x53\x65\x73\x73\x69\x6f\x6e\x73"
,
"\x6e\x6f\x74\x53\x74\x61\x72\x74\x4e\x78\x46\x72\x61\x6d\x65\x42\x75\x66\x66\x65\x72"
);addTransition (
"\x77\x61\x69\x74\x46\x6f\x72\x55\x73\x65\x72\x52\x65\x73\x70\x6f\x6e\x73\x65",
"\x63\x6f\x6e\x74\x69\x6e\x75\x65\x4c\x69\x73\x74\x53\x65\x73\x73\x69\x6f\x6e\x73"
,"\x65\x72\x72\x6f\x72");setWaitInSelect (
"\x77\x61\x69\x74\x46\x6f\x72\x55\x73\x65\x72\x52\x65\x73\x70\x6f\x6e\x73\x65");
addState (
"\x73\x61\x76\x65\x4e\x78\x46\x72\x61\x6d\x65\x42\x75\x66\x66\x65\x72\x50\x61\x72\x61\x6d\x65\x74\x65\x72\x73\x49\x6e\x43\x6f\x6e\x66\x69\x67"
,
"\x5f\x5f\x68\x61\x6e\x64\x6c\x65\x53\x74\x61\x74\x65\x53\x61\x76\x65\x4e\x78\x46\x72\x61\x6d\x65\x42\x75\x66\x66\x65\x72\x50\x61\x72\x61\x6d\x65\x74\x65\x72\x73\x49\x6e\x43\x6f\x6e\x66\x69\x67"
);addTransition (
"\x73\x61\x76\x65\x4e\x78\x46\x72\x61\x6d\x65\x42\x75\x66\x66\x65\x72\x50\x61\x72\x61\x6d\x65\x74\x65\x72\x73\x49\x6e\x43\x6f\x6e\x66\x69\x67"
,"\x73\x74\x61\x72\x74\x4e\x78\x46\x72\x61\x6d\x65\x42\x75\x66\x66\x65\x72",
"\x70\x61\x72\x61\x6d\x65\x74\x65\x72\x73\x53\x61\x76\x65\x64");addState (
"\x73\x74\x61\x72\x74\x4e\x78\x46\x72\x61\x6d\x65\x42\x75\x66\x66\x65\x72",
"\x5f\x5f\x68\x61\x6e\x64\x6c\x65\x53\x74\x61\x74\x65\x53\x74\x61\x72\x74\x4e\x78\x46\x72\x61\x6d\x65\x42\x75\x66\x66\x65\x72"
);addTransition (
"\x73\x74\x61\x72\x74\x4e\x78\x46\x72\x61\x6d\x65\x42\x75\x66\x66\x65\x72",
"\x63\x6f\x6e\x74\x69\x6e\x75\x65\x4c\x69\x73\x74\x53\x65\x73\x73\x69\x6f\x6e\x73"
,"\x65\x72\x72\x6f\x72");addTransition (
"\x73\x74\x61\x72\x74\x4e\x78\x46\x72\x61\x6d\x65\x42\x75\x66\x66\x65\x72",
"\x77\x61\x69\x74\x46\x6f\x72\x53\x65\x72\x76\x65\x72\x44\x61\x65\x6d\x6f\x6e\x52\x65\x73\x70\x6f\x6e\x73\x65"
,"\x73\x65\x72\x76\x65\x72\x44\x61\x65\x6d\x6f\x6e\x41\x73\x6b\x65\x64");
addState (
"\x77\x61\x69\x74\x46\x6f\x72\x53\x65\x72\x76\x65\x72\x44\x61\x65\x6d\x6f\x6e\x52\x65\x73\x70\x6f\x6e\x73\x65"
,
"\x5f\x5f\x68\x61\x6e\x64\x6c\x65\x53\x74\x61\x74\x65\x57\x61\x69\x74\x46\x6f\x72\x53\x65\x72\x76\x65\x72\x44\x61\x65\x6d\x6f\x6e\x52\x65\x73\x70\x6f\x6e\x73\x65"
);setWaitInSelect (
"\x77\x61\x69\x74\x46\x6f\x72\x53\x65\x72\x76\x65\x72\x44\x61\x65\x6d\x6f\x6e\x52\x65\x73\x70\x6f\x6e\x73\x65"
,$GLOBAL::timeoutForServerDaemonResponseOnStartNxFrameBuffer);addTransition (
"\x77\x61\x69\x74\x46\x6f\x72\x53\x65\x72\x76\x65\x72\x44\x61\x65\x6d\x6f\x6e\x52\x65\x73\x70\x6f\x6e\x73\x65"
,
"\x63\x6f\x6e\x74\x69\x6e\x75\x65\x4c\x69\x73\x74\x53\x65\x73\x73\x69\x6f\x6e\x73"
,"\x73\x65\x73\x73\x69\x6f\x6e\x4c\x69\x73\x74");addTransition (
"\x77\x61\x69\x74\x46\x6f\x72\x53\x65\x72\x76\x65\x72\x44\x61\x65\x6d\x6f\x6e\x52\x65\x73\x70\x6f\x6e\x73\x65"
,
"\x63\x6f\x6e\x74\x69\x6e\x75\x65\x4c\x69\x73\x74\x53\x65\x73\x73\x69\x6f\x6e\x73"
,"\x65\x72\x72\x6f\x72");addState (
"\x63\x6f\x6e\x74\x69\x6e\x75\x65\x4c\x69\x73\x74\x53\x65\x73\x73\x69\x6f\x6e\x73"
,
"\x5f\x5f\x68\x61\x6e\x64\x6c\x65\x53\x74\x61\x74\x65\x43\x6f\x6e\x74\x69\x6e\x75\x65\x4c\x69\x73\x74\x53\x65\x73\x73\x69\x6f\x6e\x73"
);addTransition (
"\x63\x6f\x6e\x74\x69\x6e\x75\x65\x4c\x69\x73\x74\x53\x65\x73\x73\x69\x6f\x6e\x73"
,"\x66\x69\x6e\x69\x73\x68\x65\x64","\x66\x69\x6e\x69\x73\x68");addState (
"\x66\x69\x6e\x69\x73\x68\x65\x64",
"\x5f\x5f\x68\x61\x6e\x64\x6c\x65\x53\x74\x61\x74\x65\x46\x69\x6e\x69\x73\x68\x65\x64"
);addTransition ("\x66\x69\x6e\x69\x73\x68\x65\x64",
"\x63\x6c\x6f\x73\x65\x53\x74\x61\x74\x65\x4d\x61\x63\x68\x69\x6e\x65",
"\x63\x6c\x6f\x73\x65\x53\x74\x61\x74\x65\x4d\x61\x63\x68\x69\x6e\x65");addState
 ("\x63\x6c\x6f\x73\x65\x53\x74\x61\x74\x65\x4d\x61\x63\x68\x69\x6e\x65",
"\x5f\x5f\x68\x61\x6e\x64\x6c\x65\x53\x74\x61\x74\x65\x43\x6c\x6f\x73\x65\x53\x74\x61\x74\x65\x4d\x61\x63\x68\x69\x6e\x65"
);setFinalState (
"\x63\x6c\x6f\x73\x65\x53\x74\x61\x74\x65\x4d\x61\x63\x68\x69\x6e\x65");
setCurrentState (
"\x68\x61\x6e\x64\x6c\x65\x4e\x78\x46\x72\x61\x6d\x65\x42\x75\x66\x66\x65\x72");
setStateMachineInitialized ();}sub stateMachineInitialized{return (
$__stateMachineInitialized);}sub setStateMachineInitialized{(
$__stateMachineInitialized=(0x0c03+ 1222-0x10c8));}sub run{Logger::debug ((
"\x4e\x58\x46\x72\x61\x6d\x65\x42\x75\x66\x66\x65\x72\x20\x73\x74\x61\x74\x65\x20\x6d\x61\x63\x68\x69\x6e\x65\x3a\x20\x53\x74\x61\x72\x74\x20\x69\x6e\x20\x73\x74\x61\x74\x65\x3a\x20"
.getCurrentState ()));while (isReady ()){handleCurrentState ();}Logger::debug ((
"\x4e\x58\x46\x72\x61\x6d\x65\x42\x75\x66\x66\x65\x72\x20\x73\x74\x61\x74\x65\x20\x6d\x61\x63\x68\x69\x6e\x65\x3a\x20\x53\x74\x6f\x70\x20\x69\x6e\x20\x73\x74\x61\x74\x65\x3a\x20"
.getCurrentState ()));}sub isReady{if ((isFinalState ()==(0x063b+ 3288-0x1312)))
{return ((0x04a9+ 8186-0x24a3));}if ((isWaitingInSelect ()==
(0x0909+ 3306-0x15f2))){if ((getCurrentState ()eq 
"\x77\x61\x69\x74\x46\x6f\x72\x53\x65\x72\x76\x65\x72\x44\x61\x65\x6d\x6f\x6e\x52\x65\x73\x70\x6f\x6e\x73\x65"
)){NXShell::registerDescriptor (
"\x4e\x58\x46\x72\x61\x6d\x65\x42\x75\x66\x66\x65\x72",
NXClientSystemDaemons::getSocketToServerDaemon (),(\&callbackFromServerDaemon),
"\x4e\x58\x46\x72\x61\x6d\x65\x42\x75\x66\x66\x65\x72\x3a\x3a\x63\x61\x6c\x6c\x62\x61\x63\x6b\x46\x72\x6f\x6d\x53\x65\x72\x76\x65\x72\x44\x61\x65\x6d\x6f\x6e"
);NXShell::registerDescriptor (
"\x4e\x58\x46\x72\x61\x6d\x65\x42\x75\x66\x66\x65\x72",
NXClientSystemDaemons::getSocketToServerDaemon (),(
\&callbackFromServerDaemonClosed),
"\x4e\x58\x46\x72\x61\x6d\x65\x42\x75\x66\x66\x65\x72\x3a\x3a\x63\x61\x6c\x6c\x62\x61\x63\x6b\x46\x72\x6f\x6d\x53\x65\x72\x76\x65\x72\x44\x61\x65\x6d\x6f\x6e\x43\x6c\x6f\x73\x65\x64"
,"\x43\x6c\x6f\x73\x65");}return ((0x0405+ 7180-0x2011));}return (
(0x22eb+ 353-0x244b));}sub callbackFromServerDaemon{(my $self=shift (@_));(my $handleHash
=shift (@_));(my $readBuffer=shift (@_));(my $readBytes=shift (@_));$self->
removeAndCloseHandle ($$handleHash{"\x48\x61\x6e\x64\x6c\x65"});$self->setExit (
$handleHash,(0x0ba0+ 3380-0x18d4),(0x1293+ 4068-0x2277));Logger::debug (((
"\x4e\x58\x46\x72\x61\x6d\x65\x42\x75\x66\x66\x65\x72\x20\x73\x74\x61\x74\x65\x20\x6d\x61\x63\x68\x69\x6e\x65\x3a\x20\x52\x65\x61\x64\x20\x66\x72\x6f\x6d\x20\x74\x68\x65\x20\x73\x65\x72\x76\x65\x72\x20\x2d\x2d\x64\x61\x65\x6d\x6f\x6e\x3a\x20"
.$readBuffer)."\x2e"));if ((($readBuffer eq getMessageStarted ())or ($readBuffer
 eq getMessageFrameBufferRunning ()))){NXMsg::send_response (
"\x69\x43\x4d\x44\x58\x73\x65\x72\x76\x65\x72\x53\x74\x61\x72\x74\x65\x64",
"\x73\x65\x73\x73\x69\x6f\x6e");setNextState (
"\x73\x65\x73\x73\x69\x6f\x6e\x4c\x69\x73\x74");}elsif (($readBuffer eq 
getMessageXserverFound ())){setNextState (
"\x73\x65\x73\x73\x69\x6f\x6e\x4c\x69\x73\x74");NXMsg::send_response (
"\x69\x43\x4d\x44\x58\x73\x65\x72\x76\x65\x72\x4e\x6f\x74\x53\x74\x61\x72\x74\x65\x64\x58\x46\x6f\x75\x6e\x64"
,"\x73\x65\x73\x73\x69\x6f\x6e");}else{Logger::error ((
"\x52\x65\x63\x65\x69\x76\x65\x64\x20\x65\x72\x72\x6f\x72\x20\x66\x72\x6f\x6d\x20\x6e\x78\x73\x65\x72\x76\x65\x72\x20\x2d\x2d\x64\x61\x65\x6d\x6f\x6e\x20"
.$readBuffer));NXMsg::error (
"\x65\x47\x55\x49\x43\x61\x6e\x6e\x6f\x74\x43\x72\x65\x61\x74\x65\x4e\x65\x77\x44\x69\x73\x70\x6c\x61\x79"
,"\x73\x65\x73\x73\x69\x6f\x6e");setNextState ("\x65\x72\x72\x6f\x72");}}sub 
callbackFromServerDaemonClosed{(my $self=shift (@_));(my $handleHash=shift (@_))
;$self->removeAndCloseHandle ($$handleHash{"\x48\x61\x6e\x64\x6c\x65"});$self->
setExit ($handleHash,(0x10ba+ 2796-0x1ba6),(0x1683+ 1437-0x1c20));Logger::error 
(
"\x53\x6f\x63\x6b\x65\x74\x20\x74\x6f\x20\x74\x68\x65\x20\x73\x65\x72\x76\x65\x72\x20\x2d\x2d\x64\x61\x65\x6d\x6f\x6e\x20\x63\x6c\x6f\x73\x65\x64\x20\x75\x6e\x65\x78\x70\x65\x63\x74\x65\x64\x6c\x79"
);NXMsg::error (
"\x65\x47\x55\x49\x43\x61\x6e\x6e\x6f\x74\x43\x72\x65\x61\x74\x65\x4e\x65\x77\x44\x69\x73\x70\x6c\x61\x79"
,"\x73\x65\x73\x73\x69\x6f\x6e");setNextState ("\x65\x72\x72\x6f\x72");}sub 
getTimeout{(my $currentState=getCurrentState ());if (defined ($waitInSelect{
$currentState})){return ($waitInSelect{$currentState});}else{return (
(0x23d5+ 701-0x2692));}}sub addState{(my $stateName=shift (@_));(my $functionToHandle
=shift (@_));if (($stateName eq (""))){Logger::error (
"\x4e\x58\x46\x72\x61\x6d\x65\x42\x75\x66\x66\x65\x72\x20\x73\x74\x61\x74\x65\x20\x6d\x61\x63\x68\x69\x6e\x65\x3a\x20\x73\x74\x61\x74\x65\x20\x6e\x61\x6d\x65\x20\x63\x61\x6e\x6e\x6f\x74\x20\x62\x65\x20\x65\x6d\x70\x74\x79\x2e"
);main::nxexit ((0x1f58+ 470-0x212e));}if (($functionToHandle eq (""))){
Logger::error (
"\x4e\x58\x46\x72\x61\x6d\x65\x42\x75\x66\x66\x65\x72\x20\x73\x74\x61\x74\x65\x20\x6d\x61\x63\x68\x69\x6e\x65\x3a\x20\x66\x75\x6e\x63\x74\x69\x6f\x6e\x20\x74\x6f\x20\x68\x61\x6e\x64\x6c\x65\x20\x73\x74\x61\x74\x65\x20\x63\x61\x6e\x6e\x6f\x74\x20\x62\x65\x20\x65\x6d\x70\x74\x79\x2e"
);main::nxexit ((0x0594+ 4237-0x1621));}($states{$stateName}=$functionToHandle);
}sub addTransition{(my $beginState=shift (@_));(my $nextState=shift (@_));(my $event
=shift (@_));(my $break=shift (@_));if (($beginState eq (""))){(my ($package,
$filename,$line,$sub)=caller ((0x0932+ 1417-0x0eba)));Logger::error (((((((((
"\x4e\x58\x46\x72\x61\x6d\x65\x42\x75\x66\x66\x65\x72\x20\x73\x74\x61\x74\x65\x20\x6d\x61\x63\x68\x69\x6e\x65\x20\x61\x64\x64\x20\x74\x72\x61\x6e\x73\x69\x74\x69\x6f\x6e\x3a\x20\x62\x65\x67\x69\x6e\x20\x73\x74\x61\x74\x65\x20\x63\x61\x6e\x6e\x6f\x74\x20\x62\x65\x20\x65\x6d\x70\x74\x79\x2e\x20\x28"
.$package)."\x2c\x20").$filename)."\x2c\x20").$line)."\x2c\x20").$sub)."\x29"));
main::nxexit ((0x05c3+ 4198-0x1629));}if (($nextState eq (""))){Logger::error ((
(
"\x4e\x58\x46\x72\x61\x6d\x65\x42\x75\x66\x66\x65\x72\x20\x73\x74\x61\x74\x65\x20\x6d\x61\x63\x68\x69\x6e\x65\x20\x61\x64\x64\x20\x74\x72\x61\x6e\x73\x69\x74\x69\x6f\x6e\x20\x66\x72\x6f\x6d\x20\x73\x74\x61\x74\x65\x20"
.$beginState).
"\x3a\x20\x6e\x65\x78\x74\x20\x73\x74\x61\x74\x65\x20\x63\x61\x6e\x6e\x6f\x74\x20\x62\x65\x20\x65\x6d\x70\x74\x79\x2e"
));main::nxexit ((0x0fa3+ 4434-0x20f5));}if (($event eq (""))){Logger::error (((
"\x4e\x58\x46\x72\x61\x6d\x65\x42\x75\x66\x66\x65\x72\x20\x73\x74\x61\x74\x65\x20\x6d\x61\x63\x68\x69\x6e\x65\x20\x61\x64\x64\x20\x74\x72\x61\x6e\x73\x69\x74\x69\x6f\x6e\x20\x66\x72\x6f\x6d\x20\x73\x74\x61\x74\x65\x20"
.$beginState).
"\x3a\x20\x65\x76\x65\x6e\x74\x20\x63\x61\x6e\x6e\x6f\x74\x20\x62\x65\x20\x65\x6d\x70\x74\x79\x2e"
));main::nxexit ((0x06bb+ 7926-0x25b1));}($transition{$beginState}{$event}=
$nextState);}sub setFinalState{(my $stateName=shift (@_));($finalState{
$stateName}=(0x019a+ 3464-0x0f21));}sub setWaitInSelect{(my $stateName=shift (@_
));(my $timeout=shift (@_));if (($timeout eq (""))){($timeout="\x69\x6e\x66");}
if (($stateName eq (""))){Logger::error (
"\x4e\x58\x46\x72\x61\x6d\x65\x42\x75\x66\x66\x65\x72\x20\x73\x74\x61\x74\x65\x20\x6d\x61\x63\x68\x69\x6e\x65\x2c\x20\x77\x61\x69\x74\x20\x69\x6e\x20\x6e\x78\x73\x68\x65\x6c\x6c\x3a\x20\x73\x74\x61\x74\x65\x20\x6e\x61\x6d\x65\x20\x63\x61\x6e\x6e\x6f\x74\x20\x62\x65\x20\x65\x6d\x70\x74\x79\x2e"
);main::nxexit ((0x1045+ 2719-0x1ae4));}($waitInSelect{$stateName}=$timeout);}
sub isFinalState{(my $stateName=getCurrentState ());if (($finalState{$stateName}
ne (""))){return ((0x0b7a+ 4071-0x1b60));}}sub isWaitingInSelect{(my $stateName=
getCurrentState ());if (($waitInSelect{$stateName}ne (""))){return (
(0x0868+ 4854-0x1b5d));}return ((0x0154+ 1247-0x0633));}sub getCurrentState{
return ($currentState);}sub setCurrentState{($currentState=shift (@_));}sub 
handleCurrentState{(my $currentState=getCurrentState ());(my $functionToHandle=
$states{$currentState});if (($functionToHandle eq (""))){Logger::error (((
"\x4e\x58\x46\x72\x61\x6d\x65\x42\x75\x66\x66\x65\x72\x20\x73\x74\x61\x74\x65\x20\x6d\x61\x63\x68\x69\x6e\x65\x3a\x20\x69\x6e\x20\x73\x74\x61\x74\x65\x20"
.$currentState).
"\x3a\x20\x63\x61\x6e\x6e\x6f\x74\x20\x66\x69\x6e\x64\x20\x66\x75\x6e\x63\x74\x69\x6f\x6e\x20\x74\x6f\x20\x68\x61\x6e\x64\x6c\x65\x2e"
));main::nxexit ((0x0be8+ 320-0x0d28));}Logger::debug (((
"\x4e\x58\x46\x72\x61\x6d\x65\x42\x75\x66\x66\x65\x72\x20\x73\x74\x61\x74\x65\x20\x6d\x61\x63\x68\x69\x6e\x65\x3a\x20\x48\x61\x6e\x64\x6c\x69\x6e\x67\x20\x73\x74\x61\x74\x65\x3a\x20"
.$currentState)."\x2e"));return (\(&$functionToHandle (@_)));}sub setNextState{(my $event
=shift (@_));if (($event eq (""))){Logger::error (((
"\x4e\x58\x46\x72\x61\x6d\x65\x42\x75\x66\x66\x65\x72\x20\x73\x74\x61\x74\x65\x20\x6d\x61\x63\x68\x69\x6e\x65\x20\x69\x6e\x20\x73\x74\x61\x74\x65\x20"
.$currentState).
"\x3a\x20\x63\x61\x6e\x6e\x6f\x74\x20\x64\x65\x63\x69\x64\x65\x20\x61\x62\x6f\x75\x74\x20\x6e\x65\x77\x20\x73\x74\x61\x74\x65\x20\x77\x69\x74\x68\x20\x65\x6d\x70\x74\x79\x20\x65\x76\x65\x6e\x74\x2e"
));main::nxexit ((0x0bcc+ 723-0x0e9f));}(my $nextState=getTransition ($event));
setCurrentState ($nextState);if (isWaitingInSelect ()){($__startWait=
Common::NXTime::getSecondsSinceEpoch ());}}sub getTransition{(my $event=shift (
@_));(my $currentState=getCurrentState ());if (($currentState eq (""))){(my (
$package,$filename,$line,$sub)=caller ((0x0ee0+ 2120-0x1727)));Logger::error (((
((((((
"\x4e\x58\x46\x72\x61\x6d\x65\x42\x75\x66\x66\x65\x72\x20\x73\x74\x61\x74\x65\x20\x6d\x61\x63\x68\x69\x6e\x65\x3a\x20\x43\x61\x6e\x6e\x6f\x74\x20\x74\x72\x61\x6e\x73\x69\x74\x69\x6f\x6e\x20\x66\x72\x6f\x6d\x20\x65\x6d\x70\x74\x79\x20\x73\x74\x61\x74\x65\x2e\x20\x28"
.$package)."\x2c\x20").$filename)."\x2c\x20").$line)."\x2c\x20").$sub)."\x29"));
main::nxexit ((0x1db0+  10-0x1dba));}if (($event eq (""))){Logger::error (((
"\x4e\x58\x46\x72\x61\x6d\x65\x42\x75\x66\x66\x65\x72\x20\x73\x74\x61\x74\x65\x20\x6d\x61\x63\x68\x69\x6e\x65\x3a\x20\x43\x61\x6e\x6e\x6f\x74\x20\x67\x65\x74\x20\x74\x72\x61\x6e\x73\x69\x74\x69\x6f\x6e\x20\x66\x6f\x72\x20\x65\x6d\x70\x74\x79\x20\x65\x76\x65\x6e\x74\x20\x28"
.$currentState)."\x29\x2e"));main::nxexit ((0x0f5b+ 5514-0x24e5));}(my $nextState
=$transition{$currentState}{$event});if (($nextState eq (""))){Logger::error (((
((
"\x47\x65\x74\x20\x63\x6f\x6d\x6d\x61\x6e\x64\x20\x73\x74\x61\x74\x65\x20\x6d\x61\x63\x68\x69\x6e\x65\x3a\x20\x43\x61\x6e\x6e\x6f\x74\x20\x66\x69\x6e\x64\x20\x74\x72\x61\x6e\x73\x69\x74\x69\x6f\x6e\x20\x77\x69\x74\x68\x20\x65\x76\x65\x6e\x74\x20"
.$event)."\x20\x28").$currentState)."\x29\x2e"));main::nxexit (
(0x0146+ 9460-0x263a));}Logger::debug (((((((
"\x4e\x58\x46\x72\x61\x6d\x65\x42\x75\x66\x66\x65\x72\x20\x73\x74\x61\x74\x65\x20\x6d\x61\x63\x68\x69\x6e\x65\x3a\x20\x54\x72\x61\x6e\x73\x69\x74\x69\x6f\x6e\x20\x66\x72\x6f\x6d\x20"
.$currentState)."\x20\x77\x69\x74\x68\x20\x65\x76\x65\x6e\x74\x20").$event).
"\x20\x69\x73\x20").$nextState)."\x2e"));return ($nextState);}sub 
__handleStateSaveNxFrameBufferParametersInConfig{saveParametersInConfigFile ();
setNextState ("\x70\x61\x72\x61\x6d\x65\x74\x65\x72\x73\x53\x61\x76\x65\x64");}
sub __handleStateStartNxFrameBuffer{if ((NXClientSystemDaemons::openConnection 
()!=(0x0f51+ 4650-0x217a))){Logger::error (
"\x43\x61\x6e\x6e\x6f\x74\x20\x63\x6f\x6e\x6e\x65\x63\x74\x20\x74\x6f\x20\x6e\x78\x73\x65\x72\x76\x65\x72\x20\x2d\x2d\x64\x61\x65\x6d\x6f\x6e\x2e"
);NXMsg::error (
"\x65\x47\x55\x49\x43\x61\x6e\x6e\x6f\x74\x43\x72\x65\x61\x74\x65\x4e\x65\x77\x44\x69\x73\x70\x6c\x61\x79"
,"\x73\x65\x73\x73\x69\x6f\x6e");setNextState ("\x65\x72\x72\x6f\x72");return (
(0x0892+ 4924-0x1bce));}my ($connection);if ((libnxh::NXTransGetEnvironment (
"\x4e\x58\x5f\x43\x4f\x4e\x4e\x45\x43\x54\x49\x4f\x4e")ne (""))){($connection=
libnxh::NXTransGetEnvironment (
"\x4e\x58\x5f\x43\x4f\x4e\x4e\x45\x43\x54\x49\x4f\x4e"));}elsif ((
libnxh::NXTransGetEnvironment (
"\x53\x53\x48\x5f\x43\x4f\x4e\x4e\x45\x43\x54\x49\x4f\x4e")ne (""))){(
$connection=libnxh::NXTransGetEnvironment (
"\x53\x53\x48\x5f\x43\x4f\x4e\x4e\x45\x43\x54\x49\x4f\x4e"));}else{($connection=
$defaultConnection);}(my $message=(((((((("\x4e\x58\x3e\x20".
$GLOBAL::MSG_START_FRAME_BUFFER).
"\x20\x53\x74\x61\x72\x74\x20\x76\x69\x72\x74\x75\x61\x6c\x20\x66\x72\x61\x6d\x65\x20\x62\x75\x66\x66\x65\x72\x20\x75\x73\x65\x72\x6e\x61\x6d\x65\x3d"
).main::urlencode (getUsername ()))."\x20\x67\x65\x6f\x6d\x65\x74\x72\x79\x3d").
main::urlencode (getGeometry ())).
"\x20\x63\x6f\x6e\x6e\x65\x63\x74\x69\x6f\x6e\x3d").main::urlencode ($connection
))."\x20\x0a"));if ((NXClientSystemDaemons::sendMessage ($message)!=
(0x0ef4+ 3985-0x1e84))){Logger::error (
"\x43\x61\x6e\x6e\x6f\x74\x20\x73\x65\x6e\x64\x20\x6d\x65\x73\x73\x61\x67\x65\x20\x74\x6f\x20\x6e\x78\x73\x65\x72\x76\x65\x72\x20\x2d\x2d\x64\x61\x65\x6d\x6f\x6e\x2e"
);NXMsg::error (
"\x65\x47\x55\x49\x43\x61\x6e\x6e\x6f\x74\x43\x72\x65\x61\x74\x65\x4e\x65\x77\x44\x69\x73\x70\x6c\x61\x79"
,"\x73\x65\x73\x73\x69\x6f\x6e");setNextState ("\x65\x72\x72\x6f\x72");
NXClientSystemDaemons::closeConnection ();return ((0x14fd+ 2918-0x2063));}
setNextState (
"\x73\x65\x72\x76\x65\x72\x44\x61\x65\x6d\x6f\x6e\x41\x73\x6b\x65\x64");}sub 
__handleStateFinished{NXShell::setExitRequestCommandFinished ();
NXShell::unregisterStateMachine (
"\x4e\x58\x46\x72\x61\x6d\x65\x42\x75\x66\x66\x65\x72");
NXShell::startGetCommandStateMachine ();setNextState (
"\x63\x6c\x6f\x73\x65\x53\x74\x61\x74\x65\x4d\x61\x63\x68\x69\x6e\x65");}sub 
__handleStateHandleNxFrameBuffer{if (shouldStartNewXserver ()){Logger::debug (
"\x4e\x58\x53\x65\x73\x73\x69\x6f\x6e\x42\x75\x66\x66\x65\x72\x20\x6e\x6f\x74\x20\x72\x75\x6e\x6e\x69\x6e\x67\x2c\x20\x73\x74\x61\x72\x74\x69\x6e\x67\x20\x61\x75\x74\x6f\x6d\x61\x74\x69\x63\x6c\x79\x2e"
);setNextState (
"\x73\x74\x61\x72\x74\x41\x75\x74\x6f\x6d\x61\x74\x69\x63\x6c\x79");return (
(0x0c5d+ 4506-0x1df7));}if ((NXSession2::getNumberOfRunningSessionsFound ()==
(0x1239+ 2416-0x1ba9))){if ((Server::isClientSupportingNxFrameBufferFeature ()
and clientNotAsked ())){setNextState (
"\x73\x74\x61\x72\x74\x4e\x78\x46\x72\x61\x6d\x65\x42\x75\x66\x66\x65\x72");
return ((0x1dd9+ 404-0x1f6d));}}else{if ((checkIsNxFrameBufferSessionsReady ()==
(0x041b+ 6572-0x1dc6))){Logger::debug (
"\x4e\x58\x53\x65\x73\x73\x69\x6f\x6e\x42\x75\x66\x66\x65\x72\x20\x69\x73\x20\x72\x75\x6e\x6e\x69\x6e\x67\x2e"
);NXMsg::send_response (
"\x69\x43\x4d\x44\x58\x73\x65\x72\x76\x65\x72\x53\x74\x61\x72\x74\x65\x64",
"\x73\x65\x73\x73\x69\x6f\x6e");}}setNextState (
"\x73\x65\x73\x73\x69\x6f\x6e\x4c\x69\x73\x74");}sub 
__handleStateAskUserToStartNxFrameBuffer{NXMsg::send_response (
"\x69\x43\x4d\x44\x41\x73\x6b\x49\x66\x43\x72\x65\x61\x74\x65\x58\x73\x65\x72\x76\x65\x72"
,"\x73\x65\x73\x73\x69\x6f\x6e");setClientAsked ();setNextState (
"\x75\x73\x65\x72\x41\x73\x6b\x65\x64");}sub 
__handleStateWaitForServerDaemonResponse{();}sub 
__handleStateContinueListSessions{main::nxrequire (
"\x4e\x58\x53\x65\x73\x73\x69\x6f\x6e\x4c\x69\x73\x74");
NXSessionList::continueListSessionsAfterNxFrameBufferHandling ();setNextState (
"\x66\x69\x6e\x69\x73\x68");}sub handleNxFrameBufferStart{(my (@param)=$_[
(0x067d+ 6419-0x1f90)]);(my (%parameters)=());if ((scalar (@param)eq 
(0x0259+ 1561-0x0871))){((%parameters)=NXShell::urlParameter2Hash (
NXShell::getLastParameters ($_[(0x18a0+ 1239-0x1d77)])));}else{((%parameters)=
@param);}NXShell::stopGetCommandStateMachine ();if (defined ($parameters{
"\x6f\x70\x74\x69\x6f\x6e"})){(my $option=$parameters{"\x6f\x70\x74\x69\x6f\x6e"
});(my $username=NXLogin::getCurrentUser ());(my $geometry=$parameters{
"\x67\x65\x6f\x6d\x65\x74\x72\x79"});setUsername ($username);setGeometry (
$geometry);Logger::debug (((((((
"\x48\x61\x6e\x64\x6c\x69\x6e\x67\x20\x78\x73\x65\x72\x76\x65\x72\x73\x74\x61\x72\x74\x20\x77\x69\x74\x68\x20\x6f\x70\x74\x69\x6f\x6e\x20"
.$option)."\x20\x66\x6f\x72\x20\x75\x73\x65\x72\x20").$username).
"\x20\x77\x69\x74\x68\x20\x67\x65\x6f\x6d\x65\x74\x72\x79\x20").$geometry).
"\x2e"));if (($option eq "\x79\x65\x73")){setNextState (
"\x73\x74\x61\x72\x74\x4e\x78\x46\x72\x61\x6d\x65\x42\x75\x66\x66\x65\x72\x52\x65\x63\x65\x69\x76\x65\x64"
);run ();return ((0x0c42+ 2426-0x15bc));}elsif (($option eq 
"\x61\x6c\x77\x61\x79\x73")){setNextState (
"\x73\x61\x76\x65\x4e\x78\x46\x72\x61\x6d\x65\x42\x75\x66\x66\x65\x72\x50\x61\x72\x61\x6d\x65\x74\x65\x72\x73\x49\x6e\x43\x6f\x6e\x66\x69\x67"
);run ();return ((0x0a03+ 6315-0x22ae));}}else{Logger::error (((
"\x57\x72\x6f\x6e\x67\x20\x78\x73\x65\x72\x76\x65\x72\x73\x74\x61\x72\x74\x20\x70\x61\x72\x61\x6d\x65\x74\x65\x72\x73\x20"
.join ($",@param))."\x2e"));NXMsg::error (
"\x65\x47\x55\x49\x43\x61\x6e\x6e\x6f\x74\x43\x72\x65\x61\x74\x65\x4e\x65\x77\x44\x69\x73\x70\x6c\x61\x79"
,"\x73\x65\x73\x73\x69\x6f\x6e");setNextState ("\x65\x72\x72\x6f\x72");run ();
return ((0x13e2+ 2448-0x1d72));}setNextState (
"\x6e\x6f\x74\x53\x74\x61\x72\x74\x4e\x78\x46\x72\x61\x6d\x65\x42\x75\x66\x66\x65\x72"
);run ();}sub handleRequestToStartNxFrameBuffer{(my $socket=shift (@_));(my $request
=shift (@_));Logger::debug (((
"\x4e\x58\x46\x72\x61\x6d\x65\x42\x75\x66\x66\x65\x72\x20\x68\x61\x6e\x64\x6c\x69\x6e\x67\x20\x72\x65\x71\x75\x65\x73\x74\x20\x27"
.$request)."\x27\x2e"));(my $message=(""));if (($request=~ /Start virtual frame buffer username=(.*) geometry=(.*) connection=(.*)/ )
){(my $username=main::urldecode ($1));(my $geometry=main::urldecode ($2));(my $connection
=main::urldecode ($3));Logger::debug (
"\x4e\x58\x46\x72\x61\x6d\x65\x42\x75\x66\x66\x65\x72\x20\x63\x68\x65\x63\x6b\x69\x6e\x67\x20\x69\x66\x20\x73\x68\x6f\x75\x6c\x64\x20\x73\x74\x61\x72\x74\x20\x66\x72\x61\x6d\x65\x20\x62\x75\x66\x66\x65\x72\x2e"
);(my ($requestCanBeHandled,$errorMessage)=checkRequestCouldBeHandled ());if (
$requestCanBeHandled){Logger::debug (((
"\x4e\x58\x46\x72\x61\x6d\x65\x42\x75\x66\x66\x65\x72\x20\x73\x74\x61\x72\x74\x69\x6e\x67\x20\x66\x6f\x72\x20\x75\x73\x65\x72\x20"
.$username)."\x2e"));($errorMessage=(""));if (handleStartNxFrameBuffer (
$username,$geometry,$connection,(\$errorMessage))){($message=$message_started);}
else{if (($errorMessage ne (""))){($message=$errorMessage);}else{($message=
$message_errorStarting);}}}else{($message=$errorMessage);}}else{Logger::warning 
(((
"\x4e\x58\x46\x72\x61\x6d\x65\x42\x75\x66\x66\x65\x72\x20\x77\x72\x6f\x6e\x67\x20\x72\x65\x71\x75\x65\x73\x74\x20\x27"
.$request)."\x27\x2e"));($message=$message_abortedWrongRequest);}main::nxwrite (
$socket,$message);}sub checkRequestCouldBeHandled{if (
NXLocalSession::anyXserverFound ()){Logger::debug (
"\x4e\x58\x46\x72\x61\x6d\x65\x42\x75\x66\x66\x65\x72\x20\x61\x62\x6f\x72\x74\x20\x73\x74\x61\x72\x74\x69\x6e\x67\x20\x66\x72\x61\x6d\x65\x20\x62\x75\x66\x66\x65\x72\x3a\x20\x58\x73\x65\x72\x76\x65\x72\x20\x66\x6f\x75\x6e\x64\x2e"
);return ((0x0777+ 4430-0x18c5),$message_abortedXserverFound);}elsif (
NXSession2::checkIsAnyNxFrameBufferSessionsRunning ()){Logger::debug (
"\x4e\x58\x46\x72\x61\x6d\x65\x42\x75\x66\x66\x65\x72\x20\x61\x62\x6f\x72\x74\x20\x73\x74\x61\x72\x74\x69\x6e\x67\x20\x66\x72\x61\x6d\x65\x20\x62\x75\x66\x66\x65\x72\x3a\x20\x6f\x74\x68\x65\x72\x20\x66\x72\x61\x6d\x65\x20\x62\x75\x66\x66\x65\x72\x20\x72\x75\x6e\x6e\x69\x6e\x67\x2e"
);return ((0x0c2f+ 4577-0x1e10),$message_abortedFrameBufferRunning);}elsif ((not
 (NXLicense::isNxFrameBufferFeature ()))){Logger::debug (
"\x4e\x58\x46\x72\x61\x6d\x65\x42\x75\x66\x66\x65\x72\x20\x61\x62\x6f\x72\x74\x20\x73\x74\x61\x72\x74\x69\x6e\x67\x20\x66\x72\x61\x6d\x65\x20\x62\x75\x66\x66\x65\x72\x3a\x20\x66\x72\x61\x6d\x65\x20\x62\x75\x66\x66\x65\x72\x20\x64\x69\x73\x61\x62\x6c\x65\x64\x2e"
);return ((0x2382+ 671-0x2621),$message_abortedFrameBufferDisabled);}else{return
 ((0x06a2+ 3744-0x1541),(""));}}sub setNxFrameBufferRunning{(
$__nxFrameBufferRunning=shift (@_));}sub isNxFrameBufferRunning{if ((
$__nxFrameBufferRunning ne (""))){if (NXSession2::existSession (
$__nxFrameBufferRunning)){return ((0x0175+ 8644-0x2338));}(
$__nxFrameBufferRunning=(""));}return ((0x0e60+ 4197-0x1ec5));}sub 
shouldStartNewXserver{if (isNxFrameBufferRunning ()){return (
(0x049c+ 5549-0x1a49));}if (NXLicense::isNxFrameBufferFeature ()){if ((
$GLOBAL::CreateDisplay==(0x10eb+ 3184-0x1d5a))){return ((0x2402+ 502-0x25f7));}
return ((0x1239+ 701-0x14f6));}else{return ((0x0597+ 1569-0x0bb8));}}sub 
handleStartNxFrameBuffer{(my $username=shift (@_));(my $geometry=shift (@_));(my $connection
=shift (@_));(my $ref_error=shift (@_));if (($username eq (""))){($username=
getUsername ());}if (($geometry eq (""))){($geometry=getGeometry ());}
Logger::debug (
"\x53\x74\x61\x72\x74\x69\x6e\x67\x20\x6e\x65\x77\x20\x58\x73\x65\x72\x76\x65\x72\x2e"
);(my $sessionParameters=
NXSessionParameters::getParametersForNxFrameBufferServer ($username,$geometry));
(my $assignedDisplay=NXVirtualSession::startSessionForUserAndWaitForConnected (
$sessionParameters,$ref_error,$connection));if (($assignedDisplay!=(-
(0x0f62+ 3333-0x1c66)))){(my (@sessions)=NXSession2::getSessionIDsByDisplay (
$assignedDisplay));setNxFrameBufferRunning (@sessions[(0x012a+ 1793-0x082b)]);
return ((0x23b0+ 497-0x25a0));}else{Logger::error (
"\x4e\x58\x46\x72\x61\x6d\x65\x42\x75\x66\x66\x65\x72\x20\x66\x61\x69\x6c\x65\x64\x20\x74\x6f\x20\x73\x74\x61\x72\x74\x2e"
);if (($$ref_error ne (""))){Logger::error ((
"\x52\x65\x63\x65\x69\x76\x65\x64\x20\x65\x72\x72\x6f\x72\x20\x6d\x65\x73\x73\x61\x67\x65\x20\x66\x72\x6f\x6d\x20\x6e\x78\x73\x65\x72\x76\x65\x72\x20"
.$$ref_error));}return ((0x1825+ 1029-0x1c2a));}}sub 
handleStartNxFrameBufferAutomatically{(my $username=getUsername ());(my $geometry
=getGeometry ());(my $connection=$defaultConnection);return (
handleStartNxFrameBuffer ($username,$geometry,$connection));}sub 
checkIsNxFrameBufferSessionsReady{(my (@sessions)=NXSession2::getSessionsByType 
(Common::NXSessionType::getNXFrameBuffer ()));foreach my $session (@sessions){if
 (NXSession2::sessionIsAliveByStatus (NXSession2::getStatusBySessionId ($session
))){(my ($display,$cookie)=NXSession2::getAgentMDisplayAndCookieBySessionId (
$session));if (defined ($display)){Logger::debug (
"\x4e\x58\x46\x72\x61\x6d\x65\x42\x75\x66\x66\x65\x72\x20\x73\x65\x73\x73\x69\x6f\x6e\x20\x69\x73\x20\x72\x65\x61\x64\x79\x2e"
);return ((0x0888+ 4330-0x1971));}return ((0x0575+ 4284-0x1631));}}}sub setError
{(my $error=shift (@_));($__error=$error);}sub getError{return ($__error);}sub 
setUsername{($__username=shift (@_));}sub setGeometry{($__geometry=shift (@_));}
sub getUsername{if ((defined ($__username)and ($__username ne ("")))){return (
$__username);}else{return ($GLOBAL::DisplayOwner);}}sub getGeometry{if ((defined
 ($__geometry)and ($__geometry ne ("")))){return ($__geometry);}elsif ((
$GLOBAL::DisplayGeometry eq (""))){return ("\x31\x32\x38\x30\x78\x38\x30\x30");}
else{return ($GLOBAL::DisplayGeometry);}}sub clientNotAsked{return (
$__clientNotAsked);}sub setClientAsked{($__clientNotAsked=(0x01b4+ 2556-0x0bb0))
;}sub getMessageStarted{return ($message_started);}sub getMessageXserverFound{
return ($message_abortedXserverFound);}sub getMessageFrameBufferRunning{return (
$message_abortedFrameBufferRunning);}sub saveParametersInConfigFile{(my $username
=getUsername ());(my $geometry=getGeometry ());main::changeServerCfgKey (
"\x44\x69\x73\x70\x6c\x61\x79\x4f\x77\x6e\x65\x72",$username);
main::changeServerCfgKey (
"\x44\x69\x73\x70\x6c\x61\x79\x47\x65\x6f\x6d\x65\x74\x72\x79",$geometry);
main::changeServerCfgKey ("\x43\x72\x65\x61\x74\x65\x44\x69\x73\x70\x6c\x61\x79"
,(0x049b+ 2480-0x0e4a));}sub initializeMessages{NXMsg::register_response (
"\x73\x65\x73\x73\x69\x6f\x6e",
"\x69\x43\x4d\x44\x41\x73\x6b\x49\x66\x43\x72\x65\x61\x74\x65\x58\x73\x65\x72\x76\x65\x72"
,(0x05e8+ 6616-0x1f2b));NXMsg::register_response ("\x73\x65\x73\x73\x69\x6f\x6e"
,"\x69\x43\x4d\x44\x58\x73\x65\x72\x76\x65\x72\x53\x74\x61\x72\x74\x65\x64",
(0x24d8+ 212-0x2516));NXMsg::register_response ("\x73\x65\x73\x73\x69\x6f\x6e",
"\x69\x43\x4d\x44\x58\x73\x65\x72\x76\x65\x72\x4e\x6f\x74\x53\x74\x61\x72\x74\x65\x64\x58\x46\x6f\x75\x6e\x64"
,(0x0159+ 4514-0x1264));NXMsg::register_error ("\x73\x65\x73\x73\x69\x6f\x6e",
"\x65\x47\x55\x49\x43\x61\x6e\x6e\x6f\x74\x43\x72\x65\x61\x74\x65\x4e\x65\x77\x44\x69\x73\x70\x6c\x61\x79"
,(0x0306+ 1044-0x0526));NXMsg::register_error ("\x73\x65\x73\x73\x69\x6f\x6e",
"\x65\x47\x55\x49\x57\x72\x6f\x6e\x67\x58\x73\x65\x72\x76\x65\x72\x53\x74\x61\x72\x74\x43\x6f\x6d\x6d\x61\x6e\x64"
,(0x0933+ 1624-0x0d97));}return ((0x0477+ 6725-0x1ebb));
