############################################################################
#                                                                          #
#  Copyright (c) 2001, 2024 NoMachine, http://www.nomachine.com.           #
#                                                                          #
#  NXSERVER, NX protocol compression and NX extensions to this software    #
#  are copyright of NoMachine. Redistribution and use of the present       #
#  software is allowed according to terms specified in the file LICENSE    #
#  which comes in the source distribution.                                 #
#                                                                          #
#  Check http://www.nomachine.com/licensing.html for applicability.        #
#                                                                          #
#  NX and NoMachine are trademarks of NoMachine S.a.r.l.                   #
#                                                                          #
#  All rights reserved.                                                    #
#                                                                          #
############################################################################
package NXLogrotate;no warnings;($__timeoutForFileReleasedCheck=
(0x133a+ 4021-0x22e0));($__sleepTimeBetweenFileReleaseChecks=0.2);(
$__checkLogrotateDelay=(0x1e0b+ 3133-0x26c4));($__lastCheckLogrotate=
(0x00ea+ 1333-0x061f));($__nxhtdErrorLogPath=(""));($__forcedRotate=
(0x13b3+ 1851-0x1aee));($__forcedRotateDateTime=(""));((
%__ref_forcedRotateParameters)=());((%threadHandles)=());sub 
__rotateTillOriginalFile{(my $type=shift (@_));(my $rotatedName=shift (@_));(my $rotationDir
=NXLogrotateDB::getDestination ($type));(my $maxRotation=
NXLogrotateDB::getRotate ($type));(my $prevRotatedFile=((($rotationDir.
$GLOBAL::DIRECTORY_SLASH).($rotatedName."\x2e")).($maxRotation+
(0x0472+ 566-0x06a7))));if (NXLogrotateDB::isCompressSet ($type)){(
$prevRotatedFile=($prevRotatedFile."\x2e\x67\x7a"));}for ((my $i=$maxRotation);(
$i>(0x0028+ 2534-0x0a0e));(--$i)){(my $curRotatedFile=((($rotationDir.
$GLOBAL::DIRECTORY_SLASH).($rotatedName."\x2e")).$i));if (
NXLogrotateDB::isCompressSet ($type)){($curRotatedFile=($curRotatedFile.
"\x2e\x67\x7a"));}if (Common::NXFile::fileExists ($curRotatedFile)){($result=
Common::NXFile::renameFile ($curRotatedFile,$prevRotatedFile));if (($result==
(0x0513+ 5402-0x1a2d))){NXMsg::error (
"\x65\x43\x61\x6e\x6e\x6f\x74\x52\x65\x6e\x61\x6d\x65\x46\x69\x6c\x65",
"\x4e\x58\x4c\x6f\x67\x72\x6f\x74\x61\x74\x65",$curRotatedFile,$prevRotatedFile)
;return ((0x17b4+ 1195-0x1c5f));}}($prevRotatedFile=$curRotatedFile);}return (
(0x0a1c+ 2676-0x148f));}sub __copyTruncate{(my $type=shift (@_));(my $path=shift
 (@_));(my $rotatedName=shift (@_));(my $destFilePath=
__getRotatedLogFilePathByLogType ($type,$rotatedName));(my $result=__copyLogFile
 ($path,$destFilePath));if (($result==(0x064f+ 8252-0x268b))){return (
(0x1719+ 3538-0x24eb));}return (__truncateFile ($path));}sub __removeExpiredLogs
{(my $type=shift (@_));(my $rotatedName=shift (@_));(my $rotationDir=
NXLogrotateDB::getDestination ($type));(my $maxRotation=NXLogrotateDB::getRotate
 ($type));(my $fileToRemove=((($rotationDir.$GLOBAL::DIRECTORY_SLASH).(
$rotatedName."\x2e")).($maxRotation+(0x09e4+ 2354-0x1315))));if (
NXLogrotateDB::isCompressSet ($type)){($fileToRemove=($fileToRemove.
"\x2e\x67\x7a"));}if (Common::NXFile::fileExists ($fileToRemove)){return (
Common::NXFile::removeFile ($fileToRemove));}return ((0x06fc+ 7642-0x24d5));}sub
 forcedRotate{(my $ref_parameters=shift (@_));(my $result=
__handleForcedRotateParameters ($ref_parameters));if (($result==
(0x1a2c+ 2758-0x24f2))){return ((0x060a+ 4318-0x16e8));}if (($$ref_parameters{
"\x74\x79\x70\x65"}and (not (isLogTypeSupported ($$ref_parameters{
"\x74\x79\x70\x65"}))))){(my (@supportedTypes)=getAllSupportedLogrotateLogTypes 
());NXMsg::error (
"\x65\x43\x4d\x44\x4c\x6f\x67\x72\x6f\x74\x61\x74\x65\x54\x79\x70\x65\x4e\x6f\x74\x53\x75\x70\x70\x6f\x72\x74\x65\x64"
,"\x4e\x58\x4c\x6f\x67\x72\x6f\x74\x61\x74\x65",$$ref_parameters{
"\x74\x79\x70\x65"},join ($",@supportedTypes));return ((0x0631+ 496-0x0821));}(my $dateTime
=Common::NXTime::getDateTimeForFileName ());__setForcedRotateDateTime ($dateTime
);__setForcedRotate ();return (rotate ($$ref_parameters{"\x74\x79\x70\x65"}));}
sub rotate{(my $type=(shift (@_)||("")));Logger::debug (
"\x4e\x58\x4c\x6f\x67\x72\x6f\x74\x61\x74\x65\x3a\x20\x53\x74\x61\x72\x74\x69\x6e\x67\x20\x6c\x6f\x67\x20\x72\x6f\x74\x61\x74\x65\x20\x70\x72\x6f\x63\x65\x64\x75\x72\x65\x2e"
);NXMsg::send_response (
"\x69\x43\x4d\x44\x53\x74\x61\x72\x74\x69\x6e\x67\x4c\x6f\x67\x72\x6f\x74\x61\x74\x65"
,"\x4e\x58\x4c\x6f\x67\x72\x6f\x74\x61\x74\x65");if (($type ne (""))){
__rotateByLogType ($type);}else{rotateAllLogFiles ();}Logger::debug (
"\x4e\x58\x4c\x6f\x67\x72\x6f\x74\x61\x74\x65\x3a\x20\x4c\x6f\x67\x20\x72\x6f\x74\x61\x74\x69\x6f\x6e\x20\x70\x72\x6f\x63\x65\x64\x75\x72\x65\x20\x68\x61\x73\x20\x66\x69\x6e\x69\x73\x68\x65\x64\x2e"
);}sub rotateAllLogFiles{main::nxrequire (
"\x4e\x58\x4c\x6f\x67\x72\x6f\x74\x61\x74\x65\x44\x42","\x69\x6e\x69\x74");(my (
@availableTypes)=());if (__isForcedRotate ()){(@availableTypes=
getAllSupportedLogrotateLogTypes ());}else{(@availableTypes=
NXLogrotateDB::getLogTypes ());}foreach my $availableType (@availableTypes){if (
__shouldSkipMultiTypeLogrotateForType ($availableType)){next;}__rotateByLogType 
($availableType);}}sub __rotateByLogType{(my $type=shift (@_));Logger::debug (((
"\x4e\x58\x4c\x6f\x67\x72\x6f\x74\x61\x74\x65\x3a\x20\x53\x74\x61\x72\x74\x69\x6e\x67\x20\x6c\x6f\x67\x20\x72\x6f\x74\x61\x74\x65\x20\x70\x72\x6f\x63\x65\x64\x75\x72\x65\x20\x66\x6f\x72\x20\x27"
.$type)."\x27\x2e"));if (__isNotForcedRotate ()){main::nxrequire (
"\x4e\x58\x4c\x6f\x67\x72\x6f\x74\x61\x74\x65\x44\x42","\x69\x6e\x69\x74");if (
NXLogrotateDB::isNotLogrotateExist ($type)){Logger::error ((((
"\x4e\x58\x4c\x6f\x67\x72\x6f\x74\x61\x74\x65\x3a\x20\x4c\x6f\x67\x20\x72\x6f\x74\x61\x74\x69\x6f\x6e\x20\x70\x72\x6f\x63\x65\x64\x75\x72\x65\x20\x66\x6f\x72\x20\x27"
.$type)."\x27\x20\x68\x61\x73\x20\x66\x61\x69\x6c\x65\x64\x2e\x20").
"\x4c\x6f\x67\x20\x74\x79\x70\x65\x20\x69\x73\x20\x6e\x6f\x74\x20\x65\x6e\x61\x62\x6c\x65\x64\x20\x66\x6f\x72\x20\x6c\x6f\x67\x20\x72\x6f\x74\x61\x74\x69\x6f\x6e\x2e"
));NXMsg::error (
"\x65\x43\x4d\x44\x4c\x6f\x67\x72\x6f\x74\x61\x74\x65\x44\x6f\x65\x73\x4e\x6f\x74\x45\x78\x69\x73\x74"
,"\x4e\x58\x4c\x6f\x67\x72\x6f\x74\x61\x74\x65\x44\x42",$type);NXMsg::error (
"\x65\x43\x4d\x44\x4c\x6f\x67\x72\x6f\x74\x61\x74\x65\x46\x61\x69\x6c\x65\x64",
"\x4e\x58\x4c\x6f\x67\x72\x6f\x74\x61\x74\x65",$type);return (
(0x0a99+ 5117-0x1e96));}}($result=__rotateFilesByLogType ($type));if (($result==
(0x1489+ 4507-0x2624))){Logger::error (((
"\x4e\x58\x4c\x6f\x67\x72\x6f\x74\x61\x74\x65\x3a\x20\x4c\x6f\x67\x20\x72\x6f\x74\x61\x74\x69\x6f\x6e\x20\x70\x72\x6f\x63\x65\x64\x75\x72\x65\x20\x66\x6f\x72\x20\x27"
.$type)."\x27\x20\x68\x61\x73\x20\x66\x61\x69\x6c\x65\x64\x2e"));NXMsg::error (
"\x65\x43\x4d\x44\x4c\x6f\x67\x72\x6f\x74\x61\x74\x65\x46\x61\x69\x6c\x65\x64",
"\x4e\x58\x4c\x6f\x67\x72\x6f\x74\x61\x74\x65",$type);}else{Logger::debug (((
"\x4e\x58\x4c\x6f\x67\x72\x6f\x74\x61\x74\x65\x3a\x20\x4c\x6f\x67\x20\x72\x6f\x74\x61\x74\x69\x6f\x6e\x20\x70\x72\x6f\x63\x65\x64\x75\x72\x65\x20\x66\x6f\x72\x20\x27"
.$type).
"\x27\x20\x68\x61\x73\x20\x66\x69\x6e\x69\x73\x68\x65\x64\x20\x73\x75\x63\x63\x65\x73\x73\x66\x75\x6c\x6c\x79\x2e"
));NXMsg::send_response (
"\x69\x43\x4d\x44\x4c\x6f\x67\x72\x6f\x74\x61\x74\x65\x46\x69\x6e\x69\x73\x68\x65\x64"
,"\x4e\x58\x4c\x6f\x67\x72\x6f\x74\x61\x74\x65",$type);}return ($result);}sub 
__getUserLogFilePathsByType{(my $type=shift (@_));(my $ref_filePaths=shift (@_))
;(my (@filePaths)=());(my (%users)=
NXUsersManager::userListIncludingInternalDMUsers ());foreach my $user (keys (
%users)){if (NXUsersManager::isDMUser ($user)){($user=
NXUsersManager::getRealDMUsername ($user));}(my $fileName=__getFilenameByLogType
 ($type));(my $path=((Common::NXPaths::getNxDirectoryInUserHomeDirectory ($user)
.$GLOBAL::DIRECTORY_SLASH).$fileName));(my $rotatedName=($fileName.("\x2d".$user
)));($$ref_filePaths{$rotatedName}=$path);}}sub 
__getSpecialUserLogFilePathByType{(my $type=shift (@_));(my $ref_filePaths=shift
 (@_));(my $fileName=__getFilenameByLogType ($type));(my $path=((
Common::NXPaths::getSpecialUsersLogFolderPath ().$GLOBAL::DIRECTORY_SLASH).
$fileName));($$ref_filePaths{$fileName}=$path);}sub __getFilePathsByLogType{(my $type
=shift (@_));(my (%filePaths)=());if (($type eq 
Logger::getLogrotateLogTypeNxserverLog ())){if (($GLOBAL::CommonLogDirectory ne 
(""))){(my $fileName=__getFilenameByLogType ($type));(my $rotateFileName=(
$fileName."\x2d\x63\x6f\x6d\x6d\x6f\x6e"));($filePaths{$rotateFileName}=((
$GLOBAL::CommonLogDirectory.$GLOBAL::DIRECTORY_SLASH).$fileName));}else{
__getUserLogFilePathsByType ($type,(\%filePaths));
__getSpecialUserLogFilePathByType ($type,(\%filePaths));}}else{(my $fileName=
__getFilenameByLogType ($type));($filePaths{$fileName}=__getFilePathByLogType (
$type));}return (%filePaths);}sub __rotateFilesByLogType{(my $type=shift (@_));(my $ref_filePaths
=shift (@_));(my $silent=(shift (@_)||(0x1365+ 1619-0x19b8)));(my (%filePaths)=
());if (__isNotForcedRotate ()){((%filePaths)=%$ref_filePaths);}else{((
%filePaths)=__getFilePathsByLogType ($type));}(my $filesCount=
(0x078d+ 2317-0x109a));(my $noExistPath=(""));(my $result=(0x04ea+ 5791-0x1b88))
;foreach my $rotatedName (keys (%filePaths)){(my $path=$filePaths{$rotatedName})
;if ((not (Common::NXFile::fileExists ($path)))){($noExistPath=$path);next;}(++
$filesCount);($result=__rotateWithCopytruncate ($type,$path,$rotatedName));if ((
$result!=(0x0a79+ 900-0x0dfd))){($result=__postRotate ($type,$rotatedName,
$silent));}}if (($filesCount==(0x0cf4+ 4892-0x2010))){if ((scalar (@filePaths)>
(0x03bd+ 6788-0x1e40))){Logger::error ((((
"\x4e\x58\x4c\x6f\x67\x72\x6f\x74\x61\x74\x65\x3a\x20\x4c\x6f\x67\x20\x72\x6f\x74\x61\x74\x69\x6f\x6e\x20\x70\x72\x6f\x63\x65\x64\x75\x72\x65\x20\x66\x6f\x72\x20\x27"
.$type)."\x27\x20\x68\x61\x73\x20\x66\x61\x69\x6c\x65\x64\x2e\x20").
"\x4e\x6f\x20\x6c\x6f\x67\x20\x66\x69\x6c\x65\x73\x20\x66\x6f\x75\x6e\x64\x2e"))
;}else{Logger::error ((((
"\x4e\x58\x4c\x6f\x67\x72\x6f\x74\x61\x74\x65\x3a\x20\x4c\x6f\x67\x20\x72\x6f\x74\x61\x74\x69\x6f\x6e\x20\x70\x72\x6f\x63\x65\x64\x75\x72\x65\x20\x66\x6f\x72\x20\x27"
.$type)."\x27\x20\x68\x61\x73\x20\x66\x61\x69\x6c\x65\x64\x2e\x20").((
"\x4c\x6f\x67\x20\x66\x69\x6c\x65\x20\x27".$path).
"\x27\x20\x64\x6f\x65\x73\x20\x6e\x6f\x74\x20\x65\x78\x69\x73\x74\x2e")));if ((
$silent==(0x07e9+ 4030-0x17a7))){Common::NXMsg::error (
"\x65\x46\x69\x6c\x65\x4e\x6f\x74\x45\x78\x69\x73\x74",$noExistPath);}}if ((
$silent==(0x16ad+ 3886-0x25db))){NXMsg::error (
"\x65\x43\x4d\x44\x4c\x6f\x67\x72\x6f\x74\x61\x74\x65\x46\x61\x69\x6c\x65\x64",
"\x4e\x58\x4c\x6f\x67\x72\x6f\x74\x61\x74\x65",$noExistPath);}return (
(0x1a2f+ 1216-0x1eef));}return ($result);}sub __postRotate{(my $type=shift (@_))
;(my $rotatedName=shift (@_));(my $silent=shift (@_));if (((__isForcedRotate ()
and __isForcedRotateCompress ())or ((not (__isForcedRotate ()))and 
NXLogrotateDB::isCompressSet ($type)))){(my $rotatedFile=
__getRotatedLogFilePathByLogType ($type,$rotatedName));($result=__compressFile (
$rotatedFile,$silent));if (($result==(0x1e28+ 162-0x1eca))){return (
(0x0acd+ 4435-0x1c20));}Common::NXFile::removeFile ($rotatedFile);}return (
(0x0461+ 4701-0x16bd));}sub __rotateWithCopytruncate{(my $type=shift (@_));(my $path
=shift (@_));(my $rotatedName=shift (@_));if (__isNotForcedRotate ()){(my $result
=__rotateTillOriginalFile ($type,$rotatedName));__removeExpiredLogs ($type,
$rotatedName);if (($result==(0x0dc6+ 2535-0x17ad))){return (
(0x0898+ 5448-0x1de0));}}return (__copyTruncate ($type,$path,$rotatedName));}sub
 __getRotatedLogFilePathByLogType{(my $type=shift (@_));(my $rotatedName=shift (
@_));if (__isNotForcedRotate ()){(my $destination=NXLogrotateDB::getDestination 
($type));return ((($destination.$GLOBAL::DIRECTORY_SLASH).($rotatedName.
"\x2e\x31")));}else{(my $destination=__getForcedRotateDestination ());return (((
($destination.$GLOBAL::DIRECTORY_SLASH).($rotatedName."\x2d")).
__getForcedRotateDateTime ()));}}sub __compressFile{(my $logFilePath=shift (@_))
;(my $silent=shift (@_));(my $compressedFile=($logFilePath."\x2e\x67\x7a"));(my $result
=Common::NXFile::compressFile ($logFilePath,$compressedFile));if (($result!=
(0x0d96+ 1424-0x1325))){if (($silent==(0x0bb9+ 4278-0x1c6f))){NXMsg::error (
"\x65\x43\x4d\x44\x43\x61\x6e\x6e\x6f\x74\x43\x6f\x6d\x70\x72\x65\x73\x73\x46\x69\x6c\x65"
,"\x4e\x58\x4c\x6f\x67\x72\x6f\x74\x61\x74\x65",$logFilePath);}return (
(0x07c5+ 3757-0x1672));}else{if (($silent==(0x1a33+ 787-0x1d46))){
NXMsg::send_response (
"\x69\x43\x4d\x44\x43\x6f\x6d\x70\x72\x65\x73\x73\x65\x64\x46\x69\x6c\x65",
"\x4e\x58\x4c\x6f\x67\x72\x6f\x74\x61\x74\x65",$compressedFile);}
__correctRotatedFileOwnershipAndPermissions ($compressedFile);return (
(0x1e33+ 325-0x1f77));}}sub isTimeForCheckLogrotate{(my $currentTime=
Common::NXTime::getSecondsSinceEpoch ());(my $delay=$__checkLogrotateDelay);if (
(($__lastCheckLogrotate+$delay)<$currentTime)){return ((0x197c+ 1343-0x1eba));}
return ((0x10a4+ 2598-0x1aca));}sub checkLogrotateAndHandleIfNeeded{
Logger::debug (
"\x4e\x58\x4c\x6f\x67\x72\x6f\x74\x61\x74\x65\x3a\x20\x53\x74\x61\x72\x74\x69\x6e\x67\x20\x73\x63\x68\x65\x64\x75\x6c\x65\x64\x20\x6c\x6f\x67\x20\x72\x6f\x74\x61\x74\x69\x6f\x6e\x20\x63\x68\x65\x63\x6b\x20\x66\x6f\x72\x20\x61\x6c\x6c\x20\x66\x69\x6c\x65\x73\x2e"
);($__lastCheckLogrotate=Common::NXTime::getSecondsSinceEpoch ());(my (
@typesToRotate)=());main::nxrequire (
"\x4e\x58\x4c\x6f\x67\x72\x6f\x74\x61\x74\x65\x44\x42");NXLogrotateDB::reload ()
;(my (@logTypes)=NXLogrotateDB::getLogTypes ());foreach my $type (@logTypes){(my $size
=NXLogrotateDB::getSizeInBytes ($type));(my $minsize=
NXLogrotateDB::getMinsizeInBytes ($type));(my $isTimeToRotate=
NXLogrotateDB::isTimeToRotate ($type));(my (%filePaths)=__getFilePathsByLogType 
($type));foreach my $fileName (keys (%filePaths)){(my $filePath=$filePaths{
$fileName});(my $fileSize=Common::NXCore::NXFileSize ($filePath));if (($size and
 ($size<=$fileSize))){return (__runLogrotateCommand ());}if ($isTimeToRotate){if
 (((not ($minsize))or ($minsize<$fileSize))){return (__runLogrotateCommand ());}
}}}}sub __runLogrotateCommand{(my (@command)=($GLOBAL::CommandNXexec,
$GLOBAL::SCRIPT_NXLOGROTATE));(my (@options)=
"\x72\x75\x6e\x20\x69\x6e\x20\x62\x67");main::nxRunCommand ((\@command),(
\@options));Logger::debug (
"\x4e\x58\x4c\x6f\x67\x72\x6f\x74\x61\x74\x65\x3a\x20\x41\x75\x74\x6f\x6d\x61\x74\x69\x63\x20\x6c\x6f\x67\x72\x6f\x74\x61\x74\x65\x20\x68\x61\x73\x20\x62\x65\x65\x6e\x20\x72\x75\x6e\x2e"
);}sub automaticRotate{(my (%typesToRotate)=());main::nxrequire (
"\x4e\x58\x4c\x6f\x67\x72\x6f\x74\x61\x74\x65\x44\x42");NXLogrotateDB::reload ()
;(my (@logTypes)=NXLogrotateDB::getLogTypes ());foreach my $type (@logTypes){(my $size
=NXLogrotateDB::getSizeInBytes ($type));(my $minsize=
NXLogrotateDB::getMinsizeInBytes ($type));(my $isTimeToRotate=
NXLogrotateDB::isTimeToRotate ($type));(my (%filePaths)=__getFilePathsByLogType 
($type));(my (%pathsToRotate)=());if (__shouldSkipMultiTypeLogrotateForType (
$type)){next;}foreach my $fileName (keys (%filePaths)){(my $filePath=$filePaths{
$fileName});(my $fileSize=Common::NXCore::NXFileSize ($filePath));if (($size and
 ($size<=$fileSize))){($pathsToRotate{$fileName}=$filePath);($typesToRotate{
$type}=(\%pathsToRotate));next;}if ($isTimeToRotate){if (((not ($minsize))or (
$minsize<$fileSize))){($pathsToRotate{$fileName}=$filePath);($typesToRotate{
$type}=(\%pathsToRotate));next;}}}}(my $silent=(0x0469+ 7364-0x212c));foreach my $type
 (keys (%typesToRotate)){__rotateFilesByLogType ($type,$typesToRotate{$type},
$silent);NXLogrotateDB::updateLastRotateTime ($type);}}sub 
__getFilePathByLogType{(my $type=shift (@_));if (($type eq 
Logger::getLogrotateLogTypeNxserverLog ())){return (
Common::NXPaths::getNXServerLogPath ());}elsif (($type eq 
Logger::getLogrotateLogTypeNxdLog ())){return (NXPaths::getNxdLog ());}elsif ((
$type eq Logger::getLogrotateLogTypeNwebclientLog ())){return (
NXPaths::getNxwebclientLog ());}elsif (($type eq 
Logger::getLogrotateLogTypeNxhtdErrorLog ())){if (($__nxhtdErrorLogPath eq (""))
){($__nxhtdErrorLogPath=NXTools::getNxhtdErrorLogPath ());}return (
$__nxhtdErrorLogPath);}elsif (($type eq Logger::getLogrotateLogTypeNxserviceLog 
())){return (NXPaths::getNxserviceLog ());}else{return ((""));}}sub 
__getFilenameByLogType{(my $type=shift (@_));if (($type eq 
Logger::getLogrotateLogTypeNxserverLog ())){return (
"\x6e\x78\x73\x65\x72\x76\x65\x72\x2e\x6c\x6f\x67");}elsif (($type eq 
Logger::getLogrotateLogTypeNxdLog ())){return ("\x6e\x78\x64\x2e\x6c\x6f\x67");}
elsif (($type eq Logger::getLogrotateLogTypeNwebclientLog ())){return (
"\x6e\x78\x77\x65\x62\x72\x75\x6e\x6e\x65\x72\x2e\x6c\x6f\x67");}elsif (($type 
eq Logger::getLogrotateLogTypeNxhtdErrorLog ())){return (
"\x6e\x78\x68\x74\x64\x2e\x6c\x6f\x67");}elsif (($type eq 
Logger::getLogrotateLogTypeNxserviceLog ())){return (
"\x6e\x78\x73\x65\x72\x76\x69\x63\x65\x2e\x6c\x6f\x67");}else{return ((""));}}
sub isLogTypeSupported{(my $type=shift (@_));(my (@supportedTypes)=
getAllSupportedLogrotateLogTypes ());foreach my $supportedType (@supportedTypes)
{if (($supportedType eq $type)){return ((0x1591+ 2145-0x1df1));}}return (
(0x0521+ 7239-0x2168));}sub getAllSupportedLogrotateLogTypes{(my (@types)=());
push (@types,Logger::getLogrotateLogTypeNxserverLog ());push (@types,
Logger::getLogrotateLogTypeNxdLog ());if (NXLicense::isHttpdSupportFeature ()){
push (@types,Logger::getLogrotateLogTypeNwebclientLog ());push (@types,
Logger::getLogrotateLogTypeNxhtdErrorLog ());}return (@types);}sub 
__isTypeNxserverLog{(my $type=shift (@_));if (($type eq 
Logger::getLogrotateLogTypeNxserverLog ())){return ((0x0149+ 9077-0x24bd));}
return ((0x1674+ 2367-0x1fb3));}sub __isTypeNxwebclientLog{(my $type=shift (@_))
;if (($type eq Logger::getLogrotateLogTypeNwebclientLog ())){return (
(0x09eb+ 7191-0x2601));}return ((0x143b+ 4713-0x26a4));}sub __truncateFile{(my $filePath
=shift (@_));(my $handle=main::nxopen ($filePath,($NXBits::O_WRONLY+
$NXBits::O_TRUNC)));if (defined ($handle)){main::nxclose ($handle);return (
(0x1c3d+ 381-0x1db9));}return ((0x1425+ 4288-0x24e5));}sub __copyLogFile{(my $filePath
=shift (@_));(my $destFilePath=shift (@_));(my ($return,$error)=
Common::NXCore::copyFile ($filePath,$destFilePath));if (($error ne (""))){return
 ((0x09c1+ 165-0x0a66));}__correctRotatedFileOwnershipAndPermissions (
$destFilePath);return ((0x01d5+ 4031-0x1193));}sub 
__correctRotatedFileOwnershipAndPermissions{(my $file=shift (@_));
Common::NXFile::setPermissionsReadWriteForNX ($file);if (
main::effectiveUserIsAdministrator ()){
Common::NXFile::setOwnershipForUserAndGroupNX ($file);}return (
(0x031f+ 5799-0x19c5));}sub __setForcedRotateDateTime{($__forcedRotateDateTime=
shift (@_));}sub __getForcedRotateDateTime{return ($__forcedRotateDateTime);}sub
 __setForcedRotate{($__forcedRotate=(0x07cb+ 290-0x08ec));}sub __isForcedRotate{
return ($__forcedRotate);}sub __getForcedRotateDestination{return (
$$__ref_forcedRotateParameters{"\x64\x65\x73\x74\x69\x6e\x61\x74\x69\x6f\x6e"});
}sub __isForcedRotateCompress{if (($$__ref_forcedRotateParameters{
"\x63\x6f\x6d\x70\x72\x65\x73\x73"}eq "\x6e\x6f")){return ((0x1aa7+ 1937-0x2238)
);}else{return ((0x0dc1+ 1417-0x1349));}}sub __isNotForcedRotate{return ((!
__isForcedRotate ()));}sub __handleForcedRotateParameters{(my $ref_parameters=
shift (@_));($__ref_forcedRotateParameters=$ref_parameters);main::nxrequire (
"\x4e\x58\x4c\x6f\x67\x72\x6f\x74\x61\x74\x65\x44\x42","\x69\x6e\x69\x74");(my $procedure
="\x66\x6f\x72\x63\x65\x64\x52\x6f\x74\x61\x74\x65");return (
NXLogrotateDB::handleDestinationAndCompressParameters ($ref_parameters,
$procedure));}sub __shouldSkipMultiTypeLogrotateForType{(my $type=shift (@_));
return ((0x040f+ 7349-0x20c4));}NXMsg::register_response (
"\x4e\x58\x4c\x6f\x67\x72\x6f\x74\x61\x74\x65",
"\x69\x43\x4d\x44\x53\x74\x61\x72\x74\x69\x6e\x67\x4c\x6f\x67\x72\x6f\x74\x61\x74\x65"
,(0x0c78+ 4333-0x19e1));NXMsg::register_response (
"\x4e\x58\x4c\x6f\x67\x72\x6f\x74\x61\x74\x65",
"\x69\x43\x4d\x44\x4c\x6f\x67\x72\x6f\x74\x61\x74\x65\x46\x69\x6e\x69\x73\x68\x65\x64"
,(0x0c26+ 5528-0x1e3a));NXMsg::register_response (
"\x4e\x58\x4c\x6f\x67\x72\x6f\x74\x61\x74\x65",
"\x69\x43\x4d\x44\x43\x6f\x6d\x70\x72\x65\x73\x73\x65\x64\x46\x69\x6c\x65",
(0x0d80+ 3265-0x16bd));NXMsg::register_error (
"\x4e\x58\x4c\x6f\x67\x72\x6f\x74\x61\x74\x65",
"\x65\x43\x4d\x44\x4c\x6f\x67\x72\x6f\x74\x61\x74\x65\x46\x61\x69\x6c\x65\x64",
(0x16fc+ 1029-0x190d));NXMsg::register_error (
"\x4e\x58\x4c\x6f\x67\x72\x6f\x74\x61\x74\x65",
"\x65\x43\x4d\x44\x46\x69\x6c\x65\x49\x73\x42\x65\x69\x6e\x67\x55\x73\x65\x64",
(0x027a+ 9575-0x25ed));NXMsg::register_error (
"\x4e\x58\x4c\x6f\x67\x72\x6f\x74\x61\x74\x65",
"\x65\x43\x4d\x44\x43\x61\x6e\x6e\x6f\x74\x43\x6f\x6d\x70\x72\x65\x73\x73\x46\x69\x6c\x65"
,(0x0ca5+ 3051-0x169c));NXMsg::register_error (
"\x4e\x58\x4c\x6f\x67\x72\x6f\x74\x61\x74\x65",
"\x65\x43\x4d\x44\x4c\x6f\x67\x72\x6f\x74\x61\x74\x65\x54\x79\x70\x65\x4e\x6f\x74\x53\x75\x70\x70\x6f\x72\x74\x65\x64"
,(0x04ec+ 6850-0x1dba));"\x3f\x3f\x3f";
