############################################################################
#                                                                          #
#  Copyright (c) 2001, 2024 NoMachine, http://www.nomachine.com.           #
#                                                                          #
#  NXSERVER, NX protocol compression and NX extensions to this software    #
#  are copyright of NoMachine. Redistribution and use of the present       #
#  software is allowed according to terms specified in the file LICENSE    #
#  which comes in the source distribution.                                 #
#                                                                          #
#  Check http://www.nomachine.com/licensing.html for applicability.        #
#                                                                          #
#  NX and NoMachine are trademarks of NoMachine S.a.r.l.                   #
#                                                                          #
#  All rights reserved.                                                    #
#                                                                          #
############################################################################
sub BEGIN{no warnings;require Common::NXCore;do{
"\x43\x6f\x6d\x6d\x6f\x6e\x3a\x3a\x4e\x58\x43\x6f\x72\x65"->import};}sub BEGIN{
no warnings;require Common::Logger;do{
"\x43\x6f\x6d\x6d\x6f\x6e\x3a\x3a\x4c\x6f\x67\x67\x65\x72"->import};}sub BEGIN{
no warnings;require Common::NXTranslator;do{
"\x43\x6f\x6d\x6d\x6f\x6e\x3a\x3a\x4e\x58\x54\x72\x61\x6e\x73\x6c\x61\x74\x6f\x72"
->import};}sub BEGIN{no warnings;require Common::NXMsg;do{
"\x43\x6f\x6d\x6d\x6f\x6e\x3a\x3a\x4e\x58\x4d\x73\x67"->import};}package NXMsg;
no warnings;(my $__silentMode=(0x11dd+ 458-0x13a7));(my $__eolAfterRequest=
(0x05bc+ 1684-0x0c50));sub register_response{__register ($_[
(0x01fc+ 4640-0x141c)],$_[(0x005c+ 3587-0x0e5e)],$_[(0x1c9b+ 1685-0x232e)],
Common::NXMsg::getResponseType (),(""));}sub register_error{__register ($_[
(0x02a4+ 1248-0x0784)],$_[(0x15e9+ 147-0x167b)],$_[(0x05dc+ 3650-0x141c)],
Common::NXMsg::getErrorType (),$_[(0x0447+ 7254-0x209a)]);}sub register_request{
__register ($_[(0x1ab8+ 2657-0x2519)],$_[(0x0655+ 4387-0x1777)],$_[
(0x1aec+ 582-0x1d30)],Common::NXMsg::getRequestType (),$_[(0x04d2+ 1790-0x0bcd)]
);}sub __register{(my $class=$_[(0x16b6+ 1800-0x1dbe)]);(my $name=$_[
(0x0ab4+ 6159-0x22c2)]);(my $number=$_[(0x0a16+ 277-0x0b29)]);(my $type=$_[
(0x0160+ 9642-0x2707)]);(my $regExp=$_[(0x0a96+ 1015-0x0e89)]);if (((not (
defined ($name)))or (not (($name=~ /^[\w\d\._-]{1,128}$/ ))))){Logger::error ((
"\x4e\x58\x4d\x73\x67\x3a\x20\x57\x72\x6f\x6e\x67\x20\x70\x61\x72\x61\x6d\x65\x74\x65\x72\x20\x6e\x61\x6d\x65\x20"
.$name),(0x0b68+ 4577-0x1d47));__error ();}if (((not (defined ($number)))or (not
 (($number=~ /^[\d]{3,4}$/ ))))){Logger::error ((
"\x4e\x58\x4d\x73\x67\x3a\x20\x57\x72\x6f\x6e\x67\x20\x70\x61\x72\x61\x6d\x65\x74\x65\x72\x20\x6e\x75\x6d\x62\x65\x72\x20"
.$number),(0x1a0a+ 799-0x1d27));__error ();}if ((((!defined ($regExp))||($regExp
 eq ("")))and Common::NXMsg::isRequestType ($type))){Logger::error ((
"\x4e\x58\x4d\x73\x67\x3a\x20\x57\x72\x6f\x6e\x67\x20\x70\x61\x72\x61\x6d\x65\x74\x65\x72\x20\x72\x65\x67\x45\x78\x70\x20"
.$regExp),(0x09ad+ 6782-0x2429));__error ();}if (isMessageRegistered ($name)){
Logger::error ((("\x4e\x58\x4d\x73\x67\x3a\x20\x4d\x65\x73\x73\x61\x67\x65\x20".
$name).
"\x20\x69\x73\x20\x61\x6c\x72\x65\x61\x64\x79\x20\x72\x65\x67\x69\x73\x74\x65\x72\x65\x64\x2e"
),(0x08b2+ 652-0x0b3c));__error ();}Common::NXMsg::saveMessageData ($name,
$number,$type,$regExp);}sub __sprinf_reg_exp{(my $format=shift (@_));(my $name=
shift (@_));(my $class=shift (@_));(my (@message_parameters)=@_);for ((my $i=
(0x0d51+ 281-0x0e6a));($i<=$#message_parameters);(++$i)){($message_parameters[$i
]=~ s/^\n//gm );($message_parameters[$i]=~ s/\n$//gm );}(my $message=sprintf (
$format,@message_parameters));($message=~ s/\n/\n        /gm );return ($message)
;}sub check_msg{(my $index=shift (@_));(my $class=shift (@_));if (((not (defined
 ($index)))or (not (($index=~ /^[\w\d\._-]{1,128}$/ ))))){return (
(0x02e6+ 5432-0x181e));}(my $messageNumber=Common::NXMsg::getNumber ($index));if
 ((not (defined ($messageNumber)))){return ((0x0647+ 7269-0x22ac));}return (
(0x0614+ 7758-0x2461));}sub get_msg{(my $index=shift (@_));(my $class=shift (@_)
);(my (@parameters)=@_);if (((not (defined ($index)))or (not (($index=~ /^[\w\d\._-]{1,128}$/ )
)))){Logger::error ((
"\x4e\x58\x4d\x73\x67\x3a\x20\x57\x72\x6f\x6e\x67\x20\x70\x61\x72\x61\x6d\x65\x74\x65\x72\x20\x69\x6e\x64\x65\x78\x20\x73\x74\x72\x69\x6e\x67\x20"
.$index),(0x16f3+ 1867-0x1e3d));__error ();}(my $messageNumber=
Common::NXMsg::getNumber ($index));if ((not (defined ($messageNumber)))){
Logger::error ((
"\x4e\x58\x4d\x73\x67\x3a\x20\x55\x6e\x72\x65\x67\x69\x73\x74\x65\x72\x65\x64\x20\x6d\x65\x73\x73\x61\x67\x65\x20"
.$index),(0x01d1+ 1191-0x0677));__error ();}for ((my $i=(0x149a+ 176-0x154a));(
$i<=$#parameters);(++$i)){($parameters[$i]=~ s/^\n//gm );($parameters[$i]=~ s/\n$//gm )
;}(my $messageText=(""));if (Common::NXEnglishMessages::isCustomizableMessage (
$index)){(($messageNumber,$index,$messageText)=
Common::NXMsg::getCustomizedMessage ($index,$messageNumber,(\@parameters)));}
else{($messageText=Common::NXEnglishMessages::getMessage ($index));}(my $message
=(""));if (shouldPackMessage ($messageNumber)){($message=
Common::NXMsg::constructMessage ($messageNumber,$messageText,@parameters));(my $packedMessage
=Common::NXMsg::packResponse ($index,$message,@parameters));return ((""),
$packedMessage);}else{Common::NXTranslator::translate ($index,(\$messageText));}
($message=Common::NXMsg::constructMessage ($messageNumber,$messageText,
@parameters));if (($index eq 
"\x65\x53\x79\x73\x74\x65\x6d\x55\x73\x65\x72\x44\x65\x6c\x46\x61\x69\x6c\x65\x64"
)){($message=~ s/ERROR: // );}return (Common::NXMsg::getRegExp ($index),$message
);}sub get_text{(my $indexString=shift (@_));(my $class=shift (@_));(my (
@parameters)=@_);(my $translate=(0x0e8f+ 495-0x107d));return (__getText (
$indexString,$translate,@parameters));}sub getEnglishText{(my $indexString=shift
 (@_));(my (@parameters)=@_);(my $translate=(0x08a1+ 3081-0x14aa));return (
__getText ($indexString,$translate,@parameters));}sub __getText{(my $index=shift
 (@_));(my $translate=shift (@_));(my (@parameters)=@_);my ($message);if (((not 
(defined ($index)))or (not (($index=~ /^[\w\d\._-]{1,128}$/ ))))){Logger::error 
((
"\x4e\x58\x4d\x73\x67\x3a\x20\x57\x72\x6f\x6e\x67\x20\x70\x61\x72\x61\x6d\x65\x74\x65\x72\x20\x69\x6e\x64\x65\x78\x20\x73\x74\x72\x69\x6e\x67\x20"
.$index),(0x17a7+ 3032-0x237e));__error ();}unless (($translate and 
Common::NXTranslator::translate ($index,(\$message)))){($message=
Common::NXEnglishMessages::getMessage ($index));}for ((my $i=
(0x06d1+ 752-0x09c1));($i<=$#parameters);(++$i)){($parameters[$i]=~ s/^\n//gm );
($parameters[$i]=~ s/\n$//gm );}if (($message ne (""))){($message=sprintf (
$message,@parameters));}return ($message);}sub send_response{(my $index=$_[
(0x0d2d+ 4818-0x1fff)]);if (Common::NXMsg::isErrorTypeByIndex ($index)){return (
error (@_));}(my ($reg_exp,$message)=get_msg (@_));if (isSilentMode ()){return;}
if ((not (Server::isClientConnectionOpen ()))){return;}Logger::debug (((
"\x4e\x58\x4d\x73\x67\x3a\x20\x53\x65\x6e\x74\x20\x72\x65\x73\x70\x6f\x6e\x73\x65\x20\x6d\x65\x73\x73\x61\x67\x65\x20\x27"
.$message)."\x27"));($message.="\x0a");if ((main::nxwrite (main::nxgetSTDOUT (),
$message)==(-(0x0fea+ 2631-0x1a30)))){NXShell::setExitRequest (
$ExitRequests::closedSTDOUT);return ((-(0x19c4+ 1970-0x2175)));}}sub 
send_response_no_newline{(my ($reg_exp,$message)=get_msg (@_));if (isSilentMode 
()){return;}if ((not (Server::isClientConnectionOpen ()))){return;}Logger::debug
 (((
"\x4e\x58\x4d\x73\x67\x3a\x20\x53\x65\x6e\x74\x20\x72\x65\x73\x70\x6f\x6e\x73\x65\x20\x6d\x65\x73\x73\x61\x67\x65\x20\x27"
.$message)."\x27"));main::nxwrite (main::nxgetSTDOUT (),$message);}sub 
send_response_without_number{(my $message=get_text (@_));if (isSilentMode ()){
return;}if ((not (Server::isClientConnectionOpen ()))){return;}Logger::debug (((
"\x4e\x58\x4d\x73\x67\x3a\x20\x53\x65\x6e\x74\x20\x72\x65\x73\x70\x6f\x6e\x73\x65\x20\x77\x69\x74\x68\x6f\x75\x74\x20\x6e\x75\x6d\x62\x65\x72\x20\x27"
.$message)."\x27"));($message.="\x0a");if ((main::nxwrite (main::nxgetSTDOUT (),
$message)==(-(0x09f2+ 4783-0x1ca0)))){NXShell::setExitRequest (
$ExitRequests::closedSTDOUT);return ((-(0x0912+ 5678-0x1f3f)));}}sub 
sendLogMessage{(my $message=shift (@_));(my $level=shift (@_));(my $storeInHistory
=shift (@_));if (Logger::isErrorLevel ($level)){Logger::error ($message,
$storeInHistory);}elsif (Logger::isWarningLevel ($level)){Logger::warning (
$message,$storeInHistory);}elsif (Logger::isInfoLevel ($level)){Logger::info (
$message,$storeInHistory);}else{Logger::debug ($message,$storeInHistory);}}sub 
__warning{(my $log_level=shift (@_));(my ($reg_exp,$message)=get_msg (@_));if (
isSilentMode ()){return;}if ((defined ($reg_exp)and ($reg_exp eq 
(0x034f+ 638-0x05cc)))){($log_msg=__sprinf_reg_exp ($reg_exp,@_));sendLogMessage
 ($log_msg,$log_level,(0x0914+ 624-0x0b81));}if (((defined ($reg_exp)and (
$reg_exp ne ("")))and ($reg_exp ne (0x041a+ 1994-0x0be3)))){($log_msg=
__sprinf_reg_exp ($reg_exp,@_));sendLogMessage ($log_msg,$log_level,
(0x0c8a+ 396-0x0e13));}if (((not (defined ($message)))or ($message eq ("")))){((
$reg_exp,$message)=Common::NXMsg::get_msg (
"\x65\x47\x55\x49\x47\x65\x6e\x65\x72\x61\x6c"));}if (
Common::NXMsg::isPackedMessage ($message)){Logger::debug (((
"\x4e\x58\x4d\x73\x67\x3a\x20\x53\x65\x6e\x64\x69\x6e\x67\x20\x70\x61\x63\x6b\x65\x64\x20\x6d\x65\x73\x73\x61\x67\x65\x20\x27"
.$message)."\x27"));}elsif (Logger::isInfoLevel ($log_level)){Logger::debug (((
"\x4e\x58\x4d\x73\x67\x3a\x20\x53\x65\x6e\x64\x69\x6e\x67\x20\x69\x6e\x66\x6f\x72\x6d\x61\x74\x69\x6f\x6e\x61\x6c\x20\x6d\x65\x73\x73\x61\x67\x65\x20\x27"
.$message)."\x27"));}elsif (Logger::isWarningLevel ($log_level)){($message=~ s/(^NX> \d+) *(.*)$/$1 WARNING: $2/gm )
;Logger::debug (((
"\x4e\x58\x4d\x73\x67\x3a\x20\x53\x65\x6e\x64\x69\x6e\x67\x20\x77\x61\x72\x6e\x69\x6e\x67\x20\x6d\x65\x73\x73\x61\x67\x65\x20\x27"
.$message)."\x27"));}else{($message=~ s/(^NX> \d+) *(.*)$/$1 ERROR: $2/gm );
Logger::debug (((
"\x4e\x58\x4d\x73\x67\x3a\x20\x53\x65\x6e\x64\x69\x6e\x67\x20\x65\x72\x72\x6f\x72\x20\x6d\x65\x73\x73\x61\x67\x65\x20\x27"
.$message)."\x27"));}if (Server::isClientConnectionOpen ()){main::nxwrite (
main::nxgetSTDOUT (),($message."\x0a"));}}sub fatal{__warning (
Logger::getErrorLevel (),@_);NXShell::handle_command ("\x65\x78\x69\x74");}sub 
error{__warning (Logger::getErrorLevel (),@_);}sub warning{__warning (
Logger::getWarningLevel (),@_);}sub info{__warning (Logger::getInfoLevel (),@_);
}$GLOBAL::NXMsg::__inBuffer;sub send_requestWithAdditionalCallback{return (
__send_request (@_));}sub send_request{(my $index=shift (@_));(my $class=shift (
@_));(my $value=shift (@_));(my $additionalFd=(""));(my $callback=(""));return (
__send_request ($index,$class,$additionalFd,$callback,$value,@_));}sub 
__send_request{(my $pRegExp=shift (@_));(my $pMessage=shift (@_));(my $additionalFd
=shift (@_));(my $callback=shift (@_));(my $value=shift (@_));(my ($reg_exp,
$message)=get_msg ($pRegExp,$pMessage,@_));if (defined ($value)){if (($reg_exp 
eq "\x70\x72\x69\x6e\x74\x61\x62\x6c\x65\x63\x68\x61\x72")){if ((not (($value=~ /(^[^0-9A-Za-z_.+\-])$/ )
))){(my $tmp=$value);while (($tmp=~ s/(.)// )){if ((ord ($1)<
(0x01bf+ 5582-0x176d))){Logger::error ((((
"\x4e\x58\x4d\x73\x67\x3a\x20\x49\x6e\x76\x61\x6c\x69\x64\x20\x63\x68\x61\x72\x61\x63\x74\x65\x72\x20\x5c"
.sprintf ("\x5c\x30\x25\x6f",ord ($1))).
"\x20\x69\x73\x20\x6e\x6f\x74\x20\x70\x72\x69\x6e\x74\x61\x62\x6c\x65\x20").
"\x61\x6e\x64\x20\x63\x61\x6e\x6e\x6f\x74\x20\x62\x65\x20\x75\x73\x65\x64\x20\x66\x6f\x72\x20\x74\x68\x69\x73\x20\x70\x61\x72\x61\x6d\x65\x74\x65\x72\x2e"
));return (());}}}}elsif ((not (($value=~ /$reg_exp/ )))){Logger::error ((
"\x4e\x58\x4d\x73\x67\x3a\x20\x49\x6e\x76\x61\x6c\x69\x64\x20\x76\x61\x6c\x75\x65\x20"
.$value));return (());}return ($value);}if (($message=~ /^NX> (\d\d\d)  $/ )){(
$message=(("\x4e\x58\x3e\x20".$1)."\x20"));}else{($message.="\x3a\x20");}if ((
sendEOL ()==(0x0291+ 7185-0x1ea1))){if ((main::nxwrite (main::nxgetSTDOUT (),(
$message."\x0a"))==(-(0x1631+ 2955-0x21bb)))){NXShell::setExitRequest (
$ExitRequests::closedSTDOUT);return (());}}else{if ((main::nxwrite (
main::nxgetSTDOUT (),$message)==(-(0x0db1+ 3716-0x1c34)))){
NXShell::setExitRequest ($ExitRequests::closedSTDOUT);return (());}}
Logger::debug (((
"\x4e\x58\x4d\x73\x67\x3a\x20\x53\x65\x6e\x74\x20\x72\x65\x71\x75\x65\x73\x74\x20\x6d\x65\x73\x73\x61\x67\x65\x20\x27"
.$message)."\x27"));(my $parser=
"\x43\x6f\x6d\x6d\x6f\x6e\x3a\x3a\x4e\x58\x50\x61\x72\x73\x65\x72"->new);((
%parameters)=());($parameters{"\x64\x61\x74\x61"}=(""));($parameters{
"\x6d\x61\x78\x4c\x65\x6e\x67\x74"}=$GLOBAL::commandBufferLimit);($parameters{
"\x65\x6e\x64\x4f\x66\x4c\x69\x6e\x65"}=(0x0eb2+ 4884-0x21c6));($parameters{
"\x69\x67\x6e\x6f\x72\x65\x55\x6e\x74\x69\x6c\x65\x45\x4f\x4c"}=
(0x0b4b+ 895-0x0eca));$parser->add ($$NXBegin::parser{"\x53\x69\x67\x6e\x61\x6c"
});$parser->add (main::nxgetSTDIN (),(\&__globalReadnLine),
"\x4e\x58\x4d\x73\x67\x3a\x3a\x5f\x5f\x67\x6c\x6f\x62\x61\x6c\x52\x65\x61\x64\x6e\x4c\x69\x6e\x65"
,(\%parameters));$parser->setNotRead (main::nxgetSTDIN ());if (($additionalFd ne
 (""))){$parser->add ($additionalFd);$parser->setCallbackForHandle (
$additionalFd,"\x43\x6c\x6f\x73\x65",$callback);}$parser->setTimeout (
"\x69\x6e\x66");$parser->run;(my $data=$parameters{"\x64\x61\x74\x61"});if ((not
 (defined ($data)))){return (());}(my $log_data=$data);if (($pRegExp eq 
"\x72\x41\x73\x6b\x46\x6f\x72\x41\x74\x74\x61\x63\x68\x4d\x65\x73\x73\x61\x67\x65"
)){($data=main::urlencode ($data));($log_data=main::urldecode ($data));}if (
NXShell::isCurrentModeNotWords ()){($log_data=~ s/(password=)([^&]*)/do {
            ($1 . ('*' x length($2)));
        };/eg )
;($log_data=~ s/(cookie=)([^&]*)/do {
            ($1 . ('*' x length($2)));
        };/eg )
;}else{();}if (($pRegExp ne "\x63\x6f\x6d\x6d\x61\x6e\x64")){if ((((
$GLOBAL::PROTO_VERSION ne "\x73\x68\x65\x6c\x6c")and ($GLOBAL::PROTO_VERSION ne 
("")))and (NXShell::getNoEcho ()!=(0x2134+ 359-0x229a)))){if ((main::nxwrite (
main::nxgetSTDOUT (),($data."\x0a"))==(-(0x02b3+ 2333-0x0bcf)))){
NXShell::setExitRequest ($ExitRequests::closedSTDOUT);return (());}}else{if ((
main::nxwrite (main::nxgetSTDOUT (),"\x0a")==(-(0x19cb+ 2785-0x24ab)))){
NXShell::setExitRequest ($ExitRequests::closedSTDOUT);return (());}}}
Logger::debug (((
"\x4e\x58\x4d\x73\x67\x3a\x20\x52\x65\x63\x65\x69\x76\x65\x64\x20\x72\x65\x73\x70\x6f\x6e\x73\x65\x20\x27"
.$log_data)."\x27\x2e"));if (($reg_exp eq 
"\x70\x72\x69\x6e\x74\x61\x62\x6c\x65\x63\x68\x61\x72")){if ((not (($data=~ /(^[^0-9A-Za-z_.+\-])$/ )
))){(my $tmp=$data);while (($tmp=~ s/(.)// )){if ((ord ($1)<
(0x0508+ 5254-0x196e))){Logger::error (((((
"\x4e\x58\x4d\x73\x67\x3a\x20\x49\x6e\x76\x61\x6c\x69\x64\x20\x72\x65\x73\x70\x6f\x6e\x73\x65\x20\x74\x6f\x20\x6d\x65\x73\x73\x61\x67\x65\x20"
.$message)."\x2e\x20\x43\x68\x61\x72\x61\x63\x74\x65\x72\x20\x5c").sprintf (
"\x5c\x30\x25\x6f",ord ($1))).
"\x20\x69\x73\x20\x6e\x6f\x74\x20\x70\x72\x69\x6e\x74\x61\x62\x6c\x65\x20\x61\x6e\x64\x20\x63\x61\x6e\x6e\x6f\x74\x20\x62\x65\x20\x75\x73\x65\x64\x20\x68\x65\x72\x65\x2e"
));return (());}}}}elsif ((not (($data=~ /$reg_exp/ )))){Logger::error (((((((
"\x4e\x58\x4d\x73\x67\x3a\x20\x49\x6e\x76\x61\x6c\x69\x64\x20\x72\x65\x73\x70\x6f\x6e\x73\x65\x20\x74\x6f\x20\x6d\x65\x73\x73\x61\x67\x65\x20\x27"
.$message)."\x27\x2e\x20\x44\x61\x74\x61\x20\x27").$data).
"\x27\x20\x64\x6f\x65\x73\x6e\x27\x74\x20\x6d\x61\x74\x63\x68\x20\x77\x69\x74\x68\x20\x72\x65\x67\x45\x78\x70\x20\x27"
).$reg_exp)."\x27\x2e"));if ((main::nxwrite (main::nxgetSTDOUT (),"\x0a")==(-
(0x1267+ 1358-0x17b4)))){NXShell::setExitRequest ($ExitRequests::closedSTDOUT);}
return (());}if ((($data eq (""))and $GLOBAL::PROTO_VERSION)){if ((main::nxwrite
 (main::nxgetSTDOUT (),"\x0a")==(-(0x0ce9+ 1595-0x1323)))){
NXShell::setExitRequest ($ExitRequests::closedSTDOUT);return (());}}return (
$data);}sub send_hrequestWithAdditionalCallback{return (__send_hrequest (@_));}
sub send_hrequest{(my $indexString=shift (@_));(my $class=shift (@_));(my $additionalFd
=(""));(my $callback=(""));return (__send_hrequest ($indexString,$class,
$additionalFd,$callback,@_));}sub __send_hrequest{(my $indexString=shift (@_));(my $class
=shift (@_));(my $additionalFd=shift (@_));(my $callback=shift (@_));(my (
$reg_exp,$message)=get_msg ($indexString,$class,@_));($message.="\x3a\x20");(my $parser
="\x43\x6f\x6d\x6d\x6f\x6e\x3a\x3a\x4e\x58\x50\x61\x72\x73\x65\x72"->new);((
%parameters)=());($parameters{"\x64\x61\x74\x61"}=(""));($parameters{
"\x6d\x61\x78\x4c\x65\x6e\x67\x74"}=$GLOBAL::commandBufferLimit);($parameters{
"\x65\x6e\x64\x4f\x66\x4c\x69\x6e\x65"}=(0x002d+  99-0x0090));($parameters{
"\x69\x67\x6e\x6f\x72\x65\x55\x6e\x74\x69\x6c\x65\x45\x4f\x4c"}=
(0x096f+ 1009-0x0d60));$parser->add ($$NXBegin::parser{
"\x53\x69\x67\x6e\x61\x6c"});$parser->add (main::nxgetSTDIN (),(
\&__globalReadnLine),
"\x4e\x58\x4d\x73\x67\x3a\x3a\x5f\x5f\x67\x6c\x6f\x62\x61\x6c\x52\x65\x61\x64\x6e\x4c\x69\x6e\x65"
,(\%parameters));$parser->setNotRead (main::nxgetSTDIN ());if (($additionalFd ne
 (""))){$parser->add ($additionalFd);$parser->setCallbackForHandle (
$additionalFd,"\x43\x6c\x6f\x73\x65",$callback);}$parser->setTimeout (
"\x69\x6e\x66");blindInput ();if ((main::nxwrite (main::nxgetSTDOUT (),$message)
==(-(0x0d83+ 3749-0x1c27)))){NXShell::setExitRequest (
$ExitRequests::closedSTDOUT);showInput ();return (());}Logger::debug (((
"\x4e\x58\x4d\x73\x67\x3a\x20\x53\x65\x6e\x74\x20\x72\x65\x71\x75\x65\x73\x74\x20\x6d\x65\x73\x73\x61\x67\x65\x20\x27"
.$message)."\x27"));$parser->run;showInput ();(my $data=$parameters{
"\x64\x61\x74\x61"});if ((not (defined ($data)))){main::nxwrite (
main::nxgetSTDOUT (),"\x0a");return (());}(my $hdata=$data);($hdata=~ s/./*/g );
Logger::debug (((
"\x4e\x58\x4d\x73\x67\x3a\x20\x52\x65\x63\x65\x69\x76\x65\x64\x20\x72\x65\x73\x70\x6f\x6e\x73\x65\x20\x27"
.$hdata)."\x27"));if ((not (($data=~ /$reg_exp/ )))){if ((main::nxwrite (
main::nxgetSTDOUT (),"\x0a")==(-(0x03bb+ 7190-0x1fd0)))){NXShell::setExitRequest
 ($ExitRequests::closedSTDOUT);}Logger::error (((((((
"\x4e\x58\x4d\x73\x67\x3a\x20\x49\x6e\x76\x61\x6c\x69\x64\x20\x72\x65\x73\x70\x6f\x6e\x73\x65\x20\x74\x6f\x20\x6d\x65\x73\x73\x61\x67\x65\x20"
.$message)."\x2e\x20\x20").$hdata).
"\x20\x64\x6f\x65\x73\x6e\x27\x74\x20\x6d\x61\x74\x63\x68\x20\x77\x69\x74\x68\x20"
).$reg_exp)."\x2e"));return (());}if (((($GLOBAL::PROTO_VERSION ne 
"\x73\x68\x65\x6c\x6c")and ($GLOBAL::PROTO_VERSION ne ("")))and (
NXShell::getNoEcho ()!=(0x0841+ 2373-0x1185)))){if ((main::nxwrite (
main::nxgetSTDOUT (),($hdata."\x0a"))==(-(0x08e7+ 3410-0x1638)))){
NXShell::setExitRequest ($ExitRequests::closedSTDOUT);return (());}}else{if ((
main::nxwrite (main::nxgetSTDOUT (),"\x0a")==(-(0x13c8+ 1756-0x1aa3)))){
NXShell::setExitRequest ($ExitRequests::closedSTDOUT);return (());}}return (
$data);}sub __error{main::nxwrite (main::nxgetSTDERR (),
"\x45\x72\x72\x6f\x72\x3a\x20\x66\x61\x74\x61\x6c\x20\x65\x72\x72\x6f\x72\x20\x69\x6e\x20\x6d\x6f\x64\x75\x6c\x65\x20\x4e\x58\x4d\x73\x67\x2c\x20\x63\x68\x65\x63\x6b\x20\x6c\x6f\x67\x20\x66\x69\x6c\x65\x20\x66\x6f\x72\x20\x6d\x6f\x72\x65\x20\x64\x65\x74\x61\x69\x6c\x73\x0a"
);NXShell::handle_command ("\x65\x78\x69\x74");main::nxexit (
(0x19f1+ 2731-0x249b));}sub __readnLine{(my $maxLengt=(shift (@_)||
(0x1927+ 627-0x0b9a)));(my $data=());(my $endOfLine=(0x12fd+ 4680-0x2545));(my $ignoreUntileEOL
=(0x08b9+ 1810-0x0fcb));while ((not ($endOfLine))){(my $readBuff=());(my $bytesToRead
=($maxLengt-length ($GLOBAL::NXMsg::__inBuffer)));if (($bytesToRead<=
(0x1793+ 2056-0x1f9b))){($GLOBAL::NXMsg::__inBuffer=(""));($ignoreUntileEOL=
(0x01e9+ 6693-0x1c0d));(my $warning=((
"\x4e\x58\x4d\x73\x67\x3a\x20\x43\x6f\x6d\x6d\x61\x6e\x64\x20\x6c\x69\x6e\x65\x20\x63\x61\x6e\x6e\x6f\x74\x20\x62\x65\x20\x6c\x6f\x6e\x67\x65\x72\x20\x74\x68\x61\x6e\x20"
.$GLOBAL::commandBufferLimit)."\x20\x63\x68\x61\x72\x61\x63\x74\x65\x72\x73\x2e"
));Logger::warning ($warning);(my ($reg_exp,$message)=get_msg (
"\x65\x54\x6f\x6f\x4c\x6f\x6e\x67\x43\x6f\x6d\x6d\x61\x6e\x64",
"\x4e\x58\x4d\x73\x67",$GLOBAL::commandBufferLimit));main::nxwrite (
main::nxgetSTDOUT (),$message);}(my $readBytes=main::nxread (main::nxgetSTDIN ()
,(\$readBuff),(0x1134+ 3620-0x1f57)));if ((not (defined ($readBytes)))){(my $errorstring
=libnxh::NXGetErrorString ());(my $errorNumber=libnxh::NXGetError ());
main::nxwrite (main::nxgetSTDOUT (),"\x0a");NXShell::setExitRequest (((((
"\x46\x61\x69\x6c\x65\x64\x20\x72\x65\x61\x64\x20\x66\x72\x6f\x6d\x20\x73\x74\x64\x69\x6e\x3a\x20"
.$errorNumber)."\x2c\x20\x27").$errorstring)."\x27\x2e"));return (());}if ((
$readBytes==(0x134f+ 733-0x162c))){main::nxwrite (main::nxgetSTDOUT (),"\x0a");
NXShell::setExitRequest ($ExitRequests::closedSTDIN);return (());}if (($readBuff
 eq "\x0a")){(($ignoreUntileEOL eq (0x01e1+ 3289-0x0eb9))and ($ignoreUntileEOL=
(0x05b2+ 5131-0x19bd)));($data=$GLOBAL::NXMsg::__inBuffer);($endOfLine=
(0x101c+ 1787-0x1716));($GLOBAL::NXMsg::__inBuffer=(""));}else{if ((
$ignoreUntileEOL eq (0x0ce7+ 2685-0x1764))){($GLOBAL::NXMsg::__inBuffer.=
$readBuff);}}}return ($data);}sub __globalReadnLine{(my $self=shift (@_));(my $handleHash
=shift (@_));(my $refParameters=$$handleHash{
"\x50\x61\x72\x61\x6d\x65\x74\x65\x72\x73"});if ((not ($$refParameters{
"\x65\x6e\x64\x4f\x66\x4c\x69\x6e\x65"}))){(my $readBuff=());(my $bytesToRead=(
$$refParameters{"\x6d\x61\x78\x4c\x65\x6e\x67\x74"}-length (
$GLOBAL::NXMsg::__inBuffer)));if (($bytesToRead<=(0x2058+ 304-0x2188))){(
$GLOBAL::NXMsg::__inBuffer=(""));($$refParameters{
"\x69\x67\x6e\x6f\x72\x65\x55\x6e\x74\x69\x6c\x65\x45\x4f\x4c"}=
(0x0952+ 5360-0x1e41));(my $warning=((
"\x4e\x58\x4d\x73\x67\x3a\x20\x43\x6f\x6d\x6d\x61\x6e\x64\x20\x6c\x69\x6e\x65\x20\x63\x61\x6e\x6e\x6f\x74\x20\x62\x65\x20\x6c\x6f\x6e\x67\x65\x72\x20\x74\x68\x61\x6e\x20"
.$GLOBAL::commandBufferLimit)."\x20\x63\x68\x61\x72\x61\x63\x74\x65\x72\x73\x2e"
));Logger::warning ($warning);(my ($reg_exp,$message)=get_msg (
"\x65\x54\x6f\x6f\x4c\x6f\x6e\x67\x43\x6f\x6d\x6d\x61\x6e\x64",
"\x4e\x58\x4d\x73\x67",$GLOBAL::commandBufferLimit));if ((main::nxwrite (
main::nxgetSTDOUT (),$message)==(-(0x136c+ 3430-0x20d1)))){
NXShell::setExitRequest ($ExitRequests::closedSTDOUT);}}(my $readBytes=
main::nxread (main::nxgetSTDIN (),(\$readBuff),(0x1403+ 4663-0x163a)));if ((not 
(defined ($readBytes)))){(my $errorstring=libnxh::NXGetErrorString ());if ((
main::nxwrite (main::nxgetSTDOUT (),"\x0a")==(-(0x0f52+ 3321-0x1c4a)))){
NXShell::setExitRequest ($ExitRequests::closedSTDOUT);}NXShell::setExitRequest (
((
"\x46\x61\x69\x6c\x65\x64\x20\x72\x65\x61\x64\x20\x66\x72\x6f\x6d\x20\x73\x74\x64\x69\x6e\x3a\x20"
.$errorstring)."\x2e"));($$refParameters{"\x64\x61\x74\x61"}=());$self->
removeHandle ($$handleHash{"\x48\x61\x6e\x64\x6c\x65"});$self->setExit (
$handleHash,(0x05b9+ 6103-0x1d90),(0x132c+ 1639-0x1993));return (());}if ((
$readBytes==(0x0904+ 6920-0x240c))){if ((main::nxwrite (main::nxgetSTDOUT (),
"\x0a")==(-(0x053d+ 5348-0x1a20)))){NXShell::setExitRequest (
$ExitRequests::closedSTDOUT);}NXShell::setExitRequest (
$ExitRequests::closedSTDIN);($$refParameters{"\x64\x61\x74\x61"}=());$self->
removeHandle ($$handleHash{"\x48\x61\x6e\x64\x6c\x65"});$self->setExit (
$handleHash,(0x12a9+ 3983-0x2238),(0x1026+ 4799-0x22e5));return (());}if ((
$readBuff=~ /\n$/ )){($readBuff=~ s/\r?\n$// );($GLOBAL::NXMsg::__inBuffer.=
$readBuff);(($$refParameters{
"\x69\x67\x6e\x6f\x72\x65\x55\x6e\x74\x69\x6c\x65\x45\x4f\x4c"}eq 
(0x05aa+ 5379-0x1aac))and ($$refParameters{
"\x69\x67\x6e\x6f\x72\x65\x55\x6e\x74\x69\x6c\x65\x45\x4f\x4c"}=
(0x08d7+ 1366-0x0e2d)));($$refParameters{"\x64\x61\x74\x61"}=
$GLOBAL::NXMsg::__inBuffer);($$refParameters{
"\x65\x6e\x64\x4f\x66\x4c\x69\x6e\x65"}=(0x002c+ 2391-0x0982));(
$GLOBAL::NXMsg::__inBuffer=(""));$self->removeHandle ($$handleHash{
"\x48\x61\x6e\x64\x6c\x65"});$self->setExit ($handleHash,(0x004d+ 4045-0x101a),
(0x18e5+ 271-0x19f4));return (());}else{if (($$refParameters{
"\x69\x67\x6e\x6f\x72\x65\x55\x6e\x74\x69\x6c\x65\x45\x4f\x4c"}eq 
(0x01b1+ 9270-0x25e7))){($GLOBAL::NXMsg::__inBuffer.=$readBuff);}}}else{$self->
removeHandle ($$handleHash{"\x48\x61\x6e\x64\x6c\x65"});$self->setExit (
$handleHash,(0x1d16+ 964-0x20da),(0x027d+ 8251-0x22b8));}}sub setSilentMode{(
$__silentMode=(0x0034+ 6914-0x1b35));}sub offSilentMode{($__silentMode=
(0x0c78+ 3963-0x1bf3));}sub isSilentMode{if (($__silentMode==
(0x07df+ 4487-0x1965))){return ((0x048f+ 4473-0x1607));}return (
(0x05b6+ 2389-0x0f0b));}sub setSendEOLAfterSendRequest{($__eolAfterRequest=
(0x1e25+  24-0x1e3c));}sub sendEOL{if (($__eolAfterRequest==(0x1443+ 114-0x14b4)
)){return ((0x1673+ 1494-0x1c48));}return ((0x0042+ 6420-0x1956));}sub 
clearDataParameter{($parameters{"\x64\x61\x74\x61"}=(""));}sub blindInput{if ((
not (Server::isConnectedToConsole ()))){Logger::debug (
"\x4e\x58\x4d\x73\x67\x3a\x20\x57\x65\x20\x61\x72\x65\x20\x6e\x6f\x74\x20\x63\x6f\x6e\x6e\x65\x63\x74\x65\x64\x20\x74\x6f\x20\x63\x6f\x6e\x73\x6f\x6c\x65\x2e"
);return ((0x07a1+ 2066-0x0fb3));}Common::NXCore::disableConsoleEchoMode ();}sub
 showInput{if ((not (Server::isConnectedToConsole ()))){Logger::debug (
"\x4e\x58\x4d\x73\x67\x3a\x20\x57\x65\x20\x61\x72\x65\x20\x6e\x6f\x74\x20\x63\x6f\x6e\x6e\x65\x63\x74\x65\x64\x20\x74\x6f\x20\x63\x6f\x6e\x73\x6f\x6c\x65\x2e"
);return ((0x0009+ 8164-0x1fed));}Common::NXCore::enableConsoleEchoMode ();}sub 
getIndexStringByMessage{(my $message=shift (@_));(my $messageId=(-
(0x0268+ 744-0x054f)));if (($message=~ /NX> (\d+) / )){($messageId=$1);}
removeMessageHeader ((\$message));if (($messageId==
$GLOBAL::BRAND_MESSAGE_LICENSE_NOT_FOUND)){return (
"\x77\x42\x72\x61\x6e\x64\x4d\x65\x73\x73\x61\x67\x65\x4c\x69\x63\x65\x6e\x63\x65\x4e\x6f\x74\x46\x6f\x75\x6e\x64"
);}elsif (($messageId==$GLOBAL::BRAND_MESSAGE_LICENSE_NOT_VALID)){return (
"\x77\x42\x72\x61\x6e\x64\x4d\x65\x73\x73\x61\x67\x65\x4c\x69\x63\x65\x6e\x63\x65\x4e\x6f\x74\x56\x61\x6c\x69\x64"
);}elsif (($messageId==$GLOBAL::BRAND_MESSAGE_LICENSE_EXPIRED)){return (
"\x77\x42\x72\x61\x6e\x64\x4d\x65\x73\x73\x61\x67\x65\x4c\x69\x63\x65\x6e\x63\x65\x45\x78\x70\x69\x72\x65\x64"
);}elsif (($messageId==$GLOBAL::BRAND_MESSAGE_LICENSE_PRODUCT_NOT_MATCH)){return
 (
"\x77\x42\x72\x61\x6e\x64\x4d\x65\x73\x73\x61\x67\x65\x4c\x69\x63\x65\x6e\x63\x65\x50\x72\x6f\x64\x75\x63\x74\x4e\x6f\x74\x4d\x61\x74\x63\x68"
);}elsif (($messageId==$GLOBAL::BRAND_MESSAGE_NEED_UPDATE)){return (
"\x77\x42\x72\x61\x6e\x64\x4d\x65\x73\x73\x61\x67\x65\x4e\x65\x65\x64\x55\x70\x64\x61\x74\x65"
);}elsif (($messageId==$GLOBAL::BRAND_MESSAGE_GENERIC_SUPPORT)){return (
"\x77\x42\x72\x61\x6e\x64\x4d\x65\x73\x73\x61\x67\x65\x47\x65\x6e\x65\x72\x69\x63\x53\x75\x70\x70\x6f\x72\x74"
);}elsif (($messageId==$GLOBAL::BRAND_MESSAGE_LICENSE_PLATFORM_NOT_MATCH)){
return (
"\x77\x42\x72\x61\x6e\x64\x4d\x65\x73\x73\x61\x67\x65\x4c\x69\x63\x65\x6e\x63\x65\x50\x6c\x61\x74\x66\x6f\x72\x6d\x4e\x6f\x74\x4d\x61\x74\x63\x68"
);}elsif (($messageId==$GLOBAL::BRAND_MESSAGE_EVALUATION_EXPIRED)){return (
"\x77\x42\x72\x61\x6e\x64\x4d\x65\x73\x73\x61\x67\x65\x45\x76\x61\x6c\x75\x61\x74\x69\x6f\x6e\x45\x78\x70\x69\x72\x65\x64"
);}elsif (($messageId==$GLOBAL::BRAND_MESSAGE_DATE_NOT_VALID)){return (
"\x77\x42\x72\x61\x6e\x64\x4d\x65\x73\x73\x61\x67\x65\x44\x61\x74\x65\x4e\x6f\x74\x56\x61\x6c\x69\x64"
);}elsif (($messageId==$GLOBAL::BRAND_MESSAGE_EXPIRY_NOT_VALID)){return (
"\x77\x42\x72\x61\x6e\x64\x4d\x65\x73\x73\x61\x67\x65\x45\x78\x70\x69\x72\x79\x4e\x6f\x74\x56\x61\x6c\x69\x64"
);}elsif (($messageId==$GLOBAL::BRAND_MESSAGE_LICENSE_UNSUBSCRIBED)){return (
"\x77\x42\x72\x61\x6e\x64\x4d\x65\x73\x73\x61\x67\x65\x4c\x69\x63\x65\x6e\x63\x65\x55\x6e\x73\x75\x62\x73\x63\x72\x69\x62\x65\x64"
);}elsif (($messageId==$GLOBAL::BRAND_MESSAGE_UPGRADE_EXPIRED)){return (
"\x77\x42\x72\x61\x6e\x64\x4d\x65\x73\x73\x61\x67\x65\x55\x70\x67\x72\x61\x64\x65\x45\x78\x70\x69\x72\x65\x64"
);}elsif (($messageId==$GLOBAL::BRAND_MESSAGE_NODE_LICENSE_NOT_FOUND)){return (
"\x77\x42\x72\x61\x6e\x64\x4d\x65\x73\x73\x61\x67\x65\x4e\x6f\x64\x65\x4c\x69\x63\x65\x6e\x63\x65\x4e\x6f\x74\x46\x6f\x75\x6e\x64"
);}elsif (($messageId==$GLOBAL::BRAND_MESSAGE_NODE_LICENSE_PRODUCT_NOT_MATCH)){
return (
"\x77\x42\x72\x61\x6e\x64\x4d\x65\x73\x73\x61\x67\x65\x4e\x6f\x64\x65\x4c\x69\x63\x65\x6e\x63\x65\x50\x72\x6f\x64\x75\x63\x74\x4e\x6f\x74\x4d\x61\x74\x63\x68"
);}elsif (($messageId==$GLOBAL::BRAND_MESSAGE_NODE_LICENSE_TYPE_NOT_MATCH)){
return (
"\x77\x42\x72\x61\x6e\x64\x4d\x65\x73\x73\x61\x67\x65\x4e\x6f\x64\x65\x4c\x69\x63\x65\x6e\x63\x65\x54\x79\x70\x65\x4e\x6f\x74\x4d\x61\x74\x63\x68"
);}elsif (($messageId==
$GLOBAL::BRAND_MESSAGE_EVALUATION_UPGRADE_FROM_3_TO_4_NOT_POSSIBLE)){return (
"\x77\x42\x72\x61\x6e\x64\x4d\x65\x73\x73\x61\x67\x65\x45\x76\x61\x6c\x75\x61\x74\x69\x6f\x6e\x55\x70\x67\x72\x61\x64\x65\x46\x72\x6f\x6d\x33\x54\x6f\x34\x4e\x6f\x74\x50\x6f\x73\x73\x69\x62\x6c\x65"
);}elsif (($messageId==$GLOBAL::MSG_ERROR_NOT_ENOUGH_X_RESOURCES)){return (
"\x65\x4e\x6f\x46\x72\x65\x65\x44\x69\x73\x70\x6c\x61\x79");}elsif (($messageId
==$GLOBAL::MSG_ERROR_REACHED_SESSION_LIMIT)){if ((index ($message,getEnglishText
 (
"\x65\x47\x55\x49\x4d\x61\x78\x69\x6d\x75\x6d\x4e\x75\x6d\x62\x65\x72\x56\x69\x72\x74\x75\x61\x6c\x53\x65\x73\x73\x69\x6f\x6e\x73"
))!=(-(0x0bd5+ 3894-0x1b0a)))){return (
"\x65\x47\x55\x49\x4d\x61\x78\x69\x6d\x75\x6d\x4e\x75\x6d\x62\x65\x72\x56\x69\x72\x74\x75\x61\x6c\x53\x65\x73\x73\x69\x6f\x6e\x73"
);}elsif ((index ($message,getEnglishText (
"\x65\x4d\x61\x78\x69\x6d\x75\x6d\x4e\x75\x6d\x62\x65\x72\x53\x65\x73\x73\x69\x6f\x6e\x73"
))!=(-(0x0992+ 1721-0x104a)))){return (
"\x65\x4d\x61\x78\x69\x6d\x75\x6d\x4e\x75\x6d\x62\x65\x72\x53\x65\x73\x73\x69\x6f\x6e\x73"
);}elsif ((index ($message,getEnglishText (
"\x65\x4d\x61\x78\x69\x6d\x75\x6d\x47\x75\x65\x73\x74\x73\x4e\x75\x6d\x62\x65\x72"
))!=(-(0x013c+ 9012-0x246f)))){return (
"\x65\x4d\x61\x78\x69\x6d\x75\x6d\x47\x75\x65\x73\x74\x73\x4e\x75\x6d\x62\x65\x72"
);}}elsif ((index ($message,getEnglishText (
"\x65\x50\x75\x62\x6c\x69\x63\x4b\x65\x79\x4e\x6f\x74\x46\x6f\x75\x6e\x64"))!=(-
(0x105d+ 3842-0x1f5e)))){return (
"\x65\x50\x75\x62\x6c\x69\x63\x4b\x65\x79\x4e\x6f\x74\x46\x6f\x75\x6e\x64");}
return ((""));}sub removeMessageHeader{(my $ref_message=shift (@_));(
$$ref_message=~ s/NX> \d+ ERROR: //gm );($$ref_message=~ s/NX> \d+ WARNING: //gm )
;($$ref_message=~ s/NX> \d+ //gm );}sub isMessageRegistered{(my $index=shift (@_
));if (Common::NXMsg::isMessageRegistered ($index)){return ((0x0e51+ 240-0x0f40)
);}return ((0x02b1+ 4811-0x157c));}sub getMessageNumber{return (
Common::NXMsg::getNumber (@_));}sub shouldPackMessage{(my $messageNumber=shift (
@_));if ((Common::NXMsg::isErrorMessageNumber ($messageNumber)and 
Server::isClientSupportsPackedMessages ())){return ((0x0734+ 268-0x083f));}
return ((0x05c9+ 2654-0x1027));}sub errorDependsOnClientType{(my $message=shift 
(@_));(my (@params)=shift (@_));if (Server::isClientNxclient ()){($message=~ s/^eCMD/eGUI/ )
;}error ($message,"\x4e\x58\x4d\x73\x67",@params);}register_error (
"\x4e\x58\x4d\x73\x67",
"\x65\x54\x6f\x6f\x4c\x6f\x6e\x67\x43\x6f\x6d\x6d\x61\x6e\x64",
(0x1440+ 2312-0x1af2));return ((0x0fdf+ 3876-0x1f02));
