############################################################################
#                                                                          #
#  Copyright (c) 2001, 2024 NoMachine, http://www.nomachine.com.           #
#                                                                          #
#  NXNODE, NX protocol compression and NX extensions to this software      #
#  are copyright of NoMachine. Redistribution and use of the present       #
#  software is allowed according to terms specified in the file LICENSE    #
#  which comes in the source distribution.                                 #
#                                                                          #
#  Check http://www.nomachine.com/licensing.html for applicability.        #
#                                                                          #
#  NX and NoMachine are trademarks of NoMachine S.a.r.l.                   #
#                                                                          #
#  All rights reserved.                                                    #
#                                                                          #
############################################################################
package NXPingMonitor;no warnings;(my $__pingTime=(0x0e33+ 3942-0x1d99));(my $__pongTime
=(0x04f0+ 4133-0x1515));(my $__interval=(0x1d55+ 2036-0x2549));(my $__timeout=
(0x09fa+ 5333-0x1ecf));(my $__errorTimeout=(0x2458+ 423-0x25ff));sub initialize{
__setTimeBetweenPings ();__setTimeoutForPingResponse ();__sendPing ();}sub 
__setTimeBetweenPings{($__interval=(0x0549+ 2388-0x0e7f));Logger::debug (((
"\x4e\x58\x50\x69\x6e\x67\x4d\x6f\x6e\x69\x74\x6f\x72\x3a\x20\x54\x69\x6d\x65\x20\x62\x65\x74\x77\x65\x65\x6e\x20\x70\x69\x6e\x67\x73\x20\x74\x6f\x20\x74\x68\x65\x20\x73\x65\x72\x76\x65\x72\x3a\x20"
.$__interval)."\x2e"));}sub __setTimeoutForPingResponse{if ((not ((
$GLOBAL::NodeConnectionTimeout=~ /\d+/ )))){Logger::warning (
"\x4e\x58\x50\x69\x6e\x67\x4d\x6f\x6e\x69\x74\x6f\x72\x3a\x20\x49\x6e\x76\x61\x6c\x69\x64\x20\x76\x61\x6c\x75\x65\x20\x66\x6f\x72\x20\x74\x68\x65\x20\x4e\x6f\x64\x65\x43\x6f\x6e\x6e\x65\x63\x74\x69\x6f\x6e\x54\x69\x6d\x65\x6f\x75\x74\x20\x6b\x65\x79\x2e\x20\x55\x73\x69\x6e\x67\x20\x64\x65\x66\x61\x75\x6c\x74\x2e"
);($GLOBAL::NodeConnectionTimeout=(0x059f+ 453-0x06ec));}($__timeout=
$GLOBAL::NodeConnectionTimeout);Logger::debug (((
"\x4e\x58\x50\x69\x6e\x67\x4d\x6f\x6e\x69\x74\x6f\x72\x3a\x20\x54\x69\x6d\x65\x6f\x75\x74\x20\x66\x6f\x72\x20\x70\x69\x6e\x67\x20\x72\x65\x73\x70\x6f\x6e\x73\x65\x3a\x20"
.$__timeout)."\x2e"));}sub checkTimesAndSendPingIfNecessary{if ((__isPingEnabled
 ()==(0x1682+ 3007-0x2241))){return;}if ((__isTimeoutForPingRespose ()==
(0x0ebd+ 1888-0x161c))){if ((__isErrorServerDidNotReply ()==
(0x0a22+ 5819-0x20dc))){Logger::error (((
"\x53\x65\x72\x76\x65\x72\x20\x64\x69\x64\x20\x6e\x6f\x74\x20\x72\x65\x70\x6c\x79\x20\x73\x69\x6e\x63\x65\x20"
.$__timeout).
"\x20\x73\x65\x63\x6f\x6e\x64\x73\x2e\x20\x54\x65\x72\x6d\x69\x6e\x61\x74\x69\x6e\x67\x20\x73\x65\x73\x73\x69\x6f\x6e\x2e"
));NXSessionMonitor::__setSessionStatus ($NXSessionMonitor::statusError,((
"\x4c\x6f\x73\x74\x20\x63\x6f\x6e\x6e\x65\x63\x74\x69\x6f\x6e\x20\x74\x6f\x20\x4e\x58\x20\x73\x65\x72\x76\x65\x72\x3a\x20\x6e\x6f\x20\x72\x65\x70\x6c\x69\x65\x73\x20\x69\x6e\x20"
.$__timeout)."\x20\x73\x65\x63\x6f\x6e\x64\x73\x2e"));return;}
__setErrorServerDidNotReply ();Logger::warning (((
"\x53\x65\x72\x76\x65\x72\x20\x64\x69\x64\x20\x6e\x6f\x74\x20\x72\x65\x70\x6c\x79\x20\x73\x69\x6e\x63\x65\x20"
.$__timeout)."\x20\x73\x65\x63\x6f\x6e\x64\x73\x2e"));__sendPing ();return;}if (
(__isPingTime ()==(0x0b31+ 4377-0x1c49))){__sendPing ();return;}}sub handlePong{
Logger::debug (
"\x52\x65\x63\x65\x69\x76\x65\x64\x20\x70\x6f\x6e\x67\x20\x6d\x65\x73\x73\x61\x67\x65\x2e"
);__clearErrorServerDidNotReply ();__setPongTime ();__resetPingTime ();}sub 
handleRequestForPingMessage{Logger::debug (
"\x52\x65\x63\x65\x69\x76\x65\x64\x20\x72\x65\x71\x75\x65\x73\x74\x20\x66\x6f\x72\x20\x73\x65\x6e\x64\x20\x70\x69\x6e\x67\x20\x74\x6f\x20\x74\x68\x65\x20\x73\x65\x72\x76\x65\x72\x2e"
);__sendPing ();}sub __sendPing{Logger::debug (
"\x53\x65\x6e\x64\x69\x6e\x67\x20\x70\x69\x6e\x67\x20\x6d\x65\x73\x73\x61\x67\x65\x2e"
);(my $message=(((("\x4e\x58\x3e\x20".$GLOBAL::MSG_NODE_PING)."\x20").
$GLOBAL::MESSAGES_FORMAT{$GLOBAL::MSG_NODE_PING})."\x0a"));(my $bytes=
main::nxwrite (main::nxgetSTDOUT (),$message));if (($bytes==(-
(0x17fa+ 235-0x18e4)))){NXSessionMonitor::__setSessionStatus (
$NXSessionMonitor::statusError,
"\x4c\x6f\x73\x74\x20\x63\x6f\x6e\x6e\x65\x63\x74\x69\x6f\x6e\x20\x74\x6f\x20\x4e\x58\x20\x73\x65\x72\x76\x65\x72\x2e\x20\x43\x61\x6e\x6e\x6f\x74\x20\x73\x65\x6e\x64\x20\x70\x69\x6e\x67\x20\x6d\x65\x73\x73\x61\x67\x65\x20\x74\x6f\x20\x73\x65\x72\x76\x65\x72\x2e"
);return;}__resetPongTime ();__setPingTime ();}sub __isPingEnabled{if ((
$__timeout==(0x00b8+ 5600-0x1698))){return ((0x0124+ 6196-0x1958));}return (
(0x0239+ 8814-0x24a6));}sub __setPingTime{($__pingTime=
Common::NXTime::getSecondsSinceEpoch ());}sub __resetPingTime{($__pingTime=
(0x05e1+ 3057-0x11d2));}sub __isPingTime{if (($__pongTime==(0x0731+ 905-0x0aba))
){return ((0x1295+ 2387-0x1be8));}(my $time=Common::NXTime::getSecondsSinceEpoch
 ());if (($time>=($__pongTime+$__interval))){return ((0x1961+ 2786-0x2442));}
return ((0x00ec+ 8515-0x222f));}sub __isTimeoutForPingRespose{if (($__pingTime==
(0x1db3+ 2085-0x25d8))){return ((0x142b+ 2419-0x1d9e));}(my $time=
Common::NXTime::getSecondsSinceEpoch ());if (($__pingTime>$time)){($__pingTime=
Common::NXTime::getSecondsSinceEpoch ());}if (($time>=($__pingTime+$__timeout)))
{return ((0x0600+ 1767-0x0ce6));}return ((0x08e3+ 2988-0x148f));}sub 
__setErrorServerDidNotReply{($__errorTimeout=(0x1bc1+ 2495-0x257f));}sub 
__isErrorServerDidNotReply{return ($__errorTimeout);}sub 
__clearErrorServerDidNotReply{($__errorTimeout=(0x1ffb+ 549-0x2220));}sub 
__setPongTime{($__pongTime=Common::NXTime::getSecondsSinceEpoch ());}sub 
__resetPongTime{($__pongTime=(0x0990+ 3170-0x15f2));}return (
(0x0085+ 558-0x02b2));
