############################################################################
#                                                                          #
#  Copyright (c) 2001, 2024 NoMachine, http://www.nomachine.com.           #
#                                                                          #
#  NXSERVER, NX protocol compression and NX extensions to this software    #
#  are copyright of NoMachine. Redistribution and use of the present       #
#  software is allowed according to terms specified in the file LICENSE    #
#  which comes in the source distribution.                                 #
#                                                                          #
#  Check http://www.nomachine.com/licensing.html for applicability.        #
#                                                                          #
#  NX and NoMachine are trademarks of NoMachine S.a.r.l.                   #
#                                                                          #
#  All rights reserved.                                                    #
#                                                                          #
############################################################################
sub NXStartup::BEGIN{package NXStartup;no warnings;require NXMsg;do{
"\x4e\x58\x4d\x73\x67"->import};}sub NXStartup::BEGIN{package NXStartup;no 
warnings;require NXRedis;do{"\x4e\x58\x52\x65\x64\x69\x73"->import};}sub 
NXStartup::BEGIN{package NXStartup;no warnings;require NXCluster;do{
"\x4e\x58\x43\x6c\x75\x73\x74\x65\x72"->import};}sub NXStartup::BEGIN{package 
NXStartup;no warnings;require Common::NXInfo;do{
"\x43\x6f\x6d\x6d\x6f\x6e\x3a\x3a\x4e\x58\x49\x6e\x66\x6f"->import};}package 
NXStartup;no warnings;require NXSystemDaemons;my (%__wasRunning);sub BEGIN{
require Error;do{"\x45\x72\x72\x6f\x72"->import ("\x3a\x74\x72\x79")};}sub 
handleStartup{if (Server::isDaemonProcess ()){handleStartupDaemon ();
main::nxexit ((0x107d+ 3397-0x1dc2));}(my $isPossible=
libnxh::NXIsHostAddressResolvePossible ("\x6c\x6f\x63\x61\x6c\x68\x6f\x73\x74"))
;if (($isPossible!=(0x00c7+ 2064-0x08d6))){Logger::error (
"\x43\x61\x6e\x6e\x6f\x74\x20\x72\x65\x73\x6f\x6c\x76\x65\x20\x27\x6c\x6f\x63\x61\x6c\x68\x6f\x73\x74\x27\x2e\x20\x50\x6c\x65\x61\x73\x65\x20\x63\x68\x65\x63\x6b\x20\x73\x65\x74\x74\x69\x6e\x67\x73\x20\x69\x6e\x20\x74\x68\x65\x20\x73\x79\x73\x74\x65\x6d\x20\x68\x6f\x73\x74\x73\x20\x66\x69\x6c\x65\x20\x6f\x72\x20\x63\x6f\x6e\x74\x61\x63\x74\x20\x79\x6f\x75\x72\x20\x73\x79\x73\x74\x65\x6d\x20\x61\x64\x6d\x69\x6e\x69\x73\x74\x72\x61\x74\x6f\x72\x2e"
);NXMsg::error (
"\x65\x43\x4d\x44\x43\x61\x6e\x6e\x6f\x74\x53\x74\x61\x72\x74\x4e\x6f\x4d\x61\x63\x68\x69\x6e\x65\x53\x65\x72\x76\x65\x72\x52\x65\x73\x6f\x6c\x76\x65\x6c\x6f\x63\x61\x6c\x68\x6f\x73\x74\x4e\x6f\x74\x50\x6f\x73\x73\x69\x62\x6c\x65"
,"\x4e\x58\x53\x74\x61\x72\x74\x75\x70");return;}main::nxrequire (
"\x4e\x58\x45\x47\x4c\x43\x61\x70\x74\x75\x72\x65");NXEGLCapture::processScripts
 ();(my $servicesToCheck=initializeStartup ());NXRedis::closeDb ();if ((
startNXServerDaemon ()==(0x0ebc+ 3137-0x1afc))){Logger::error (
"\x43\x61\x6e\x6e\x6f\x74\x20\x73\x74\x61\x72\x74\x20\x6e\x78\x73\x65\x72\x76\x65\x72\x20\x2d\x2d\x64\x61\x65\x6d\x6f\x6e\x20\x70\x72\x6f\x63\x65\x73\x73\x2e"
);__checkServicesWithoutNXServerDaemon ();return ((0x1753+ 3030-0x2329));}if ((
waitForDaemonReady ()==(0x09ef+ 4152-0x1a26))){Logger::warning (
"\x6e\x78\x73\x65\x72\x76\x65\x72\x20\x2d\x2d\x64\x65\x61\x6d\x6f\x6e\x20\x69\x73\x20\x6e\x6f\x74\x20\x72\x65\x61\x64\x79\x2e"
);__checkServicesWithoutNXServerDaemon ();return ((0x0d57+ 5070-0x2125));}my (
$response);if ((Server::isCurrentServerDeamonStartedBySystemd ()or 
Server::isCurrentServerDeamonStartedByService ())){($response=
NXSystemDaemons::askServerDaemonForServiceStatus ($servicesToCheck));}else{(
$response=NXSystemDaemons::askServerDaemonForServiceStatusAndRunServicesIfNeeded
 ($servicesToCheck));}if (defined ($response)){NXMsg::info (
"\x69\x43\x4d\x44\x43\x6f\x6e\x6e\x65\x63\x74\x69\x6f\x6e\x73\x53\x74\x61\x74\x75\x73"
,"\x4e\x58\x53\x79\x73\x74\x65\x6d\x44\x61\x65\x6d\x6f\x6e\x73",
"\x65\x6e\x61\x62\x6c\x65\x64");NXSystemDaemons::printServiceStatusByReply (
$response,"\x73\x74\x61\x72\x74\x75\x70");}else{Logger::warning (
"\x43\x61\x6e\x6e\x6f\x74\x20\x65\x73\x74\x61\x62\x6c\x69\x73\x68\x20\x63\x6f\x6d\x6d\x75\x6e\x69\x63\x61\x74\x69\x6f\x6e\x20\x77\x69\x74\x68\x20\x6e\x78\x73\x65\x72\x76\x65\x72\x20\x2d\x2d\x64\x65\x61\x6d\x6f\x6e\x2e"
);__checkServicesWithoutNXServerDaemon ();return ((0x06ef+ 1720-0x0da7));}}sub 
handleStartupDaemon{if (NXLicense::isKillingLeftoverCMonStarup ()){
NXSession2::killAllRunningCM ();}NXSession2::cleanSessionsWithMyPid ();
NXServerDaemon::initializeDaemon ();if ((NXSystemDaemons::removeShutdownFlag ()
==(0x0633+ 2883-0x1175))){Logger::error (
"\x43\x61\x6e\x6e\x6f\x74\x20\x72\x65\x6d\x6f\x76\x65\x20\x73\x68\x75\x74\x64\x6f\x77\x6e\x20\x66\x6c\x61\x67\x2e"
);return ((0x1e13+  72-0x1e5b));}removeServicesStopFlags ();
main::setSSHStatusStart ();NXUpdate::killUpdateIfPidFileExists ();
initializeNXUdp ();if (Server::startupNeedPerformAdministrativeTasks ()){
setFirewallRules ();}if (NXLicense::isHttpdSupportFeature ()){
NXSystemDaemons::stopServiceIfRunningWithoutNXServerDaemon (
"\x6e\x78\x68\x74\x64");}(my $isPossible=libnxh::NXIsHostAddressResolvePossible 
("\x6c\x6f\x63\x61\x6c\x68\x6f\x73\x74"));if (($isPossible!=(0x194a+ 366-0x1ab7)
)){Logger::error (
"\x43\x61\x6e\x6e\x6f\x74\x20\x72\x65\x73\x6f\x6c\x76\x65\x20\x27\x6c\x6f\x63\x61\x6c\x68\x6f\x73\x74\x27\x2e\x20\x50\x6c\x65\x61\x73\x65\x20\x63\x68\x65\x63\x6b\x20\x73\x65\x74\x74\x69\x6e\x67\x73\x20\x69\x6e\x20\x74\x68\x65\x20\x73\x79\x73\x74\x65\x6d\x20\x68\x6f\x73\x74\x73\x20\x66\x69\x6c\x65\x20\x6f\x72\x20\x63\x6f\x6e\x74\x61\x63\x74\x20\x79\x6f\x75\x72\x20\x73\x79\x73\x74\x65\x6d\x20\x61\x64\x6d\x69\x6e\x69\x73\x74\x72\x61\x74\x6f\x72\x2e"
);main::nxexit ((0x00d1+ 6944-0x1bf1));}NXServerDaemon::runDaemon ();}sub 
__checkServicesWithoutNXServerDaemon{NXMsg::info (
"\x69\x53\x65\x72\x76\x69\x63\x65\x44\x69\x73\x61\x62\x6c\x65\x64",
"\x4e\x58\x53\x79\x73\x74\x65\x6d\x44\x61\x65\x6d\x6f\x6e\x73",
"\x6e\x78\x73\x65\x72\x76\x65\x72");NXSystemDaemons::printStatus (
"\x6e\x78\x6e\x6f\x64\x65");if (NXSystemDaemons::isNxdStartupKeyEnabled ()){
NXSystemDaemons::printStatus ("\x6e\x78\x64");}if ((
NXSystemDaemons::isServiceEnabled ("\x6e\x78\x68\x74\x64")and 
NXSystemDaemons::isHttpdStartupKeyEnabled ())){NXSystemDaemons::printStatus (
"\x6e\x78\x68\x74\x64");}}sub checkFixesAfterUpdate{(my $parameter=shift (@_));
if (($parameter ne "\x6d\x6f\x6e\x69\x74\x6f\x72")){
NXSystemDaemons::fixHttpdAfterUpdate ();NXSystemDaemons::fixNXpamAfterUpdate ();
NXSystemDaemons::fixUuidFile ();}}sub checkObfuscation{Logger::debug2 (
"\x42\x65\x67\x69\x6e\x69\x6e\x67\x20\x76\x65\x72\x69\x66\x69\x63\x61\x74\x69\x6f\x6e\x20\x6f\x66\x20\x6f\x62\x66\x75\x73\x63\x61\x74\x69\x6f\x6e\x2e"
);if ((libnxhs::NXPerlDirectoryObfuscation (($GLOBAL::NODE_ROOT.
"\x2f\x6c\x69\x62\x2f\x70\x65\x72\x6c\x2f\x6e\x78\x73\x65\x72\x76\x65\x72\x2f"))
!=(0x03bb+ 2751-0x0e79))){Logger::error (
"\x53\x65\x72\x76\x65\x72\x20\x63\x6f\x64\x65\x20\x69\x73\x6e\x27\x74\x20\x6f\x62\x66\x75\x73\x63\x61\x74\x65\x64\x2e"
);NXMsg::send_response (
"\x65\x53\x65\x72\x76\x65\x72\x4f\x62\x66\x75\x73\x63\x61\x74\x69\x6f\x6e\x45\x72\x72\x6f\x72"
,"\x4e\x58\x53\x74\x61\x72\x74\x75\x70");exit ((0x1293+ 2120-0x1adb));}if ((
libnxhs::NXPerlDirectoryObfuscation (($GLOBAL::NODE_ROOT.
"\x2f\x6c\x69\x62\x2f\x70\x65\x72\x6c\x2f\x6e\x78\x6e\x6f\x64\x65\x2f"))!=
(0x0227+ 440-0x03de))){Logger::error (
"\x4e\x6f\x64\x65\x20\x63\x6f\x64\x65\x20\x69\x73\x6e\x27\x74\x20\x6f\x62\x66\x75\x73\x63\x61\x74\x65\x64\x2e"
);NXMsg::send_response (
"\x65\x4e\x6f\x64\x65\x4f\x62\x66\x75\x73\x63\x61\x74\x69\x6f\x6e\x45\x72\x72\x6f\x72"
,"\x4e\x58\x53\x74\x61\x72\x74\x75\x70");exit ((0x1631+ 380-0x17ad));}
Logger::debug2 (
"\x46\x69\x6e\x69\x73\x68\x65\x64\x20\x76\x65\x72\x69\x66\x69\x63\x61\x74\x69\x6f\x6e\x20\x6f\x66\x20\x6f\x62\x66\x75\x73\x63\x61\x74\x69\x6f\x6e\x2e"
);}sub setLogFilesPermission{if (($ENV{"\x4e\x58\x5f\x51\x55\x49\x43\x4b"}eq 
"\x31")){return ((0x179b+ 2981-0x2340));}
Common::NXFile::setServerLogFilePermissions ();}sub delWebInfoFilesLeftover{if (
main::effectiveUserIsAdministrator ()){if (
NXSystemDaemons::isHttpdEnabledInLicenceAndConfig ()){main::nxrequire (
"\x4e\x58\x57\x65\x62\x49\x6e\x66\x6f\x46\x69\x6c\x65\x73\x43\x6f\x6e\x74\x72\x6f\x6c"
);NXWebInfoFilesControl::setInfoDirectoryPermissionByAdmin ();
NXWebInfoFilesControl::deleteAllInfoFiles ();}}}sub setUpdateFilePermission{if (
main::effectiveUserIsAdministrator ()){main::nxrequire (
"\x4e\x58\x55\x70\x64\x61\x74\x65");
NXUpdate::checkAndCorrectUpdateFilePermission ();}}sub 
__setErrorLogFilePermission{(my $nxerrorFile=NXPaths::getNXErrorFile ());if (($>
eq (0x1f89+ 981-0x235e))){
Common::NXFile::setPermissionReadWriteForOwnerAndGroupWriteForAll ($nxerrorFile)
;}}sub setServerLogFilePermissionAndOwner{if ((not (Common::NXFile::isExists (
$lockFile)))){(my $nxlogFile=$GLOBAL::SystemLogFile);
Common::NXFile::setPermissionReadWriteForOwnerAndGroupWriteForAll ($nxlogFile);
Common::NXFile::setOwnershipForUserNXGroupRoot ($nxlogFile);}}sub 
checkUserNXRequirementsInPAM{(my $parameter=shift (@_));if (($parameter ne 
"\x6d\x6f\x6e\x69\x74\x6f\x72")){if ((not (__checkUserNXRequirementsInPAM ()))){
Logger::error (
"\x43\x61\x6e\x6e\x6f\x74\x20\x73\x74\x61\x72\x74\x75\x70\x20\x4e\x6f\x4d\x61\x63\x68\x69\x6e\x65\x20\x73\x65\x72\x76\x69\x63\x65\x73\x2e\x20\x50\x41\x4d\x20\x63\x6f\x6e\x66\x69\x67\x75\x72\x61\x74\x69\x6f\x6e\x20\x61\x6c\x6c\x6f\x77\x73\x20\x75\x73\x65\x72\x73\x20\x66\x72\x6f\x6d\x20\x72\x6f\x6f\x74\x2f\x77\x68\x65\x65\x6c\x20\x67\x72\x6f\x75\x70\x20\x74\x6f\x20\x61\x75\x74\x68\x65\x6e\x74\x69\x63\x61\x74\x65\x20\x77\x69\x74\x68\x6f\x75\x74\x20\x70\x61\x73\x73\x77\x6f\x72\x64"
);main::nxexit ((0x0746+ 1282-0x0c48));}}}sub __checkUserNXRequirementsInPAM{if 
((not (main::checkUserBelongsToGroupWheelOrRoot ("\x6e\x78")))){return (
(0x1503+ 3675-0x235d));}(my ($cmd_err,$cmd_out,$exit_value)=
Common::NXCore::run_setup ("\x63\x68\x65\x63\x6b\x70\x61\x6d","\x6e\x6f\x62\x67"
));if (($exit_value==(0x13fd+ 3317-0x20f2))){return ((0x07cc+ 350-0x0929));}
NXMsg::error (
"\x65\x43\x61\x6e\x6e\x6f\x74\x53\x74\x61\x72\x74\x53\x65\x72\x76\x69\x63\x65",
"\x4e\x58\x53\x74\x61\x72\x74\x75\x70","\x6e\x78\x73\x65\x72\x76\x65\x72");
return ((0x05e7+ 1313-0x0b08));}sub 
killNXHtdIfRunningWithoutNXServerDaemonOnUnix{if ((
NXSystemDaemons::isHttpdEnabledInLicenceAndConfig ()and 
NXSystemDaemons::isHttpdStartupKeyEnabled ())){
NXSystemDaemons::killNXHtdIfRunningWithoutNXServerDaemon ((0x0d6d+ 1234-0x123e))
;}}sub removeServicesStopFlags{NXSystemDaemons::removeStopFlag (
"\x6e\x78\x73\x65\x72\x76\x65\x72");if ((NXSystemDaemons::isNxdEnabled ()and 
NXSystemDaemons::isNxdStartupKeyEnabled ())){NXSystemDaemons::removeStopFlag (
"\x6e\x78\x64");}if ((NXSystemDaemons::isHttpdEnabledInLicenceAndConfig ()and 
NXSystemDaemons::isHttpdStartupKeyEnabled ())){NXSystemDaemons::removeStopFlag (
"\x6e\x78\x68\x74\x64");}}sub disableServices{if (((
Common::NXCore::getEffectiveUsername ()eq "\x6e\x78")and 
NXLogin::isAdministrator ())){(my (@command)=());(my (@parameters)=());push (
@command,$GLOBAL::CommandNXexec,$GLOBAL::SCRIPT_NXDISABLESERVICES);push (
@parameters,
"\x75\x73\x65\x20\x73\x63\x72\x69\x70\x74\x20\x74\x6f\x20\x6b\x69\x6c\x6c");
main::run_command ((\@command),(\@parameters));}else{Common::NXCore::run_setup (
"\x64\x69\x73\x61\x62\x6c\x65\x73\x65\x72\x76\x69\x63\x65\x73",
"\x6e\x6f\x62\x67");}}sub enableServices{if (((
Common::NXCore::getEffectiveUsername ()eq "\x6e\x78")and 
NXLogin::isAdministrator ())){(my (@command)=());(my (@parameters)=());push (
@command,$GLOBAL::CommandNXexec,$GLOBAL::SCRIPT_NXENABLESERVICES);push (
@parameters,
"\x75\x73\x65\x20\x73\x63\x72\x69\x70\x74\x20\x74\x6f\x20\x6b\x69\x6c\x6c");
main::run_command ((\@command),(\@parameters));}else{Common::NXCore::run_setup (
"\x65\x6e\x61\x62\x6c\x65\x73\x65\x72\x76\x69\x63\x65\x73","\x6e\x6f\x62\x67");}
}sub checkIfNetlogonServiceIsEnabled{();}sub checkIfHostnameContainNewLine{(my $hostInfo
=Common::NXInfo::getHostInfo ());if (($hostInfo=~ /\n/ )){Logger::error (
"\x4e\x6f\x4d\x61\x63\x68\x69\x6e\x65\x20\x73\x74\x61\x72\x74\x75\x70\x20\x77\x61\x73\x20\x69\x6e\x74\x65\x72\x72\x75\x70\x74\x65\x64\x2e\x20\x48\x6f\x73\x74\x6e\x61\x6d\x65\x20\x63\x61\x6e\x6e\x6f\x74\x20\x63\x6f\x6e\x74\x61\x69\x6e\x20\x61\x20\x6e\x65\x77\x20\x6c\x69\x6e\x65\x20\x63\x68\x61\x72\x61\x63\x74\x65\x72\x2e"
);NXMsg::error (
"\x65\x43\x4d\x44\x43\x61\x6e\x6e\x6f\x74\x53\x74\x61\x72\x74\x4e\x6f\x4d\x61\x63\x68\x69\x6e\x65\x48\x6f\x73\x74\x6e\x61\x6d\x65\x43\x6f\x6e\x74\x61\x69\x6e\x73\x4e\x65\x77\x4c\x69\x6e\x65"
,"\x4e\x58\x53\x74\x61\x72\x74\x75\x70");main::nxexit ((0x1ef3+ 672-0x2193));}}
sub setFirewallRules{main::nxrequire ("\x4e\x58\x46\x69\x72\x65\x77\x61\x6c\x6c"
);NXFirewall::addFirewallRules ();}sub startNXServerDaemon{if ((
NXServerDaemon::checkDaemonFlock ()==(0x0f92+ 1235-0x1465))){Logger::debug (
"\x6e\x78\x73\x65\x72\x76\x65\x72\x20\x2d\x2d\x64\x61\x65\x6d\x6f\x6e\x20\x61\x6c\x72\x65\x61\x64\x79\x20\x72\x75\x6e\x6e\x69\x6e\x67\x2e"
);return ((0x1baf+ 1044-0x1fc3));}if ((
Server::isCurrentServerDeamonStartedBySystemd ()or 
Server::isCurrentServerDeamonStartedByService ())){main::nxrequire (
"\x4e\x58\x53\x65\x72\x76\x69\x63\x65\x73\x3a\x3a\x4e\x58\x44\x61\x65\x6d\x6f\x6e"
);return (NXServices::NXDaemon::startDaemonOnLinux ());}main::nxrequire (
"\x4e\x58\x53\x65\x72\x76\x69\x63\x65\x73\x3a\x3a\x4e\x58\x44\x61\x65\x6d\x6f\x6e"
);if (NXSystemDaemons::isSystemBasedOnSystemd ()){if ((not (
NXSystemDaemons::doesRunSystemdExist ()))){Logger::error (
"\x43\x61\x6e\x6e\x6f\x74\x20\x73\x74\x61\x72\x74\x20\x4e\x6f\x4d\x61\x63\x68\x69\x6e\x65\x20\x73\x65\x72\x76\x65\x72\x2e\x20\x44\x69\x72\x65\x63\x74\x6f\x72\x79\x20\x27\x2f\x72\x75\x6e\x2f\x73\x79\x73\x74\x65\x6d\x64\x27\x20\x64\x6f\x65\x73\x6e\x27\x74\x20\x65\x78\x69\x73\x74\x20\x6f\x6e\x20\x74\x68\x65\x20\x73\x79\x73\x74\x65\x6d\x2e\x20\x50\x6c\x65\x61\x73\x65\x20\x63\x6f\x6e\x74\x61\x63\x74\x20\x79\x6f\x75\x72\x20\x73\x79\x73\x74\x65\x6d\x20\x61\x64\x6d\x69\x6e\x69\x73\x74\x72\x61\x74\x6f\x72\x2e"
);NXMsg::error (
"\x65\x43\x4d\x44\x43\x61\x6e\x6e\x6f\x74\x53\x74\x61\x72\x74\x4e\x6f\x4d\x61\x63\x68\x69\x6e\x65\x53\x65\x72\x76\x65\x72\x44\x69\x72\x52\x75\x6e\x53\x79\x73\x74\x65\x6d\x64\x4e\x6f\x74\x45\x78\x69\x73\x74"
,"\x4e\x58\x53\x74\x61\x72\x74\x75\x70");main::nxexit ((0x1528+ 3187-0x219b));}
NXServices::NXDaemon::startNXServerServiceBySystemd ();return (
(0x1a7f+ 411-0x1c1a));}elsif (NXSystemDaemons::startupRequrieUpStartSwitch ()){
if ((NXServices::NXDaemon::startNXServerServiceByUpStart ()!=
(0x0ab3+ 4464-0x1c23))){Server::resetStartupNotNeedPerformAdministrativeTasks ()
;return (NXServices::NXDaemon::startDaemonOnLinux ());}return (
(0x1904+ 1487-0x1ed3));}return (NXServices::NXDaemon::startDaemonOnLinux ());}
sub waitForDaemonReady{Logger::debug (
"\x53\x74\x61\x72\x74\x20\x77\x61\x69\x74\x69\x6e\x67\x20\x6f\x6e\x20\x6e\x78\x73\x65\x72\x76\x65\x72\x20\x2d\x2d\x64\x61\x65\x6d\x6f\x6e\x2e"
);(my $selector=
"\x43\x6f\x6d\x6d\x6f\x6e\x3a\x3a\x4e\x58\x53\x65\x6c\x65\x63\x74\x6f\x72"->new)
;(my $signalFd=$$NXBegin::parser{"\x53\x69\x67\x6e\x61\x6c"});$selector->add (
$signalFd);(local $$NXBegin::parser{"\x73\x69\x67\x62\x61\x63\x6b"}{
"\x54\x45\x52\x4d"}=sub{Logger::debug (
"\x52\x65\x63\x65\x69\x76\x65\x64\x20\x27\x53\x49\x47\x54\x45\x52\x4d\x27\x3a\x20\x65\x78\x69\x74\x2e"
);main::nxexit ((0x1620+ 1450-0x1bca));});(my $waitTime=(0x05d2+ 5518-0x1b60));(my $waitInterval
=(0x0c13+ 3147-0x17fa));(my $waitTimeout=__getTimeoutToWaitForDeamonReady ());(my $socketReady
=NXClientSystemDaemons::isSocketReady ());main::nxrequire (
"\x4e\x58\x53\x65\x72\x76\x69\x63\x65\x73\x3a\x3a\x4e\x58\x44\x61\x65\x6d\x6f\x6e"
);while (($socketReady!=(0x0772+ 7927-0x2668))){if ((
NXServices::NXDaemon::isChildProcessNotWorking ()==(0x1080+ 4372-0x2193))){
Logger::debug (
"\x43\x68\x69\x6c\x64\x20\x70\x72\x6f\x63\x65\x73\x73\x20\x6e\x78\x73\x65\x72\x76\x65\x72\x20\x2d\x2d\x64\x61\x65\x6d\x6f\x6e\x20\x69\x73\x20\x6e\x6f\x74\x20\x77\x6f\x72\x6b\x69\x6e\x67\x2c\x20\x73\x74\x6f\x70\x20\x77\x61\x69\x74\x69\x6e\x67\x2e"
);return ((0x059b+ 6903-0x2091));}Logger::debug (
"\x6e\x78\x73\x65\x72\x76\x65\x72\x20\x2d\x2d\x64\x61\x65\x6d\x6f\x6e\x20\x6e\x6f\x74\x20\x72\x65\x61\x64\x79\x2c\x20\x77\x61\x69\x74\x69\x6e\x67\x2e"
);($waitTime+=$waitInterval);if (($waitTime>$waitTimeout)){last;}$selector->
can_read ($waitInterval);($socketReady=NXClientSystemDaemons::isSocketReady ());
}if (($socketReady!=(0x09b0+ 6656-0x23af))){Logger::warning (((
"\x54\x69\x6d\x65\x6f\x75\x74\x20".$GLOBAL::TimeoutToWaitForDaemonReady).
"\x73\x20\x77\x68\x65\x6e\x20\x77\x61\x69\x74\x69\x6e\x67\x20\x66\x6f\x72\x20\x6e\x78\x73\x65\x72\x76\x65\x72\x20\x2d\x2d\x64\x61\x65\x6d\x6f\x6e\x2e"
));return ((0x1447+ 1553-0x1a57));}return ((0x0414+ 1999-0x0be3));}sub 
initializeNXUdp{main::nxrequire (
"\x4e\x58\x55\x64\x70\x43\x6f\x6e\x74\x72\x6f\x6c");NXUdpControl::init ();}sub 
__getTimeoutToWaitForDeamonReady{return (($GLOBAL::TimeoutToWaitForDaemonReady *
(0x1368+ 1294-0x148e)));}sub initializeStartup{(my $servicesToCheck=
"\x6e\x78\x73\x65\x72\x76\x65\x72\x20\x6e\x78\x6e\x6f\x64\x65\x20\x6e\x78\x64");
if (NXLicense::isHttpdSupportFeature ()){($servicesToCheck.=
"\x20\x6e\x78\x68\x74\x64");}($response=
NXSystemDaemons::askServerDaemonForServiceStatus ($servicesToCheck));if (defined
 ($response)){(my (@services)=split ( /, / ,$response,(0x0c08+ 5273-0x20a1)));
foreach my $service (@services){if (($service=~ /(.*) Enabled/ )){($__wasRunning
{$1}=(0x0f21+ 3374-0x1c4e));}}removeServicesStopFlags ();return (
$servicesToCheck);}(my (@services)=split ("\x20",$servicesToCheck,
(0x073a+ 1224-0x0c02)));foreach my $serviceName (@services){if (
NXSystemDaemons::isRunning ($serviceName)){($__wasRunning{$serviceName}=
(0x0db2+ 6413-0x26be));}}return ($servicesToCheck);}sub serviceWasRunning{(my $service
=shift (@_));if ((defined ($__wasRunning{$service})and ($__wasRunning{$service}
==(0x0d38+ 2714-0x17d1)))){return ((0x03f5+ 1870-0x0b42));}return (
(0x0b70+ 838-0x0eb6));}NXMsg::register_response (
"\x4e\x58\x53\x74\x61\x72\x74\x75\x70",
"\x65\x43\x61\x6e\x6e\x6f\x74\x46\x69\x6e\x64\x4e\x65\x74\x4c\x6f\x67\x6f\x6e\x44\x65\x70\x65\x6e\x64\x65\x6e\x63\x79"
,(0x190f+ 2155-0x20d8));NXMsg::register_response (
"\x4e\x58\x53\x74\x61\x72\x74\x75\x70",
"\x65\x43\x61\x6e\x6e\x6f\x74\x53\x74\x61\x72\x74\x53\x65\x72\x76\x69\x63\x65\x43\x61\x6e\x74\x43\x6f\x6e\x6e\x65\x63\x74\x4d\x53\x47"
,(0x1e15+ 538-0x1e3b));NXMsg::register_response (
"\x4e\x58\x53\x74\x61\x72\x74\x75\x70",
"\x65\x43\x61\x6e\x6e\x6f\x74\x53\x74\x61\x72\x74\x53\x65\x72\x76\x69\x63\x65\x41\x75\x74\x68\x46\x61\x69\x6c\x65\x64\x4d\x53\x47"
,(0x0ef8+ 5564-0x22c0));NXMsg::register_response (
"\x4e\x58\x53\x74\x61\x72\x74\x75\x70",
"\x65\x53\x65\x72\x76\x65\x72\x4f\x62\x66\x75\x73\x63\x61\x74\x69\x6f\x6e\x45\x72\x72\x6f\x72"
,(0x0f82+ 5418-0x22b8));NXMsg::register_response (
"\x4e\x58\x53\x74\x61\x72\x74\x75\x70",
"\x65\x4e\x6f\x64\x65\x4f\x62\x66\x75\x73\x63\x61\x74\x69\x6f\x6e\x45\x72\x72\x6f\x72"
,(0x0ef2+ 4121-0x1d17));NXMsg::register_error (
"\x4e\x58\x53\x74\x61\x72\x74\x75\x70",
"\x65\x43\x4d\x44\x43\x61\x6e\x6e\x6f\x74\x53\x74\x61\x72\x74\x4e\x6f\x4d\x61\x63\x68\x69\x6e\x65\x53\x65\x72\x76\x65\x72\x52\x65\x73\x6f\x6c\x76\x65\x6c\x6f\x63\x61\x6c\x68\x6f\x73\x74\x4e\x6f\x74\x50\x6f\x73\x73\x69\x62\x6c\x65"
,(0x0948+ 4429-0x18a1));NXMsg::register_error (
"\x4e\x58\x53\x74\x61\x72\x74\x75\x70",
"\x65\x43\x4d\x44\x43\x61\x6e\x6e\x6f\x74\x53\x74\x61\x72\x74\x4e\x6f\x4d\x61\x63\x68\x69\x6e\x65\x48\x6f\x73\x74\x6e\x61\x6d\x65\x43\x6f\x6e\x74\x61\x69\x6e\x73\x4e\x65\x77\x4c\x69\x6e\x65"
,(0x09e5+ 1437-0x0d8e));NXMsg::register_error (
"\x4e\x58\x53\x74\x61\x72\x74\x75\x70",
"\x65\x43\x4d\x44\x43\x61\x6e\x6e\x6f\x74\x53\x74\x61\x72\x74\x4e\x6f\x4d\x61\x63\x68\x69\x6e\x65\x53\x65\x72\x76\x65\x72\x44\x69\x72\x52\x75\x6e\x53\x79\x73\x74\x65\x6d\x64\x4e\x6f\x74\x45\x78\x69\x73\x74"
,(0x0d42+ 2236-0x140a));return ((0x06dc+ 4451-0x183e));
